//--------------------------------------------------------------------------------------------------
//Globln promnn
//--------------------------------------------------------------------------------------------------
{$IFNDEF BGTYPE}
{$I Badges.Type.pas}
{$ENDIF}
//--------------------------------------------------------------------------------------------------
type TFCompact = Record
	HTML	:	String;
	Count	:	Integer;
end;

type THTMLdata = Record
	sHtmlB			:	string;		//pomocn etzce - odznky
	sHtmlS			:	string;
	sHtmlG			:	string;
	sHtmlP			:	string;
	sHtmlR			:	string;
	sHtmlSa			:	string;
	sHtmlE			:	string;
	sHtmlD			:	string;
	sHtmlBP			:   string;
	sHtmlGray		:	string;
	//-------------------------------------------------------------------------
	sHtmlBf			:	string;		//pomocn etzce - odznky flag
	sHtmlSf			:	string;
	sHtmlGf			:	string;
	sHtmlPf			:	string;
	sHtmlRf			:	string;
	sHtmlSaf		:	string;
	sHtmlEf			:	string;
	sHtmlDf			:	string;
	//-------------------------------------------------------------------------
	sHtmlBi			:	string;		//pomocn etzce - info
	sHtmlSi			:	string;
	sHtmlGi			:	string;
	sHtmlPi			:	string;
	sHtmlRi			:	string;
	sHtmlSai		:	string;
	sHtmlEi			:	string;
	sHtmlDi			:	string;
	sHtmlBPi		:	string;
	sHtmlGrayi		:	string;
	//-------------------------------------------------------------------------
	sHtmlBelt		:	string;
	sHtmlBeltInf	:	string;
	//-------------------------------------------------------------------------
	iBCount			:	integer;
	iSCount			:	integer;
	iGCount			:	integer;
	iPCount			:	integer;
	iRCount			:	integer;
	iSaCount		:	integer;
	iECount			:	integer;
	iDCount			:	integer;
	iBPCount		:   integer;
	iGrayCount		:	integer;
	iFlagCount		:   integer;
end;

const
	Badges_sBGIndex = 'Gray,B,S,G,P,R,Sa,E,D';
var
	Badges_H: THTMLdata;
	
//Globln modul pro odznky

	function Badges_USAstates():Int64;
	var
	  sql:String;
	begin
	  //SQL------------------------------------------------------------------------
	  sql := 'select count(cnt) from';
	  sql := sql + ' (select count(gc.id) cnt';
	  sql := sql + ' from geocache gc';
	  sql := sql + ' where gc.dtfound > 0';
	  sql := sql + '   and gc.state <> ''''';  
	  sql := sql + '   and gc.country = ''United States''';
	  sql := sql + ' group by gc.state)';
	  //hodnota--------------------------------------------------------------------
	  result := GEOGET_DB.GetTableValue(sql);
	  //---------------------------------------------------------------------------
	end;

	function Badges_MyCacheInfo(sType:String):Int64;
	var
		cStr, seltype, sql: String;
	begin
		cStr := GlobalVarGet('OwnedIDsForInPhrase',false);
		//
		if sType = 'CT' then seltype := 'x.cachetype'
		else seltype := 'x.cachesize';
    //
		sql := 'SELECT COUNT(*) FROM (';
		sql := sql + 'SELECT DISTINCT ' + seltype + ' FROM (SELECT *';
		sql := sql + ' FROM geocache gc';
		sql := sql + ' WHERE gc.[id] in (' + cStr + ')';
		sql := sql + ') x )';
		//Log('BG SQL:' + sql);
		//hodnota--------------------------------------------------------------------
		result := GEOGET_DB.GetTableValue(sql);
	end;

    //--------------------------------------------------------------------------
	//Vytvo pojmenovan pole zskanch bod pro psek
	//--------------------------------------------------------------------------
	function Badges_BeltPt(fPt: extended; iValue: Int64; sId, sBeltPt: String): String;
	begin
		Result := sBeltPt;
		if fPt >= 0 then begin
			//Log('Pt: ' + flToStr(fPT));
			case sId of
				'GGeoc': Result := sBeltPt + 'GGeocacher=' + IntToStr(iValue) + ',GGPoints=' + flToStr(fPt) + ',';
				'Host': Result := sBeltPt + 'HostCacher=' + IntToStr(iValue) + ',HostPoints=' + flToStr(fPt) + ',';
				'Matr': Result := sBeltPt + 'MatrCacher=' + IntToStr(iValue) + ',MatrPoints=' + flToStr(fPt) + ',';
				'Twen': Result := sBeltPt + 'TwenCacher=' + IntToStr(iValue) + ',BusyPoints=' + flToStr(fPt) + ',';
				'Cons': Result := sBeltPt + 'ConsCacher=' + IntToStr(iValue) + ',DailyPoints=' + flToStr(fPt) + ',';
				'Favo': Result := sBeltPt + 'FPCacher=' + IntToStr(iValue) + ',FPPoints=' + flToStr(fPt) + ',';
				'Uniq': Result := sBeltPt + 'UniqCacher=' + IntToStr(iValue) + ',UniqPoints=' + flToStr(fPt) + ',';
				'FTF': 	Result := sBeltPt + 'FTFCacher=' + IntToStr(iValue) + ',FTFPoints=' + flToStr(fPt) + ',';
				'Five':	Result := sBeltPt + 'FiverCacher=' + IntToStr(iValue) + ',F55Points=' + flToStr(fPt) + ',';
				'Vete':	Result := sBeltPt + 'VeteCacher=' + IntToStr(iValue) + ',VetePoints=' + flToStr(fPt) + ',';
				'Cale':	Result := sBeltPt + 'CaleCacher=' + IntToStr(iValue) + ',CalendarPoints=' + flToStr(fPt) + ',';
				'Trav':	begin Result := sBeltPt + 'TravelCacher=' + IntToStr(iValue) + ',TBPoints=' + flToStr(fPt) + ','; CalcBG_INI.eTB := fPt; end;
				'Coin':	begin Result := sBeltPt + 'CoinCacher=' + IntToStr(iValue) + ',CoinPoints=' + flToStr(fPt) + ','; CalcBG_INI.eGC := fPt; end;
				'Phot':	Result := sBeltPt + 'PhotoCacher=' + IntToStr(iValue) + ',PhotoPoints=' + flToStr(fPt) + ',';
			end;
			if not((sID = 'Trav') or (sID = 'Coin')) then 
				CalcBG_INI.eSumPoints := CalcBG_INI.eSumPoints + fPt;
		end;	
	end;
	//-------------------------------------------------------------------------
	//Vythne index limit
	//-------------------------------------------------------------------------
	function Badges_GetIndex(sIdx:String):integer;
	var
		j: integer;
		sCut, spom: String;
	begin
		j := -1; sCut := Badges_sBGIndex;
		Result := j;
		if sIdx = 'BP' then begin
			Result := 8;							//BP = D
			exit;
		end;
		while Length(sCut) <> 0 do begin
			spom := Fetch(sCut,',');
			if spom = sIdx then begin
				Result := j;
				exit;
			end;
			Inc(j);
		end;
	end;
	//-------------------------------------------------------------------------
	//Skldn odznk do HTML podle toho jak vychz jejich rove
	//-------------------------------------------------------------------------
	procedure Badges_CreateHTML(sBadge, sOverlay, sBadgeInfo, sIdx: String; Value: Int64; percent: integer; aLmt:TLimit; BG: TBadgeDef);
	var
		i,j, ipg, fsize, ibgtopidx, ifont: integer;
		html, ihtml, pm, GNumber, GWidth, BGWidth: String;
		stmp, s1, s2: String;
	begin
		ipg := Badges_GetIndex(sIdx);
		ibgtopidx := Trunc(0.09 * Round((CalcBG_INI.iBadgeSize - 50) / 1.5));
		//---------------------------------------------------------------------
		if BG.Sign = '+' then pm := '' else pm := BG.Sign;		
		//---------------------------------------------------------------------
		//Odznek
		//Log('Id:' + sIdx + ' ' + IntToStr(ipg));
		//---------------------------------------------------------------------
		BGWidth := IntToStr(CalcBG_INI.iBadgeSize);
		//
		stmp := sBadgeInfo;						//Pro vytaen real name
		//
		fsize := CalcBG_INI.iBadgeSize div 25;
		ifont := fsize + 4;
		//
		s1 := '<div style="display: inline-block; margin:5px 0px 5px 0px; line-height:' + IntToStr(10 + fsize) + 'px;">' + CRLF;
		if sOverlay <> '' then  //<img style="background:url(image.jpg)" src="overlay_image.gif" alt="" />
			s2 := '<img style="background:url(' + sBadge + '); background-size:' + BGWidth + 'px;" src="' + sOverlay + '" width="' + BGWidth + '" title="' + sBadgeInfo + '" />'
		else
			s2 := '<img src="' + sBadge + '" width="' + BGWidth + '" title="' + sBadgeInfo + '" />';	
		//
		if (CalcBG_INI.sIsGraph <> '0') then begin
			GNumber := '';
			//
			if (sIdx <> 'D') and (sIdx <> 'BP') then begin
				if Pos('Z',BG.Flags) > 0 then														//Speciln ady - APE a Unique
					GNumber := '1'
				else begin																			//klasika
					GNumber := Trim(IntToStr(aLmt[ipg + 1] - Value));
				end;
				//
				GWidth := IntToStr(Round((CalcBG_INI.iBadgeSize * percent)/100.00));
				GNumber := BG.Sign + GNumber + '&nbsp;' + ReplaceString(BG.Units,' ','&nbsp;');	//HTML
			end
			else begin
				if (sIdx = 'D') then begin
					GWidth := BGWidth;
					GNumber := _('Diamond');														//Diamant
				end
				else begin
					GWidth := BGWidth;
					GNumber := _('Black Pearl');													//Black Pearl
				end;
			end;
			//
			html := s1 + s2 + '<br />' + CRLF;
			//--------------------------------------------------------------------------------------
			if CalcBG_INI.sIsGraph = '2' then begin		//HTML
				html := html 
					+ '<table style="border-collapse:collapse; padding:0px;'
					+ 'background-color:#%ColorTableBkg%; color:#%ColorTableText%; font-size:'
					+ IntToStr(8 + fsize) +'px; width:'
					+ BGWidth + 'px; height:' + IntToStr(10 + fsize) + 'px;"><tr><td>' 
					+ '<div style="position: absolute; width:' + BGWidth
					+ 'px; height:' + IntToStr(10 + fsize) + 'px;">'
					+ '<div style="z-index:1; position:relative; top:-' + IntToStr(ifont)
					+ 'px; height:'
					+ IntToStr(10 + fsize) + 'px; font-weight:bold; text-align:center;">'
					+ GNumber + '</div>'
					+ '<div style="width:' + GWidth
					+ 'px; position:relative; top:-' + IntToStr(19 + ibgtopidx)
					+ 'px; background-color:#%ColorTableScaleMinBkg%; height:'
					+ IntToStr(10 + fsize) + 'px; float:left;">&nbsp;</div></div>'
					+ '</td></tr></table>' + CRLF
					+ '</div>' + CRLF;
			end
			else begin										//TEXT StyleTitleDivStartHtml
				html := html 
					+ '<table style="border-collapse:collapse; padding:0px;'
					+ 'background-color:#%ColorTitleBkg%; color:#%ColorTitleText%; font-size:'
					+ IntToStr(8 + fsize) +'px; width:'
					+ BGWidth + 'px; height:' + IntToStr(10 + fsize)
					+ 'px;"><tr><td style="font-weight:bold; text-align:center;">'
					+ GNumber
					+ '</td></tr></table>' + CRLF
					+ '</div>' + CRLF;
			end;
		end
		else
			html := s1 + s2 + ' ' + CRLF + '</div>' + CRLF;
		//---------------------------------------------------------------------
		//Info sekce
		//---------------------------------------------------------------------
		ihtml := ihtml + '<div style="display:block; margin: 0px auto;">' + CRLF;
		//table
		ihtml := ihtml + '<table style="%StyleTableMatrix%">' + CRLF;
		//row 1
		if sOverlay <> '' then
			ihtml := ihtml + '<tr style="%StyleTableMatrixTh2%"><td style="width:160px;" rowspan="3"><img style="background:url(' + sBadge
				+ '); background-size:' + BGWidth + 'px;" src="' + sOverlay + '" width="' + BGWidth + '" title="' + sBadgeInfo + '" /></td>'
		else  
			ihtml := ihtml + '<tr style="%StyleTableMatrixTh2%"><td style="width:160px;" rowspan="3"><img src="' + sBadge
				+ '" width="' + BGWidth + '" title="' +  + sBadgeInfo + '" /></td>';
		//------
		if Pos('L',BG.Flags) > 0 then
			ihtml := ihtml + '<td style="font-size:14px;" colspan="10"><b>' + Fetch(sTmp,'-') + '</b>'	//RealName
		else	
			ihtml := ihtml + '<td style="font-size:14px;" colspan="10"><b>' + BG.Name + '</b>';			//BGName
		//------	
		if BG.Units <> '' then
			ihtml := ihtml + ' (' + Trim(BG.Units) + ')</td></tr>' + CRLF
		else
			ihtml := ihtml + '</td></tr>' + CRLF;
		//row 2	
		ihtml := ihtml + '<tr style="%StyleTableMatrixTh2%font-weight:bold;"><td width="10%">B</td><td width="10%">S</td><td width="10%">G</td><td width="10%">P</td><td width="10%">R</td><td width="10%">Sa</td><td width="10%">E</td><td width="10%">D</td><td width="10%">&#931;</td><td width="10%">+</td></tr>' + CRLF + '<tr style="text-align: center;">';
		//row 3
		for i := 0 to 7 do begin
			if Pos('Z',BG.Flags) > 0 then begin		//specil
				if aLmt[i] = 0 then
					ihtml := ihtml + '<td>-</td>'
				else if i <= ipg then
					ihtml := ihtml + '<td style="background-color:#%ColorMapAvgBkg%; color:#%ColorMapPercentText%;">'
						+ pm + Trim(IntToStr(aLmt[i])) + '</td>'
				else begin
					j := 0;
					if (ipg < 7) then begin
						for j := (ipg+1) to 7 do begin
							if aLmt[j] <> 0 then break;
						end;
					end;
					if (i = j) then begin
						ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableAvgText%;"><b>';
						ihtml := ihtml + pm + Trim(IntToStr(aLmt[i])) + '</b></td>';
					end
					else
						ihtml := ihtml + '<td>' + pm + Trim(IntToStr(aLmt[i])) + '</td>';
				end;					
			end
			else begin				//norml
				if i <= ipg then begin
					if (Pos('S',BG.Flags) > 0) and (i=0) then ihtml := ihtml + '<td style="background-color:#%ColorMapAvgBkg%; color:#%ColorMapPercentText%;">'
						  + pm + Trim(IntToStr(1)) + '</td>'
					else ihtml := ihtml + '<td style="background-color:#%ColorMapAvgBkg%; color:#%ColorMapPercentText%;">'
						  + pm + Trim(IntToStr(aLmt[i])) + '</td>';
				end
				else if i = (ipg+1) then begin
					if (Pos('S',BG.Flags) > 0) and (i=0) then ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableAvgText%;"><b>'
						  + pm + Trim(IntToStr(1)) + '</b></td>'
					else ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableAvgText%;"><b>'
						  + pm + Trim(IntToStr(aLmt[i])) + '</b></td>';
				end
				else begin
					if (Pos('S',BG.Flags) > 0) and (i=0) then ihtml := ihtml + '<td>' + pm + Trim(IntToStr(1)) + '</td>' 
					else ihtml := ihtml + '<td>' + pm + Trim(IntToStr(aLmt[i])) + '</td>' ;
				end;
			end;
		end;
		//
		//
		ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; width:60px;"><b>'
			  + pm + Trim(IntToStr(Value)) + '</b></td>';
		//
		if (ipg = 7) or (Value >= aLmt[7]) or (ipg = 8) then begin			//Diamant a Black Pearl
			ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableMaxText%; width:60px;"><b>---</b></td>';
		end
		else begin									//Ostatn
			if Pos('Z',BG.Flags) = 0 then			//norml
				ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableMaxText%; width:60px;"><b>'
					  + pm + Trim(IntToStr(aLmt[ipg+1] - Value)) + '</b></td>'
			else									//specil
				ihtml := ihtml + '<td style="background-color:#%ColorTableScaleMinBkg%; color:#%ColorTableMaxText%; width:60px;"><b>'
					  + pm + ' 1 ' + '</b></td>';
		end;
		//
		ihtml := ihtml + '</tr>' + CRLF + '</table>' + CRLF + '</div>' + CRLF;
		//---------------------------------------------------------------------
		//Rozdlen do sprvnch HTML
		//---------------------------------------------------------------------
		if not CalcBG_INI.bFlagsSeparetly then begin
			case sIdx of
				'B': begin Badges_H.sHtmlB := Badges_H.sHtmlB + html; Inc(Badges_H.iBCount); end;
				'S': begin Badges_H.sHtmlS := Badges_H.sHtmlS + html; Inc(Badges_H.iSCount); end;
				'G': begin Badges_H.sHtmlG := Badges_H.sHtmlG + html; Inc(Badges_H.iGCount); end;
				'P': begin Badges_H.sHtmlP := Badges_H.sHtmlP + html; Inc(Badges_H.iPCount); end;
				'R': begin Badges_H.sHtmlR := Badges_H.sHtmlR + html; Inc(Badges_H.iRCount); end;
				'Sa': begin Badges_H.sHtmlSa := Badges_H.sHtmlSa + html; Inc(Badges_H.iSaCount); end;
				'E': begin Badges_H.sHtmlE := Badges_H.sHtmlE + html; Inc(Badges_H.iECount); end;
				'D': begin Badges_H.sHtmlD := Badges_H.sHtmlD + html; Inc(Badges_H.iDCount); end;
				'BP': begin Badges_H.sHtmlBP := Badges_H.sHtmlBP + html; Inc(Badges_H.iBPCount); end;
				'Gray': begin Badges_H.sHtmlGray := Badges_H.sHtmlGray + html; Inc(Badges_H.iGrayCount); end;
			end;
		end
		else begin
			if Pos('S',BG.Flags) = 0 then begin
				case sIdx of
					'B': begin Badges_H.sHtmlB := Badges_H.sHtmlB + html; Inc(Badges_H.iBCount); end;
					'S': begin Badges_H.sHtmlS := Badges_H.sHtmlS + html; Inc(Badges_H.iSCount); end;
					'G': begin Badges_H.sHtmlG := Badges_H.sHtmlG + html; Inc(Badges_H.iGCount); end;
					'P': begin Badges_H.sHtmlP := Badges_H.sHtmlP + html; Inc(Badges_H.iPCount); end;
					'R': begin Badges_H.sHtmlR := Badges_H.sHtmlR + html; Inc(Badges_H.iRCount); end;
					'Sa': begin Badges_H.sHtmlSa := Badges_H.sHtmlSa + html; Inc(Badges_H.iSaCount); end;
					'E': begin Badges_H.sHtmlE := Badges_H.sHtmlE + html; Inc(Badges_H.iECount); end;
					'D': begin Badges_H.sHtmlD := Badges_H.sHtmlD + html; Inc(Badges_H.iDCount); end;
					'BP': begin Badges_H.sHtmlBP := Badges_H.sHtmlBP + html; Inc(Badges_H.iBPCount); end;
					'Gray': begin Badges_H.sHtmlGray := Badges_H.sHtmlGray + html; Inc(Badges_H.iGrayCount); end;
				end;
			end
			else begin
				case sIdx of
					'B': begin Badges_H.sHtmlBf := Badges_H.sHtmlBf + html; Inc(Badges_H.iFlagCount); end;
					'S': begin Badges_H.sHtmlSf := Badges_H.sHtmlSf + html; Inc(Badges_H.iFlagCount); end;
					'G': begin Badges_H.sHtmlGf := Badges_H.sHtmlGf + html; Inc(Badges_H.iFlagCount); end;
					'P': begin Badges_H.sHtmlPf := Badges_H.sHtmlPf + html; Inc(Badges_H.iFlagCount); end;
					'R': begin Badges_H.sHtmlRf := Badges_H.sHtmlRf + html; Inc(Badges_H.iFlagCount); end;
					'Sa': begin Badges_H.sHtmlSaf := Badges_H.sHtmlSaf + html; Inc(Badges_H.iFlagCount); end;
					'E': begin Badges_H.sHtmlEf := Badges_H.sHtmlEf + html; Inc(Badges_H.iFlagCount); end;
					'D': begin Badges_H.sHtmlDf := Badges_H.sHtmlDf + html; Inc(Badges_H.iFlagCount); end;
					'Gray': begin Badges_H.sHtmlGray := Badges_H.sHtmlGray + html; Inc(Badges_H.iGrayCount); end;
				end;
			end;
		end;
		case sIdx of
			'B': Badges_H.sHtmlBi := Badges_H.sHtmlBi + ihtml;
			'S': Badges_H.sHtmlSi := Badges_H.sHtmlSi + ihtml;
			'G': Badges_H.sHtmlGi := Badges_H.sHtmlGi + ihtml;
			'P': Badges_H.sHtmlPi := Badges_H.sHtmlPi + ihtml;
			'R': Badges_H.sHtmlRi := Badges_H.sHtmlRi + ihtml;
			'Sa': Badges_H.sHtmlSai := Badges_H.sHtmlSai + ihtml;
			'E': Badges_H.sHtmlEi := Badges_H.sHtmlEi + ihtml;
			'D': Badges_H.sHtmlDi := Badges_H.sHtmlDi + ihtml;
			'BP': Badges_H.sHtmlBPi := Badges_H.sHtmlBPi + ihtml;
			else Badges_H.sHtmlGrayi := Badges_H.sHtmlGrayi + ihtml;
		end;
	end;
	//-------------------------------------------------------------------------
	function Badges_IsGem(sIdx:String):Integer;
	begin
		Case sIdx of
			'R','Sa','E','D','BP': Result := 1;
			else Result := 0;
		end;
	end;
	//-------------------------------------------------------------------------
	//Vrt level odznku v seln podob 0-7
	function Badges_GetLevel(Const Setting:String):Integer;
	var
		s,stmp : String;
	begin
		s:= ReplaceString(Setting,'(','-');	//kdyby nkde zstal pvodn setting
		stmp := Fetch(s, '-');
		Result := Badges_GetIndex(stmp) - 1;
	end;
	
	function Badges_Footer() :string;
	var
		outhtml : string;
	begin
		outhtml := '';
		outhtml := outhtml + '<div style="line-height:95%;font-size:10px; text-align: center;"><br />' + CRLF;
		outhtml := outhtml + '<a href="http://www.badgegen.com/badges.html">Available Badges from BadgeGen</a> or ';
		outhtml := outhtml + '<a href="http://www.drakmrak.cz/doku.php?id=geo:badgegen">Czech info</a>, ';
		outhtml := outhtml + '<a href="http://www.drakmrak.cz/doku.php?id=geo:badgegeninfo">[1]</a>, ';
		outhtml := outhtml + '<a href="http://www.drakmrak.cz/doku.php?id=geo:beltinfoii">[2]</a><br />' + CRLF;
		outhtml := outhtml + 'The Groundspeak Geocaching Logo is a trademark of ';
		outhtml := outhtml + '<a href="https://www.geocaching.com/">Groundspeak, Inc.</a> and used with permission.<br />' + CRLF;
		outhtml := outhtml + 'Inspired by <a href="http://www.badgegen.com/">BadgeGen</a> from <b>ky.m.guy</b><br /><br />' + CRLF;
		outhtml := outhtml + '<span style="font-weight:bold; color:#6484FF">Version: ' + CalcBG_Version + ' by DrakMrak</span>';
		outhtml := outhtml + '</div>';
		Result := outhtml;
	end;
	
	function Badges_GetBadge(BGName:String):TBGData;
	var
		i: integer;
	begin
		Result := CalcBG_Data[0];
		For i := 0 to High(CalcBG_Data) do
		begin
			if CalcBG_Badges[CalcBG_Data[i].Index].Name = BGName then begin
				Result := CalcBG_Data[i];
				break;
			end;
		end;
	end;

//******************************************************************************
//								B E L T S   I I
//******************************************************************************
function Badges_BeltsII(Params: TStringlist; var BeltHtml, InfHtml: String):Boolean;
var
	Points, TBGCpt, eShowPt, eOtherPt: extended;
	belt, base, basename, imgname, ihtml, ccolor, mx, mf: String;
	sTabStart, sTabMiddle, sTabMiddle2, sTabEnd: String;
	sBeltWidth, sBeltInfo, GNumber, GWidth, s1, s2, scd: String;
	ibgtopidx,fsize,ifont, percent: integer;
begin
	//
	StatorBusy('Belt');
	Result := True;
	InfHtml := ''; BeltHtml := '';
	belt := '0'; mx := '30';
    basename := 'belt';
	Points := CalcBG_INI.eSumPoints;
	//
	if Points >= 30 then begin belt := '1'; mf := '0'; mx := '40'; end;
	if Points >= 40 then begin belt := '2'; mf := '40'; mx := '50'; end;
	if Points >= 50 then begin belt := '3'; mf := '50'; mx := '60'; end;
	if Points >= 60 then begin belt := '4'; mf := '60'; mx := '70'; end;
	if Points >= 70 then begin belt := '5'; mf := '70'; mx := '80'; end;
	if Points >= 80 then begin belt := '6'; mf := '80'; mx := '90'; end;
	if Points >= 90 then begin belt := '7'; mf := '90'; mx := '100'; end;
	if Points >= 100 then begin belt := '8'; mf := '100'; mx := '110'; end;
	if Points >= 110 then begin belt := '9'; mf := '110'; mx := '120'; end;
	if Points >= 120 then begin belt := '10'; mf := '120'; mx := '130'; end;
	if Points >= 130 then begin belt := '11'; mf := '130'; mx := '140'; end;
	if Points >= 140 then begin belt := '12'; mf := '140'; mx := '150'; end;
	if Points >= 150 then begin belt := '13'; mf := '150'; mx := '160'; end;
	if Points >= 160 then begin belt := '14'; mf := '160'; mx := '170'; end;
	if Points >= 170 then begin belt := '15'; mf := '170'; mx := '180'; end;
	if Points >= 180 then begin belt := '16'; mf := '180'; mx := '190'; end;
	if Points >= 190 then begin belt := '17'; mf := '190'; mx := '200'; end;
	if Points >= 200 then begin belt := '18'; mf := '200'; mx := '210'; end;
	if Points >= 210 then begin belt := '19'; mf := '210'; mx := '220'; end;
	if Points >= 220 then begin belt := '20'; mf := '220'; mx := '232'; end;
	if Points >= 232 then begin belt := '21'; mf := '232'; mx := '244'; end;
	if Points >= 244 then begin belt := '22'; mf := '244'; mx := '256'; end;
	if Points >= 256 then begin belt := '23'; mf := '256'; mx := '268'; end;
	if Points >= 268 then begin belt := '24'; mf := '268'; mx := '280'; end;
	if Points >= 280 then begin belt := '25'; mf := '280'; mx := '292'; end;
	if Points >= 292 then begin belt := '26'; mf := '292'; mx := '304'; end;
	if Points >= 304 then begin belt := '27'; mf := '304'; mx := '316'; end;
	if Points >= 316 then begin belt := '28'; mf := '316'; mx := '328'; end;
	if Points >= 328 then begin belt := '29'; mf := '328'; mx := '340'; end;
	if Points >= 340 then begin belt := '30'; mf := '340'; mx := '352'; end;
	if Points >= 352 then begin belt := '31'; mf := '352'; mx := '364'; end;
	if Points >= 364 then begin belt := '32'; mf := '364'; mx := '376'; end;
	if Points >= 376 then begin belt := '33'; mf := '376'; mx := '388'; end;
	if Points >= 388 then begin belt := '34'; mf := '388'; mx := '400'; end;
	if Points >= 400 then begin belt := '35'; mf := '400'; mx := '***'; end;
	//---------------------------------------------------------------------------------------------------
	//--Psek--------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------------
	base := CalcBG_INI.sBadgesURL + 'b2/';
	imgname := base + basename + belt;
	//---------------------------------------------------------------------------------------------------
	eShowPt := round(Points*100)/100.0;
	if mx = '***' then
		eOtherPt := -1
	else
		eOtherPt := StrToFl(mx) - eShowPt;
	//
	sBeltWidth := Trim(IntToStr(Round((175 * CalcBG_INI.iBeltSize)/100.0)));
	sBeltInfo := _('Score:') + ' ' + FlToStr(eShowPt)
			+ ' ' + _('pt.') + ' (' + _('next:') + ' ' + mx
			+ ' ' + _('pt.') + ')';
	//
	fsize := CalcBG_INI.iBeltSize div 25;
	ifont := fsize + 3;
	//
	s1 := '<div style="margin:5px 0px 5px 0px; ; line-height:' + IntToStr(10 + fsize) + 'px; width:' + sBeltWidth + 'px;">' + CRLF;
	s2 := '<img src="' + imgname + '.png" width="' + sBeltWidth + '" title="' + sBeltInfo + '" />';
	//
	if (CalcBG_INI.sIsGraph <> '0') then begin
		percent := Round(((eShowPt-StrToFl(mf))*100.00)/(StrToInt(mx)-StrToInt(mf)));
		if eOtherPt < 0 then begin
			GNumber := '***';
			Gwidth := sBeltWidth;
		end
		else begin
			GNumber := '+' + FlToStr(Round(eOtherPt*100.00)/100.00);		//HTML
			GWidth	:= IntToStr(Round((StrToInt(sBeltWidth) * percent)/100.00));
		end;
		//
		ibgtopidx := Trunc(0.09 * Round((CalcBG_INI.iBeltSize - 50) / 1.5));
		//
		BeltHtml := s1 + s2 + '<br />' + CRLF;
		//------------------------------------------------------------------------------------------
		if CalcBG_INI.sIsGraph = '2' then begin		//HTML	
			BeltHtml := BeltHtml + '<table style="border-collapse:collapse; padding:0px;'
				+ 'background-color:#%ColorTableBkg%; color:#%ColorTableText%; font-size:'
				+ IntToStr(8 + fsize) + 'px; width:'
				+ sBeltWidth + 'px; height:' + IntToStr(10 + fsize) + 'px;"><tr><td>'
				+ '<div style="position: absolute; width:' + sBeltWidth
				+ 'px; height:' + IntToStr(10 + fsize) + 'px;">'
				+ '<div style="z-index:1; position:relative; top:-' + IntToStr(ifont)
				+ 'px; height:'
				+ IntToStr(10 + fsize) + 'px; font-weight:bold; text-align:center;">'
				+ GNumber + '</div>'
				+ '<div style="width:' + GWidth
				+ 'px; position:relative; top:-' + IntToStr(19 + ibgtopidx)
				+ 'px; background-color:#%ColorTableScaleMinBkg%; height:'
				+ IntToStr(10 + fsize) + 'px; float:left;">&nbsp;</div></div>'
				+ '</td></tr></table>' + CRLF
				+ '</div>' + CRLF;
		end
		else begin										//TEXT
			BeltHtml := BeltHtml 
				+ '<table style="border-collapse:collapse; padding:0px; '
				+ 'background-color:#%ColorTitleBkg%; color:#%ColorTitleText%; font-size:'
				+ IntToStr(8 + fsize) +'px; width:'
				+ sBeltWidth + 'px; height:' + IntToStr(10 + fsize)
				+ 'px;"><tr><td style="font-weight:bold; text-align:center;">'
				+ GNumber
				+ '</td></tr></table>' + CRLF
				+ '</div>' + CRLF;
		end;
	end
	else begin
		BeltHtml := s1 + s2 + '</div>' + CRLF;
	end;
	//---------------------------------------------------------------------------------------------------
	//--INFO-O-PSKU-------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------------
	sTabStart := '<tr style="%StyleTableNumTr%"><td style="%StyleTableNumLabelTd%">';
	sTabMiddle := '&nbsp;</td><td style="%StyleTableNumTd% text-align: right;">';
	sTabMiddle2 := '</td><td style="%StyleTableNumTd% text-align: right;">';
	sTabEnd := '</td></tr>'+CRLF;
	//
	ihtml := ihtml + CRLF+'<br/><table style="%StyleTableNum%">'+CRLF;
	//Header----------------------------------------------------------------------------------------
	ihtml := ihtml
			+ '<tr style="%StyleTableNumTr%"><th colspan=3 style="%StyleTableNumTh%">'
			+ _('Belt evaluation') +'</th></tr>'+CRLF;
	//Header II-------------------------------------------------------------------------------------
	ihtml := ihtml
			+ '<tr style="%StyleTableNumTr%"><th style="%StyleTableNumTh%">'
			+ _('Info') +'</th><th style="%StyleTableNumTh%">' + _('Count') + '</th>'
			+ '<th style="%StyleTableNumTh%">' + _('Points') + '</th></tr>'+CRLF; 
	//Cache-----------------------------------------------------------------------------------------
	ihtml := ihtml
			+ STabStart + _('1 point per 100 caches found') + sTabMiddle
			+ Params.Values['GGeocacher'] + sTabMiddle2
			+ Params.Values['GGPoints'] + sTabEnd;		
	//Host------------------------------------------------------------------------------------------
	if StrToInt(Params.Values['HostPoints']) = 30 then
		ccolor := '<b>' + Params.Values['HostPoints'] + '</b>'
	else
		ccolor := Params.Values['HostPoints'];
	//
	ihtml := ihtml
			+ sTabStart + _('2 points per event hosted (max.30 pt.)') + sTabMiddle
			+ Params.Values['HostCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//Matrix----------------------------------------------------------------------------------------		
	if StrToInt(Params.Values['MatrCacher']) = 81 then
		ccolor := '<b>' + Params.Values['MatrPoints'] + '</b>'
	else
		ccolor := Params.Values['MatrPoints'];
	//
	ihtml := ihtml + sTabStart + _('0.5 points per D/T combination found in excess of 40 combinations');
	if StrToInt(Params.Values['MatrCacher']) = 81 then
		ihtml := ihtml + '<br />' +  _('+10 points for completing the D/T matrix');
	ihtml := ihtml + 
		+ sTabMiddle + Params.Values['MatrCacher'] + sTabMiddle2
		+ ccolor + sTabEnd;
	//Country/State---------------------------------------------------------------------------------
	if StrToInt(Params.Values['SumCountryPoints']) = 20 then
		ccolor := '<b>20</b>'
	else 
		ccolor := '0';
	//
	ihtml := ihtml + sTabStart + _('20 points for either finding caches in 15 USA distinct states or 5 distinct countries')
			+ sTabMiddle
			+ Params.Values['StatePoints'] + '/' + Params.Values['CountryPoints'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//za kadch 50 ke v den kdy m lovk nejvce nlez-----------------------------------------
	if StrToInt(Params.Values['BusyPoints']) = 40 then 
		ccolor := '<b>40</b>'
	else 
		ccolor := Params.Values['BusyPoints'];
	//
	ihtml := ihtml + sTabStart + _('10 points per 50 caches found on day with most finds (max.40 pt.)') + sTabMiddle
			+ Params.Values['TwenCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//kalendn dny--------------------------------------------------------------------------------
	if StrToInt(Params.Values['ConsCacher']) >= 366 then
		ccolor := '<b>' + Params.Values['DailyPoints'] + '</b>'
	else
		ccolor := Params.Values['DailyPoints'];
	//
	ihtml := ihtml + sTabStart + _('0.5 points per 7 consecutive days with finds in largest streak. 10 point bonus at 366 days')
			+ sTabMiddle
			+ Params.Values['ConsCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//FP--------------------------------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('0.1 points per favorite point on owned caches') + sTabMiddle
			+ Params.Values['FPCacher'] + sTabMiddle2
			+ Params.Values['FPPoints'] + sTabEnd;
	//max found types in one day--------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('2 points per distinct cache type on day with most distinct types found') + sTabMiddle
			+ Params.Values['UniqCacher'] + sTabMiddle2
			+ Params.Values['UniqPoints'] + sTabEnd;
	//My own type-----------------------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('2 points per distinct cache type hidden') + sTabMiddle
			+ Params.Values['CacheOwnType'] + sTabMiddle2
			+ Params.Values['HDistPoints'] + sTabEnd;
	//My own size-----------------------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('2 points per disctinct cache size hidden') + sTabMiddle
			+ Params.Values['CacheOwnBSize'] + sTabMiddle2
			+ Params.Values['HSizePoints'] + sTabEnd;		
	//FTF-------------------------------------------------------------------------------------------
	if StrToInt(Params.Values['FTFPoints']) = 30 then 
		ccolor := '<b>' + Params.Values['FTFPoints'] + '</b>'
	else
		ccolor := Params.Values['FTFPoints'];
	//
	ihtml := ihtml + sTabStart + _('0.5 points per FTF (max.30 pt.)') + sTabMiddle
			+ Params.Values['FTFCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//5/5-------------------------------------------------------------------------------------------
	if StrToInt(Params.Values['F55Points']) = 5 then 
		ccolor := '<b>' + Params.Values['F55Points'] + '</b>'
	else
		ccolor := Params.Values['F55Points'];
	//
	ihtml := ihtml + sTabStart + _('1 point per 5/5 Difficulty/Terrain cache found (max.5 pt.)') + sTabMiddle
			+ Params.Values['FiverCacher'] + sTabMiddle2
		    + ccolor + sTabEnd;		
	//gemstone--------------------------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('1 point per gemstone badge (excluding country badges)') + sTabMiddle
			+ Params.Values['GemPoints'] + sTabMiddle2
			+ Params.Values['GemPoints'] + sTabEnd;
	//veteran---------------------------------------------------------------------------------------
	ihtml := ihtml + sTabStart + _('2 points for every year since your first cache find') + sTabMiddle
			+ Params.Values['VeteCacher'] + sTabMiddle2
			+ Params.Values['VetePoints'] + sTabEnd;
	//calendar days > 100---------------------------------------------------------------------------
	if StrToInt(Params.Values['CaleCacher']) = 366 then
		ccolor := '<b>' + Params.Values['CalendarPoints'] + '</b>'
	else
		ccolor := Params.Values['CalendarPoints'];
	//
	ihtml := ihtml + sTabStart 
			+ _('0.08 points per calendar day cached on. No points awarded if distinct days is less than 100. The year is negligible.')
			+ sTabMiddle + Params.Values['CaleCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//TB/GC move/discover---------------------------------------------------------------------------
	TBGCpt := CalcBG_INI.eTB + CalcBG_INI.eGC;
	if TBGCpt > 25 then TBGCpt := 25;
	//
	if TBGCpt = 25 then
		ccolor := '<b>25</b>'
	else
		ccolor := FlToStr(TBGCpt);
	//
	ihtml := ihtml + sTabStart + _('0.05 points per trackable moved/discovered (max.25 pt.)') + sTabMiddle
			+ IntToStr(StrToInt(Params.Values['CoinCacher']) + StrToInt(Params.Values['TravelCacher'])) + sTabMiddle2
			+ ccolor + sTabEnd;
	//Photo-----------------------------------------------------------------------------------------
	if StrToInt(Params.Values['PhotoPoints']) = 25 then 
		ccolor := '<b>25</b>'
	else
		ccolor := Params.Values['PhotoPoints'];
	//
	ihtml := ihtml + sTabStart + _('0.1 points per photo uploaded to found logs (max.25 pt.)') + sTabMiddle
			+ Params.Values['PhotoCacher'] + sTabMiddle2
			+ ccolor + sTabEnd;
	//Score-----------------------------------------------------------------------------------------
	ihtml := ihtml
			+ '<tr style="%StyleTableNumTr%"><th colspan=3 style="%StyleTableNumTh%">'
			+ _('Score:') + ' ' + FlToStr(round(Points*100)/100.0) + ' '
			+ _('pt.') +'</th></tr>'+CRLF;
	//---------------------------------END TABLE----------------------------------------------------
	ihtml := ihtml + CRLF + '</table>';
	//----------------------------------------------------------------------------------------------
	scd := '<div style="text-align:center;">';
	//----------------------------------------------------------------------------------------------
	ihtml := ihtml + '<div align="center">' + CRLF + '<table>' + CRLF;
	ihtml := ihtml + '<tr><td><br /></td><td><br /></td><td>' + CRLF + scd + '<br />';
	ihtml := ihtml + '<span><img src="' + base + 'belt0.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td><br /></td><td><br /></td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><br /></td><td><br /></td><td>' + scd + '0-30</div>';
	ihtml := ihtml + '</td><td><br /></td><td><br /></td></tr>' + CRLF + '<tr>';
    ihtml := ihtml + '<td>'+ scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt1.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt2.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt3.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt4.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt5.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + CRLF + scd + '30-40</div></td>';
    ihtml := ihtml + '<td>' + scd + '40-50</div></td>';
    ihtml := ihtml + '<td>' + scd + '50-60</div></td>';
    ihtml := ihtml + '<td>' + scd + '60-70</div></td>';
    ihtml := ihtml + '<td>' + scd + '70-80</div></td></tr>';
	ihtml := ihtml + '<tr><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt6.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt7.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt8.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt9.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt10.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + scd + '80-90</div></td>';
    ihtml := ihtml + '<td>' + scd + '90-100</div></td>';
    ihtml := ihtml + '<td>' + scd + '100-110</div></td>';
    ihtml := ihtml + '<td>' + scd + '110-120</div></td>';
    ihtml := ihtml + '<td>' + scd + '120-130</div></td></tr>';
	ihtml := ihtml + '<tr><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt11.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt12.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt13.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt14.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt15.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + scd + '130-140</div></td>';
    ihtml := ihtml + '<td>' + scd + '140-150</div></td>';
    ihtml := ihtml + '<td>' + scd + '150-160</div></td>';
    ihtml := ihtml + '<td>' + scd + '160-170</div></td>';
    ihtml := ihtml + '<td>' + scd + '170-180</div></td></tr>';
	ihtml := ihtml + '<tr><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt16.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt17.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt18.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt19.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt20.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + scd + '180-190</div></td>';
    ihtml := ihtml + '<td>' + scd + '190-200</div></td>';
    ihtml := ihtml + '<td>' + scd + '200-210</div></td>';
    ihtml := ihtml + '<td>' + scd + '210-220</div></td>';
    ihtml := ihtml + '<td>' + scd + '220-232</div></td></tr>';
	ihtml := ihtml + '<tr><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt21.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt22.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt23.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt24.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt25.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + scd + '232-244</div></td>';
    ihtml := ihtml + '<td>' + scd + '244-256</div></td>';
    ihtml := ihtml + '<td>' + scd + '256-268</div></td>';
    ihtml := ihtml + '<td>' + scd + '268-280</div></td>';
    ihtml := ihtml + '<td>' + scd + '280-292</div></td></tr>';	
	ihtml := ihtml + '<tr><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt26.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt27.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt28.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt29.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt30.png" width="100" /></span></div>';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>' + scd + '292-304</div></td>';
    ihtml := ihtml + '<td>' + scd + '304-316</div></td>';
    ihtml := ihtml + '<td>' + scd + '316-328</div></td>';
    ihtml := ihtml + '<td>' + scd + '328-340</div></td>';
    ihtml := ihtml + '<td>' + scd + '340-352</div></td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>';
	ihtml := ihtml + '<br />';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt31.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br />';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt32.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br />';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><br /></td>';
    ihtml := ihtml + '<td>' + scd + '352-364</div></td>';
    ihtml := ihtml + '<td><br /></td>';
    ihtml := ihtml + '<td>' + scd + '364-376</div></td>';
    ihtml := ihtml + '<td><br /></td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td>';
	ihtml := ihtml + '<br />';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt33.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt34.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>' + scd;
	ihtml := ihtml + '<span><img src="' + base + 'belt35.png" width="100" /></span></div>';
	ihtml := ihtml + '</td><td>';
	ihtml := ihtml + '<br />';
	ihtml := ihtml + '</td></tr>' + CRLF;
	ihtml := ihtml + '<tr><td><br /></td>';
    ihtml := ihtml + '<td>' + scd + '376-388</div></td>';
    ihtml := ihtml + '<td>' + scd + '388-400</div></td>';
    ihtml := ihtml + '<td>' + scd + '400+</div></td>';
    ihtml := ihtml + '<td><br /></td></tr>' + CRLF;
	ihtml := ihtml + '</table>' + CRLF + '</div><br />' + CRLF;
	//
	InfHtml:= InfHtml + ihtml;
end;

function Badges_IDSection(iSec: integer):String;
begin
	Result := '';
	if iSec > 0 then Result := '_0' + IntToStr(iSec);
end;

procedure Badges_LevelOutput(const BGhtml: String; const Level, maxLevel: integer; var CacheHtml, ShowHtml: String);
begin
	if BGhtml <> '' then begin
		if Level <= maxLevel then CacheHtml := CacheHtml + BGhtml 
		else ShowHtml := ShowHtml + BGhtml;
	end;
end;

procedure Badges_LevelOutputSep(const BGhtml: String; const Level, maxLevel: integer; var CacheHtml, ShowHtml: String);
var
	spre, spost: String;
begin
	spre := '';
	spost := '<br />';
	//
	if BGhtml <> '' then begin
		if Level <= maxLevel then CacheHtml := CacheHtml + spre + BGhtml + spost
		else ShowHtml := ShowHtml + spre + BGhtml + spost;
	end;
end;

procedure Badges_BadgeCreate(const Name:String; var GemPt:integer; var BeltPt:String);
var
	D: TBGData;
	BG: TBadgeDef;
begin
	log(Name);
	//----------------------------------------------------------------
	D := Badges_GetBadge(Name);	//Zsk vypotan data odznaku
	BG := CalcBG_Badges[D.Index];	//Zsk odznak
	//----------------------------------------------------------------
	GemPt := GemPt + Badges_IsGem(D.BadgeType);												//body za drahokam
	BeltPt := Badges_BeltPt(D.Points, D.Value, BG.ShortName, BeltPt);						//data pro psek
	Badges_CreateHTML(D.Image, D.OverlayImg, D.Info, D.BadgeType, D.Value, D.Percent, D.RealLimit, BG);	//poskld HTML
end;

//hlavni funkce modulu
function Badges_Run(aPar: TStringList):string;
var
	bStatus: boolean;
	aParams: TStringlist;
	aTmpParams: TStringList;
	sBgFlag, sCacheData: String;
	sBgsName,sBgName, OldID: String;
	sBeltPoints: String;
	iGemPoints, iCountryCount, iSumCountryPoints: Integer;
	iOwnType, iOwnSize : integer;
	i,j: integer;
	iRowCount, iSection: integer;
	spre, spost, sflag, sgray: String;
	sShow, spomhtml, sxhtml, stmp: String;
	Compact : array of TFCompact;
	D: TBGData;
	BG: TBadgeDef;
	
begin
	Result := '';
	if(CalcBG_sCalcRun<>'CALC') then begin
		Inc(nModuleErrors);
		iModuleError := 1;
		sModuleError := _('ERR: Can not start module!') + CRLF
					  + _('Can not start module CalcBG - there aren''t processable data.');
		if(sModuleError <> '') then Log(sModuleError);
		exit;
	end;
	//clear strings------------------------------------------------------------
	Badges_H.sHtmlB := ''; Badges_H.sHtmlS := ''; 
	Badges_H.sHtmlG := ''; Badges_H.sHtmlP := ''; 
	Badges_H.sHtmlR := ''; Badges_H.sHtmlSa := ''; 
	Badges_H.sHtmlE := ''; Badges_H.sHtmlD := ''; 
	Badges_H.sHtmlBP := ''; Badges_H.sHtmlGray := '';
	//
	Badges_H.sHtmlBi := ''; Badges_H.sHtmlSi := ''; 
	Badges_H.sHtmlGi := ''; Badges_H.sHtmlPi := ''; 
	Badges_H.sHtmlRi := ''; Badges_H.sHtmlSai := ''; 
	Badges_H.sHtmlEi := ''; Badges_H.sHtmlDi := ''; 
	Badges_H.sHtmlBPi := ''; Badges_H.sHtmlGrayi := '';
	//
	Badges_H.sHtmlBf := ''; Badges_H.sHtmlSf := ''; 
	Badges_H.sHtmlGf := ''; Badges_H.sHtmlPf := ''; 
	Badges_H.sHtmlRf := ''; Badges_H.sHtmlSaf := ''; 
	Badges_H.sHtmlEf := ''; Badges_H.sHtmlDf := '';
	//	
	sBgFlag := '';
	//
	Badges_H.sHtmlBelt := ''; Badges_H.sHtmlBeltInf := '';
	//
	Badges_H.iBCount := 0; Badges_H.iSCount := 0; Badges_H.iGCount := 0; Badges_H.iPCount := 0;
	Badges_H.iRCount := 0; Badges_H.iSaCount := 0; Badges_H.iECount := 0; Badges_H.iDCount := 0;
	Badges_H.iBPCount := 0; Badges_H.iGrayCount := 0; Badges_H.iFlagCount := 0;
	//
	//sHtmlInfo := '';
	spre := ''; spost := ''; sflag := ''; sgray := ''; sCacheData := '';
	//-------------------------------------------------------------------------
	//Nastavm globln promnn pro dal pouit
	//-------------------------------------------------------------------------
	stmp						:= aPar.Values['Graf'];
	CalcBG_INI.sIsGraph 		:= Fetch(stmp, '-');
	if CalcBG_INI.sIsGraph = '1' then CalcBG_INI.sIsGraph := '2';
	stmp	 					:= aPar.Values['MainCompact'];
	CalcBG_INI.sIsCompact		:= Fetch(stmp, '-');
	//stmp	 					:= aPar.Values['FlagCompact'];
	CalcBG_INI.sIsFlagCompact	:= aPar.Values['FlagCompact'] = 'Yes'; //Fetch(stmp, '-');
	CalcBG_INI.bIsBelt 			:= aPar.Values['Belt'] = 'Yes';
	CalcBG_INI.bIsInfo 			:= aPar.Values['Info'] = 'Yes';
	CalcBG_INI.bFlagsSeparetly 	:= aPar.Values['FlagsSeparetly'] = 'Yes';
	CalcBG_INI.bShowGrey 		:= aPar.Values['Grey'] = 'Yes';
	//
	CalcBG_INI.iLevel			:= Badges_GetLevel(aPar.Values['BGLevel']);
	//
	CalcBG_INI.iBadgeSize		:= StrToInt(aPar.Values['BgSize']);
	if CalcBG_INI.iBadgeSize < 50 Then CalcBG_INI.iBadgeSize := 50;
	if CalcBG_INI.iBadgeSize > 150 Then CalcBG_INI.iBadgeSize := 150;
	CalcBG_INI.iBeltSize		:= StrToInt(aPar.Values['BltSize']);
	if CalcBG_INI.iBeltSize < 50 Then CalcBG_INI.iBeltSize := 50;
	if CalcBG_INI.iBeltSize > 150 Then CalcBG_INI.iBeltSize := 150;
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//Header
	if(aPar.Values['Title']<>'') then Output(ProcessCommand('CmdTitle',aPar));
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	aParams := TStringList.Create;
	aTmpParams := TStringList.Create;
	try
		sBeltPoints := ''; iGemPoints := 0; iCountryCount := 0;
		//
		Log('Badges - start creating...');
		if(aPar.Values['BadgesGC']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesGC']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesType']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesType']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesSize']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesSize']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesDT']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesDT']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesFTF']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesFTF']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesOWN']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesOWN']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesHeight']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesHeight']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesCountry']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesCountry']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				if sBgName = 'State Badges' then begin
					For i := 0 to High(CalcBG_StateData) do begin					
						//----------------------------------------------------------------
						D := CalcBG_StateData[i];		//Zsk vypotan data odznaku
						log(D.RealName);
						BG := CalcBG_Badges[D.Index];	//Zsk odznak
						//----------------------------------------------------------------
						//body za drahokam nejsou a do psku taky nic
						Badges_CreateHTML(D.Image, D.OverlayImg, D.Info, D.BadgeType, D.Value, D.Percent, D.RealLimit, BG); //poskld HTML
						Inc(iCountryCount);	 //zskan country
					end;
				end
				else 	//Ostatn Country odznky
					Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if(aPar.Values['BadgesOther']<>'') then begin
			sBgsName := Trim(aPar.Values['BadgesOther']);
			while Length(sBgsName) <> 0 do begin
				sBgName := Fetch(sBgsName,'|');
				Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
			end;
		end;
		//
		if CalcBG_INI.bWaymarking then begin
			if(aPar.Values['BadgesWaymarking']<>'') then begin
				sBgsName := Trim(aPar.Values['BadgesWaymarking']);
				while Length(sBgsName) <> 0 do begin
					sBgName := Fetch(sBgsName,'|');
					Badges_BadgeCreate(sBgName, iGemPoints, sBeltPoints);
				end;
			end;
		end;
		//----------------------------------------------------------------------------------------------
		//BELT------------------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------------------
		if CalcBG_INI.bIsBelt then begin
			aParams.Clear;
			//
			iSumCountryPoints := 0;
			if (Badges_USAstates >= 15) or (iCountryCount >= 5) then
				iSumCountryPoints := 20; 							//20 bod		
			//OWN CACHE TYPE/SIZE
			iOwnType := Badges_MyCacheInfo('CT');
			iOwnSize := Badges_MyCacheInfo('CS');
			//BODY-------------
			//TB/GC
			if (CalcBG_INI.eTB + CalcBG_INI.eGC) >= 25 then 
				CalcBG_INI.eSumPoints := CalcBG_INI.eSumPoints + 25
			else 
				CalcBG_INI.eSumPoints := CalcBG_INI.eSumPoints + CalcBG_INI.eTB + CalcBG_INI.eGC;
			CalcBG_INI.eSumPoints := CalcBG_INI.eSumPoints + iGemPoints
								   + iSumCountryPoints + (iOwnType * 2) + (iOwnSize * 2);
			//COMMA TEXT-------
			aParams.CommaText := sBeltPoints + 'GemPoints=' + IntToStr(iGemPoints) + ','
				+ 'StatePoints=' + IntToStr(Badges_USAstates) + ',' + 'CountryPoints=' + IntToStr(iCountryCount) + ','
				+ 'SumCountryPoints=' + IntToStr(iSumCountryPoints) + ','
				+ 'CacheOwnType=' + IntToStr(iOwnType) + ',' + 'HDistPoints='  + IntToStr(iOwnType * 2) + ','
				+ 'CacheOwnBSize=' + IntToStr(iOwnSize) + ',' + 'HSizePoints='  + IntToStr(iOwnSize * 2) + ','; 
			//Log('BELT Param: ' + sBeltPoints);
			Log('BELT Sum: ' + FlToStr(CalcBG_INI.eSumPoints));
			bStatus := Badges_BeltsII(aParams, Badges_H.sHtmlBelt, Badges_H.sHtmlBeltInf);
		end;
		//------------------------------------------------------------------------------------------
		//VSTUP------------------------------------------------------------------------------------
		//------------------------------------------------------------------------------------------
		//Pprava----------------------------------------------------------------------------------
		sShow := '';
		iSection := 0;
		OldID := GlobalVarGet('IdElement',false);
		iRowCount := trunc((iWidth / CalcBG_INI.iBadgeSize) - 0.5);
		//------------------------------------------------------------------------------------------
		aTmpParams.Clear;
		aTmpParams.Values['Title'] := _('Awarded Badges');
		aTmpParams.Values['Open'] := 'Yes';
		sCacheData := ProcessFrameStart(OldID,aTmpParams) + '<div style="text-align:center;">';
		//
		spre := '';
		spost := '<br />';
		//
		//inicializace pro ed odznaky-------------------------------------------------------------
		//zvren html dodatky--------------------------------------------------------------------
		if CalcBG_INI.bFlagsSeparetly then begin
			if not CalcBG_INI.sIsFlagCompact {CalcBG_INI.sIsFlagCompact = '0'} then begin
				Badges_LevelOutputSep(Badges_H.sHtmlDf, CalcBG_INI.iLevel, 7, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlEf, CalcBG_INI.iLevel, 6, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlSaf, CalcBG_INI.iLevel, 5, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlRf, CalcBG_INI.iLevel, 4, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlPf, CalcBG_INI.iLevel, 3, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlGf, CalcBG_INI.iLevel, 2, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlSf, CalcBG_INI.iLevel, 1, sflag, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlBf, CalcBG_INI.iLevel, 0, sflag, sShow);
			end
			else begin
				sflag := sflag + spre;
				//
				Badges_LevelOutput(Badges_H.sHtmlDf, CalcBG_INI.iLevel, 7, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlEf, CalcBG_INI.iLevel, 6, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlSaf, CalcBG_INI.iLevel, 5, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlRf, CalcBG_INI.iLevel, 4, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlPf, CalcBG_INI.iLevel, 3, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlGf, CalcBG_INI.iLevel, 2, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlSf, CalcBG_INI.iLevel, 1, sflag, sShow);
				Badges_LevelOutput(Badges_H.sHtmlBf, CalcBG_INI.iLevel, 0, sflag, sShow);
				//
				sflag := sflag + spost;
			end;
		end;
		case CalcBG_INI.sIsCompact of
			'0': begin		//Separovan jednotliv druhy
				Badges_LevelOutputSep(Badges_H.sHTMLBP, CalcBG_INI.iLevel, 7, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlD, CalcBG_INI.iLevel, 7, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlE, CalcBG_INI.iLevel, 6, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlSa, CalcBG_INI.iLevel, 5, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlR, CalcBG_INI.iLevel, 4, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlP, CalcBG_INI.iLevel, 3, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlG, CalcBG_INI.iLevel, 2, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlS, CalcBG_INI.iLevel, 1, sCacheData, sShow);
				Badges_LevelOutputSep(Badges_H.sHtmlB, CalcBG_INI.iLevel, 0, sCacheData, sShow);
			end;
			'1': begin		//Kompaktn odznky
				sCacheData := sCacheData + spre;
				sShow := sShow + spre;
				
				//
				Badges_LevelOutput(Badges_H.sHTMLBP, CalcBG_INI.iLevel, 7, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlD, CalcBG_INI.iLevel, 7, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlE, CalcBG_INI.iLevel, 6, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlSa, CalcBG_INI.iLevel, 5, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlR, CalcBG_INI.iLevel, 4, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlP, CalcBG_INI.iLevel, 3, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlG, CalcBG_INI.iLevel, 2, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlS, CalcBG_INI.iLevel, 1, sCacheData, sShow);
				Badges_LevelOutput(Badges_H.sHtmlB, CalcBG_INI.iLevel, 0, sCacheData, sShow);
				
				sShow := sShow + spost;
				sCacheData := sCacheData + spost;				
			end;
			else begin		//sten zkompaktizovno (jen ty co se vejdou na jeden dek)
				SetLength(Compact, 9);
				Compact[0].HTML := Badges_H.sHTMLBP; Compact[0].Count := Badges_H.iBPCount;
				Compact[1].HTML := Badges_H.sHtmlD; Compact[1].Count := Badges_H.iDCount;
				Compact[2].HTML := Badges_H.sHtmlE; Compact[2].Count := Badges_H.iECount;
				Compact[3].HTML := Badges_H.sHtmlSa; Compact[3].Count := Badges_H.iSaCount;
				Compact[4].HTML := Badges_H.sHtmlR; Compact[4].Count := Badges_H.iRCount;
				Compact[5].HTML := Badges_H.sHtmlP; Compact[5].Count := Badges_H.iPCount;
				Compact[6].HTML := Badges_H.sHtmlG; Compact[6].Count := Badges_H.iGCount;
				Compact[7].HTML := Badges_H.sHtmlS; Compact[7].Count := Badges_H.iSCount;
				Compact[8].HTML := Badges_H.sHtmlB; Compact[8].Count := Badges_H.iBCount;
				j := 0; spomhtml := ''; sxhtml :='';
				For i:=0 to 8 do begin
					if (CalcBG_INI.iLevel+1 <= 8-i) then begin
						j := j + Compact[i].Count;
						spomhtml := spomhtml + Compact[i].HTML;
						if j > iRowCount then begin
							sCacheData := sCacheData + spre + sxhtml + spost;
							spomhtml := Compact[i].HTML;
							j := Compact[i].Count;
						end;
						sxhtml := spomhtml;
					end
					else begin
						sShow := sShow + spre + Compact[i].HTML + spost;
					end;
				end;
				if sxhtml <> '' then 
					sCacheData := sCacheData + spre + sxhtml + spost;
				SetLength(Compact, 0);
			end;
		end;
		sCacheData := sCacheData + '</div>' + ProcessFrameEnd();
		Output(sCacheData);					//ODZNACKY
		Inc(iSection);		
		//------------------------------------------------------------------------------------------Odznaky End
		//Vlajky oddlen
		if (CalcBG_INI.bFlagsSeparetly) and (sflag <> '') then begin
			aTmpParams.Clear;
			aTmpParams.Values['Title'] := _('Flags & Continents');
			aTmpParams.Values['Open'] := 'Yes';
			//--------------------------------------------------
			GlobalVarSet('IdElement',OldID + Badges_IDSection(iSection));
			sCacheData := ProcessFrameStart(GlobalVarGet('IdElement',false), aTmpParams)
						+ '<div style="text-align:center;">'
						+ sflag + '</div>' + ProcessFrameEnd();
			Output(sCacheData);			//VLAJKY ODDELENE JSOU-LI
			Inc(iSection);
		end;	
		//------------------------------------------------------------------------------------------Vlajky End
		if sShow <> '' then						//je-li nco nezobrazenho ??
			sgray := sShow + Badges_H.sHtmlGray	//Nezobrazen + Gray
		else
			sgray := Badges_H.sHtmlGray;		//Jenom Gray
		//--------------------------------------------------------------------------	
		if (CalcBG_INI.bShowGrey) and (sGray <> '') then begin
			aTmpParams.Clear;
			if CalcBG_INI.iLevel = 0 then
				aTmpParams.Values['Title'] := _('Not rated Badges')
			else
				aTmpParams.Values['Title'] := _('Not shown & Not rated Badges');
			aTmpParams.Values['Open'] := 'No';
			//--------------------------------------------
			GlobalVarSet('IdElement',OldID + Badges_IDSection(iSection));
			sCacheData := ProcessFrameStart(GlobalVarGet('IdElement',false), aTmpParams)
						+ '<div style="text-align:center;">'
						+ sGray + '</div>' + ProcessFrameEnd();
			Output(sCacheData);				//ED NEAKTIVN JSOU-LI
			Inc(iSection);
		end;
		//------------------------------------------------------------------------------------------Gray End
		if CalcBG_INI.bIsBelt then begin
			aTmpParams.Clear;
			aTmpParams.Values['Title'] := _('Belt');
			aTmpParams.Values['Open'] := 'Yes';
			//--------------------------------------------
			GlobalVarSet('IdElement',OldID + Badges_IDSection(iSection));
			sCacheData := ProcessFrameStart(GlobalVarGet('IdElement',false), aTmpParams)
						+ '<div align="center">'
						+ Badges_H.sHtmlBelt + '</div>' + ProcessFrameEnd();
			Output(sCacheData);				//PSEK
			Inc(iSection);
		end;
		//------------------------------------------------------------------------------------------Belt End
		if CalcBG_INI.bIsInfo then begin
			aTmpParams.Clear;
			if CalcBG_INI.bIsBelt then
				aTmpParams.Values['Title'] := _('Badges & Belt Information')
			else
				aTmpParams.Values['Title'] := _('Badges Information');
			aTmpParams.Values['Open'] := 'No';
			//--------------------------------------------			
			GlobalVarSet('IdElement',OldID + Badges_IDSection(iSection));
			SaveWidth('Frame');
			sCacheData := ProcessFrameStart(GlobalVarGet('IdElement',false), aTmpParams);
			sCacheData := sCacheData + '<div style="text-align:center;">'
						+ Badges_H.sHtmlBPi + Badges_H.sHtmlDi + Badges_H.sHtmlEi + Badges_H.sHtmlSai
						+ Badges_H.sHtmlRi + Badges_H.sHtmlPi + Badges_H.sHtmlGi
						+ Badges_H.sHtmlSi + Badges_H.sHtmlBi + Badges_H.sHtmlGrayi
						+ Badges_H.sHtmlBeltInf
						+ '</div>' + ProcessFrameEnd();			
			Output(sCacheData);				//INFO
			RestoreWidth('Frame');
			Inc(iSection);
		end;
		//------------------------------------------------------------------------------------------Info End
		//konec html--------------------------------------------------------------------------------
		GlobalVarSet('IdElement',OldID);
		//SAVE Output
		Output(Badges_Footer);
		Result := '';
		//------------------------------------------------------------------------------------------
		//Vyist Zbytky a uzave-------------------------------------------------------------------
		//------------------------------------------------------------------------------------------
	finally
		aParams.Free;
		aTmpParams.Free;
	end;
end;