var CalcIso3166_sGsCountries:string;  //nacteny soubor gsiso3166.tab prevedeny na ASCII

//uvolnovaci funkce modulu
procedure CalcIso3166_Free;
begin
  Log('Start CalcIso3166_Free()');
  CalcIso3166_sGsCountries:='';
end;

procedure CalcIso3166_GetCountries;
begin
  if(CalcIso3166_sGsCountries='') then begin  //nacteme soubor
    CalcIso3166_sGsCountries:=CRLF+UtfToAscii(FileToString(GEOGET_DATADIR+'/gsiso3166.tab'))+CRLF;
  end;
end;

//funkce najde v souboru gsiso3166.tab jmeno statu a vrati jeho zkratku
//protoze ne vsechny znaky z jinych statu jdou prevest na ANSI,
//funkce porovnava jmena statu prevedena na ciste ASCII
//pokud nebude stat nalezen, vrati '??' a zapise varovani do logu
function CalcIso3166_GetGsCountryAbbr(sCountry:string):string;
var iPos:integer; 
begin
  CalcIso3166_GetCountries();
  Result:='??';
  sCountry:=UtfToAscii(sCountry);
  iPos:=Pos(Chr($09)+sCountry+CRLF,CalcIso3166_sGsCountries); //oddelovac mezi zkratkou a jmenem statu
  if(iPos>0) then begin
    iPos:=iPos-2;                                //pravdepodobny pocatek zkratky
    Result:=CalcIso3166_sGsCountries[iPos]+CalcIso3166_sGsCountries[iPos+1];
    //osetrime pripad vicepismennych zkratek
    while((iPos>1) and (CalcIso3166_sGsCountries[iPos-1]>Chr($0D))) do begin
      Result:=CalcIso3166_sGsCountries[iPos-1]+Result;
      Dec(iPos);
    end;
  end;
  if(Result='??') then Log('CalcIso3166: ERR: "'+sCountry+'" not found.');
end;

//funkce najde v souboru gsiso3166.tab zkratku statu a vrati jeho jmeno
//pokud nebude zkratka nalezena, vrati '??' a zapise varovani do logu
function CalcIso3166_GetGsCountryName(sAbbr:string):string;
var iPos:integer;
    s:string;
begin
  CalcIso3166_GetCountries();
  Result:='??';
  s:=CRLF+sAbbr+Chr($09);
  iPos:=Pos(s,CalcIso3166_sGsCountries); //oddelovac mezi zkratkou a jmenem statu
  if(iPos>0) then begin
    iPos:=iPos+Length(s);
    Result:='';
    //prepiseme vsechny znaky jmena
    while(CalcIso3166_sGsCountries[iPos]>=' ') do begin
      Result:=Result+CalcIso3166_sGsCountries[iPos];
      Inc(iPos);
    end;
  end;
  if(Result='??') or (Result='') then Log('CalcIso3166: ERR: "'+sAbbr+'" not found.');
end;

//hlavni funkce modulu
function CalcIso3166_Run(aPar:TStringList):string;
begin
  Result:='';
  Log('Start CalcIso3166_Run()');
  //registrovat funkce (nepotrebujeme uvolnovat pamet, tak staci, ze je pridany modul s funkci)
  //GlobalVarRegisterReplaceFunction('CalcIso3166_GetGsCountryAbbr',@CalcIso3166_GetGsCountryAbbr);
  //GlobalVarRegisterReplaceFunction('CalcIso3166_GetGsCountryName',@CalcIso3166_GetGsCountryName);
  Log('End of CalcIso3166_Run()');
end;
