// Histogram dennho potu nlez

function DailyFindsHistogram_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    i,iSum,iMax,iBars,iHeightGr,iWidthGr,iBarSp,iBarWd,iStepLabels:integer;
    s,sData,sLabels,sSql,sOne,sMore:string;
    aData:TStringList;
    sEData,sENames:string;
begin
  // rozmry a parametry grafu
  iHeightGr:=250;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  iBars:=50;                                  // poet sloupc histogramu
  iBarSp:=1;                                  // mezera mezi bary histogramu
  iBarWd:=Trunc((iWidthGr-30)/iBars)-iBarSp;  // ka baru histogramu
  iStepLabels:=2;                             // krok popisk vodorovn osy
  if iWidthGr<400 then iStepLabels:=5;

  // pprava dat pro graf
  aData:=TStringList.Create();
  sSql:='SELECT count(*) as DaysCount, DailyFounds FROM'
       +'  (SELECT count(*) as DailyFounds FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql
       +'   GROUP BY dtfound ORDER BY DailyFounds ASC)'
       +'GROUP BY DailyFounds';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      aData.Add(tab.FieldByName['DailyFounds']+'='+tab.FieldByName['DaysCount']);
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  for i:=2 to iBars do begin
    s:=aData.Values[IntToStr(i)];
    if s='' then s:='0';
    sEData:=sEData+s+CRLF;
    sENames:=sENames+IntToStr(i)+CRLF;
    if(sData='') then
      sData:=s else sData:=sData+','+s;
    if (i mod iStepLabels)=0 then
      sLabels:=sLabels+'|'+IntToStr(i) else sLabels:=sLabels+'|';
    if StrToInt(s)>iMax then iMax:=StrToInt(s);
  end;
  // poet dn jen s jednm nlezem a s vce ne iBars nlezy
  sOne:=aData.Values['1'];
  for i:=0 to aData.Count-1 do begin
    if StrToInt(aData.Names[i])>iBars then begin
      s:=aData.Values[IntToStr(i)];
      if s<>'' then iSum:=iSum+StrToInt(s);
    end;
  end;
  if iSum>0 then sMore:=IntToStr(iSum);

  // finln akce
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  // poznmka pod grafem
  s:='';
  if (sOne+sMore)<>'' then s:='%GeogetOwner%';
  if sOne<>'' then s:=s+' '+_('has also')+' '+sOne+' '+_('days with one find');
  if sMore<>'' then s:=s+' '+_('and')+' '+sMore+' '+_('days with more than')+' '+IntToStr(iBars)+' '+_('finds.');
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',
    _('Days with {b} find(s): {c}'),true,false,iWidth,250)             
    +'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  Output(Result);
  Result:='';
  // klid
  if(aData<>nil) then aData.Free();
end;