//hlavni funkce modulu
function DifficultyTerrain_DT(aPar:TStringList;cachetype:string):string;
var
  sOld,s,sStyle,sSql:string;
  tab: TSqliteTable;
  a:array [0..10*10-1] of integer;
  aDiffSuma:array[0..9] of integer;
  i,n,dif,ter,nMax,nMaxDiff,nMaxTerr:integer;
  sTabId,sTabIdNext,sDispl:string;
  bCond:boolean;
begin
  Result:='';
  // pepna zenho vpisu tabulky
  i:=Geoget_DB.GetTableValue('SELECT count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar));
  bCond:=((iWidth<700) or (i>4000));
  //inicializace poli
  s:=copy(cachetype,1,1);
  sTabId:='i'+GlobalVarGet('IdElement',false)+'_Tab'+s;
  sDispl:=' display:none;';
  case s of
  'T':  sTabIdNext:='i'+GlobalVarGet('IdElement',false)+'_TabM';
  'M':  sTabIdNext:='i'+GlobalVarGet('IdElement',false)+'_TabU';
  'U':  sTabIdNext:='i'+GlobalVarGet('IdElement',false)+'_Tab';
  else sTabIdNext:='i'+GlobalVarGet('IdElement',false)+'_TabT';
  end;
  if(cachetype<>'') then s:=' AND gc.cachetype='''+cachetype+''''
  else begin s:=''; sDispl:=''; end;
  for n:=0 to 10*10-1 do a[n]:=0;
  for n:=0 to 9 do aDiffSuma[n]:=0;
  sSql:='SELECT count(DT) pocet,DT FROM'
    +' (select (2*difficulty-2)||";"||(2*terrain-2) as DT '
    +'   FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+s
    +SetSqlFilter(aPar)
    +') x'
    +' group by DT'
    +' order by DT';
  //Log('SQL='+sSql);
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do
    begin
      n:=tab.FieldAsInteger(0);
      if(n>nMax) then nMax:=n;
      s:=tab.FieldAsString(1);
      sOld:=Fetch(s,';');
      dif:=StrToInt(Fetch(sOld,'.'));
      ter:=StrToInt(Fetch(s,'.'));
      a[dif*10+ter]:=n;
      tab.Next();
    end;
  finally
    tab.free;
  end;

  //nastavime velikost pisma tabulky, pokud je to potreba
  sOld:=GlobalVarGet('StyleTableMatrix',false);
  s:=aPar.Values['FontSize'];
  if(s<>'') then begin
    sOld:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOld,'font-size:'+s+'px',false);
  end;
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  sOld:=ReplaceString(sOld,'%Width%',IntToStr(iWidth));
  Result:=Result+'<div id="'+sTabId+'" style="'+sDispl+'">'+CRLF
    +'<table style="'+sOld+'">'+CRLF;

  //vytvorime vystupni tabulku
  sOld:=GlobalVarGet('ColumnHeaderDifficulty',false);
  s:=sOld;
  if bCond then begin //udelame svisly text
    s:='';
    for n:=1 to Length(sOld) do begin
      s:=s+'&nbsp;'+sOld[n]+'&nbsp;<br />';
    end;
  end;
  Result:=Result
    +'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh1%">&nbsp;</th><th colspan=11 style="%StyleTableMatrixTh1%">%ColumnHeaderTerrain%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'
    +'    <th rowspan=12 style="%StyleTableMatrixTh1Down%">'+s+'</th>'
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th>'
    +'    <th style="%StyleTableMatrixTh2%">1</th>'
    +'    <th style="%StyleTableMatrixTh2%">1.5</th><th style="%StyleTableMatrixTh2%">2</th>'
    +'    <th style="%StyleTableMatrixTh2%">2.5</th><th style="%StyleTableMatrixTh2%">3</th>'
    +'    <th style="%StyleTableMatrixTh2%">3.5</th><th style="%StyleTableMatrixTh2%">4</th>'
    +'    <th style="%StyleTableMatrixTh2%">4.5</th><th style="%StyleTableMatrixTh2%">5</th>'
    +'<th style="%StyleTableMatrixTh2%">&sum;&nbsp;<button style="cursor:pointer; margin:2px 2px 5px 2px;" onclick="'
      +'document.getElementById('''+sTabId+''').style.display=''none'';'
      +'document.getElementById('''+sTabIdNext+''').style.display=''block'';'
    +'">';
  if(cachetype<>'') then Result:=Result+'<img style="vertical-align:bottom;" src="%IconCacheTypeSmall'+cachetype+'%" />'
  else Result:=Result+_('All');
  Result:=Result+'</button></th>'
    +'  </tr>'+CRLF;
  //vypocteme soucty radku a sloupcu
  nMaxDiff:=0;
  nMaxTerr:=0;
  for dif:=0 to 8 do begin
    n:=0;
    for ter:=0 to 8 do begin
      n:=n+a[dif*10+ter];
      aDiffSuma[ter]:=aDiffSuma[ter]+a[dif*10+ter];
      if(nMaxTerr<aDiffSuma[ter]) then nMaxTerr:=aDiffSuma[ter];
    end;
    aDiffSuma[9]:=aDiffSuma[9]+n;
    if(nMaxDiff<n) then nMaxDiff:=n;
  end;
  //ShowMessage('nMaxDiff='+IntToStr(nMaxDiff)+', nMaxTerr='+IntToStr(nMaxTerr));
  for dif:=0 to 8 do begin
    n:=0;
    Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">'+FormatFloatDot('0.#',(1.0+0.5*dif))+'</th>'+CRLF;
    for ter:=0 to 8 do begin
      n:=n+a[dif*10+ter];
      if(a[dif*10+ter]=0) then Result:=Result+'    <td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else begin
        if(a[dif*10+ter]=nMax) and (GlobalVarGet('StyleTableMatrixTdMaxValueText',true)<>'') then begin
          Result:=Result+'    <td style="%StyleTableMatrixTdMaxValue% background:#'
            +ScaleColor(a[dif*10+ter],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[dif*10+ter])+'</td>'+CRLF;
        end
        else begin Result:=Result+'    <td style="%StyleTableMatrixTd% background:#'
          +ScaleColor(a[dif*10+ter],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
          +'">'+IntToStr(a[dif*10+ter])+'</td>'+CRLF;
        end;
      end;
    end;
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(n=nMaxDiff) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(n)+'</th>'+CRLF+'  </tr>'+CRLF;
  end;
  //doplnime soucty poctu terenu
  Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  for ter:=0 to 9 do begin
    //ve stylu nahradime barvu textu za barvu maximalniho textu
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(aDiffSuma[ter]=nMaxTerr) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    //Result:=Result+'    <th style="%StyleTableMatrixTh2%">'+IntToStr(aDiffSuma[ter])+'</th>'+CRLF
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(aDiffSuma[ter])+'</th>'+CRLF
  end;
  Result:=Result+'  </tr>'+CRLF;
  Result:=Result+'</table>'+CRLF;
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //zjistime pocet kombinaci
    n:=0;
    for ter:=0 to 8 do begin
      for dif:=0 to 8 do begin
        if(a[dif*10+ter]>0) then Inc(n);
      end;
    end;
    s:=ReplaceString(s,'%FoundCount%',IntToStr(n));
    s:=ReplaceString(s,'%AllCount%',IntToStr(366));
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
 end;
 Result:=Result+'</div>'+CRLF;
end;

function DifficultyTerrain_Run(aPar:TStringList):string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Result:=Result+DifficultyTerrain_DT(aPar,'')+ //vsechny typy kesi
    DifficultyTerrain_DT(aPar,'Traditional Cache')+         //jen tradicky
    DifficultyTerrain_DT(aPar,'Multi-cache')+         //jen multiny
    DifficultyTerrain_DT(aPar,'Unknown Cache');      //jen mysterky
end;
