//hlavni funkce modulu
function FindsByCreated_Run(aPar:TStringList):string;
var
  s,sOld,sSql,sStyle:string;
  tab: TSqliteTable;
  a:array [0..12*50] of integer;  //na 50 let, to by melo chvili stacit
  aMonthSuma:array[0..12] of integer;
  aMonthName:array [0..11] of string;
  i,n,rok,mes,rokMax,nMax,nMaxRok,nMaxMes,rokAkt,mesAkt:integer;
  bCond:boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  // pepna zenho vpisu tabulky
  i:=Geoget_DB.GetTableValue('SELECT count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar));
  bCond:=((iWidth<700) or (i>4000));
  //inicializace poli
  rokAkt:=StrToInt(FormatDateTime('yyyy',Now()))-2000;
  mesAkt:=StrToInt(FormatDateTime('m',Now()))-1;
  for rok:=0 to 50-1 do begin
    for mes:=0 to 11 do begin
      a[rok*12+mes]:=0;
      if (rok=0) and (mes<4) or (rok=rokAkt) and (mes>mesAkt) then a[rok*12+mes]:=-1; 
    end;
  end;
  for n:=0 to 12 do aMonthSuma[n]:=0;
  //z databaze nacteme data - pocty nalezu podle roku a mesice zalozeni
  sSql:=    'SELECT count(rok_mes) pocet,rok_mes FROM'
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho den v tydnu a prevedeme tak, aby 0 bylo pondeli
    +'  (SELECT substr(dthidden,1,4)||";"||substr(dthidden,5,2) as rok_mes FROM geocache gc WHERE gc.dtfound>0 AND '
      +sCachePrefixForSql+SetSqlFilter(aPar)
      +') x'
    +' group by rok_mes'
    +' order by rok_mes';
  Log('SQL='+sSql);
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    rokMax:=0;
    nMax:=0;
    while not tab.eof do begin
      n:=tab.FieldAsInteger(0);
      if(n>nMax) then nMax:=n;
      s:=tab.FieldAsString(1);
      sOld:=s;
      rok:=StrToInt(Fetch(s,';'))-2000;
      if(rok>rokMax) then rokMax:=rok;
      if(rok<0) then begin
        Log('ERR: nalezena cache s nesmyslnym datem zalozeni ('+sOld+')');
        Log('WARN: nastaven rok 2000');
        rok:=0;
      end;
      mes:=StrToInt(s)-1;
      a[rok*12+mes]:=n;
      tab.Next();
    end;
  finally
    tab.free;
  end;
  n:=StrToInt(FormatDateTime('yyyy',Now()))-2000;
  if rokMax<n then rokMax:=n;

  if bCond then begin
    aMonthName[0]:='Jan';   aMonthName[1]:='Feb';     aMonthName[2]:='Mar';
    aMonthName[3]:='Apr';   aMonthName[4]:='Ma';      aMonthName[5]:='Jun';
    aMonthName[6]:='Jul';   aMonthName[7]:='Aug';     aMonthName[8]:='Sep';
    aMonthName[9]:='Oct';   aMonthName[10]:='Nov';    aMonthName[11]:='Dec';
  end else begin
    aMonthName[0]:='January'; aMonthName[1]:='February';  aMonthName[2]:='March';
    aMonthName[3]:='April';   aMonthName[4]:='May';       aMonthName[5]:='June';
    aMonthName[6]:='July';    aMonthName[7]:='August';    aMonthName[8]:='September';
    aMonthName[9]:='October'; aMonthName[10]:='November'; aMonthName[11]:='December';
  end;
  //vytvorime vystupni tabulku
  //nastavime velikost pisma tabulky, pokud je to potreba
  sOld:=GlobalVarGet('StyleTableMatrix',false)
  s:=aPar.Values['FontSize'];
  if(s<>'') then begin
    sOld:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOld,'font-size:'+s+'px',false);
  end;
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  sOld:=ReplaceString(sOld,'%Width%',IntToStr(iWidth));
  Result:=Result+'<table style="'+sOld+'">'+CRLF;

  //naformatujeme levy slopecek s titulkem, pokud je potreba
  //sOld:=GlobalVarGet('ColumnHeaderYear',false);
  //s:=sOld;
  //if bCond then begin //udelame svisly text
  //  s:='';
  //  for n:=1 to Length(sOld) do begin
  //    s:=s+'&nbsp;'+sOld[n]+'&nbsp;<br />';
  //  end;
  //end;
  Result:=Result
    +'  <tr style="%StyleTableMatrixTr%">'
    //+'<th style="%StyleTableMatrixTh1%">&nbsp;</th>'
    +'<th colspan=14'
      +IntToStr(rokMax+3)+' style="%StyleTableMatrixTh1%">%ColumnHeaderMonth%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'
    //+'    <th rowspan='+IntToStr(rokMax+3)+' style="%StyleTableMatrixTh1Down%">'+s+'</th>'
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th>';
  for n:=0 to 11 do Result:=Result+'    <th style="%StyleTableMatrixTh2%">%Month'+aMonthName[n]+'%</th>';
  Result:=Result+'    <th style="%StyleTableMatrixTh2%">&sum;</th></tr>'+CRLF;
  //zjistime maximalni hodnoty
  nMaxRok:=0;
  nMaxMes:=0;
  for rok:=0 to rokMax do begin
    n:=0;
    for mes:=0 to 11 do begin
      if a[rok*12+mes]>0 then begin
        n:=n+a[rok*12+mes];
        aMonthSuma[mes]:=aMonthSuma[mes]+a[rok*12+mes];
      end;
      if(nMaxMes<aMonthSuma[mes]) then nMaxMes:=aMonthSuma[mes];
    end;
    aMonthSuma[12]:=aMonthSuma[12]+n;
    if(nMaxRok<n) then nMaxRok:=n;
  end;
  //ShowMessage('nMaxRok='+IntToStr(nMaxRok)+', nMaxMes='+IntToStr(nMaxMes));
  for rok:=0 to rokMax do begin
    n:=0;
    Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">'+IntToStr(2000+rok)+'</th>'+CRLF;
    for mes:=0 to 11 do begin
      if a[rok*12+mes]>0 then begin
        n:=n+a[rok*12+mes];
      end;
      if(a[rok*12+mes]=0) then Result:=Result+'    <td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else if(a[rok*12+mes]=-1) then Result:=Result+'    <td style="%StyleTableMatrixTh2%">&nbsp;</td>'+CRLF
      else begin
        if(a[rok*12+mes]=nMax) and (GlobalVarGet('StyleTableMatrixTdMaxValueText',true)<>'') then begin
          Result:=Result+'    <td style="%StyleTableMatrixTdMaxValue% background:#'
            +ScaleColor(a[rok*12+mes],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[rok*12+mes])+'</td>'+CRLF;
        end
        else begin Result:=Result+'    <td style="%StyleTableMatrixTd% background:#'
          +ScaleColor(a[rok*12+mes],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
          +'">'+IntToStr(a[rok*12+mes])+'</td>'+CRLF;
        end;
      end;
    end;
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(n=nMaxRok) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(n)+'</th>'+CRLF+'  </tr>'+CRLF;
    //Result:=Result+'    <th style="%StyleTableMatrixTh2%">'+IntToStr(n)+'</th></tr>'+CRLF;
  end;
  //doplnime mesicni soucty
  Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  for mes:=0 to 12 do begin
    //ve stylu nahradime barvu textu za barvu maximalniho textu
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(aMonthSuma[mes]=nMaxMes) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(aMonthSuma[mes])+'</th>'+CRLF
  end;
  Result:=Result+'  </tr>'+CRLF;
  Result:=Result+'</table>'+CRLF;
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //zjistime pocet kombinaci
    n:=0;
    for rok:=0 to rokMax do begin
      for mes:=0 to 11 do begin
        if(a[rok*12+mes]>0) then Inc(n);
      end;
    end;
    s:=ReplaceString(s,'%FoundCount%',IntToStr(n));
    n:=12-StrToInt(FormatDateTime('m',Now()));
    s:=ReplaceString(s,'%AllCount%',IntToStr(rokMax*12+8-n));   // osm je mesicu v roce 2000
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;