function FindsBySize_Run(aPar:TStringList):string;
var aTmpPar:TStringList;
    tab: TSqliteTable;
    s,s1,sSql,sType,sColumns,sPieDisp,sTableDisp,sID:string;
    //sPlotlyData,sPlotlyLayout,sPlotlyLabels,sPlotlyColors:string;
    sEData,sELabels:string;
    i:integer;
    bSwitch:boolean;
begin
  Result:='';
  s:=aPar.Values['OutputType'];
  sType:=Fetch(s,'-');
  bSwitch:=(aPar.Values['SwitchType']='Yes');
  sID:='ID'+IntToStr(iItem);
  if(sType='Table') then begin
    sPieDisp:='none'; sTableDisp:=''; 
  end else begin
    sPieDisp:=''; sTableDisp:='none';
  end;
  if bSwitch then
    aPar.Values['Title']:=aPar.Values['Title']+'&nbsp;'
        +'<button id="'+sID+'TableB" style="cursor:pointer; display:'+sTableDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'TableB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Table'').style.display=''none'';'
        +'document.getElementById('''+sID+'PieB'').style.display='''';'
        +'document.getElementById('''+sID+'Pie'').style.display='''';'
        +'" title="'+_('Switch to pie chart')+'">'
        +'<img src="%IconLayoutChartPie%"></button>'
        +'<button id="'+sID+'PieB" style="cursor:pointer; display:'+sPieDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'PieB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Pie'').style.display=''none'';'
        +'document.getElementById('''+sID+'TableB'').style.display='''';'
        +'document.getElementById('''+sID+'Table'').style.display='''';'
        +'" title="'+_('Switch to histogram')+'">'
        +'<img src="%IconLayoutList%"></button>';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  aTmpPar:=TStringList.Create();
  try
    //pripravime parametry
    s1:=aPar.Values['SortBy'];
    s:=Fetch(s1,'-');
    if(s='Size') then sColumns:='Size icon|Size as num=Center;Cnt;Asc|Count|Percent|Histogram'
    else sColumns:='Size icon|Size=Center;Cnt|Count=;Desc|Percent|Histogram';
    aTmpPar.Text:='Columns='+sColumns+CRLF
                 +'FoundOnly=Yes'+CRLF
                 +'UseFilter='+aPar.Values['UseFilter']+CRLF;
    //vytvorime SQL
    sSql:=TableListMakeSqlFromParams(aTmpPar,true,'',i);
    aTmpPar.Text:='';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      while not tab.eof do begin
        aTmpPar.Add(tab.FieldAsString(0));
        aTmpPar.Add(tab.FieldAsString(1));
        aTmpPar.Add(tab.FieldAsString(2));
        aTmpPar.Add(tab.FieldAsString(3));
        aTmpPar.Add(tab.FieldAsString(4));
        //pro kolacovy graf pridavame jen pocet a label
        s:=tab.FieldAsString(1);
        //pokud je na zacatku cislo (zobarazovana velikost), musime jej odstranit,
        //ale pozor na viceslovny 'Not choosen'
        if(s[1]>='0') and (s[1]<='9') then begin
          s1:=Fetch(s,' ');
          if(s='') then s:=s1;
        end;
{$ifdef DEBUG_HELPER} LDH(tab.FieldAsString(1)+'->s[1]='+s[1]+', s='+s+', s1='+s1); {$endif}
        //----------------data pro Plotly
        //sPlotlyLabels:=sPlotlyLabels+''''+s+''''+CRLF;
        //sPlotlyData:=sPlotlyData+tab.FieldAsString(2)+CRLF;
        //----------------data pro ECharts
        sELabels:=sELabels+s+CRLF;
        sEData:=sEData+tab.FieldAsString(2)+CRLF;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //---------------- data pro Plotly
    //sPlotlyColors:=PieScaleRGBColors(sPlotlyData);
    //sPlotlyData:='    values:['+ReplaceString(Trim(sPlotlyData),CRLF,',')+'],'+CRLF
    //  +'    labels:['+ReplaceString(Trim(sPlotlyLabels),CRLF,',')+'],'+CRLF
    //  +'    marker:{ colors: ['+ReplaceString(Trim(sPlotlyColors),CRLF,',')+']},'+CRLF
    //  +'    hoverinfo: ''label+value'','+CRLF //obsah zobrazeneho tooltip
    //  +'    sort: false,'+CRLF   //bez tohoto nejsou akceptovany moje barvy
    //  +'    textinfo: ''label+percent'','+CRLF
    //  //+'    textinfo: ''label'','+CRLF
    //  +'    type:''pie''';
    ////sPlotlyLayout:='    title: ''Plotly'', showlegend: false';
    //sPlotlyLayout:='    showlegend: false';
    //----------------data pro ECharts
    //---------------- z nactenych dat vytvorime vystup
    if(bSwitch)then begin       //prepinani mezi tabulkou a grafem
      Result:=Result+'<div id="'+sID+'Table" style="display:'+sTableDisp+'">'
        +OutputTableList(sColumns,aTmpPar,0,-1,2,i)+'</div>'+CRLF;
      Result:=Result+'<div id="'+sID+'Pie" style="display:'+sPieDisp+'">'
      Output(Result);
      Result:='';
      //graf pomoci ECharts
      Result:=EChartsPieChart(sId+'PieGraf',sEData,sELabels,0,SetPieHeightDefault())+'</div>'+CRLF;
      Output(Result);
      Result:='';
      //graf pomoci Plotly
      //sId:=sId+'_PLOTLY';
      //Result:=PlotlyChart(sId,sPlotlyData,sPlotlyLayout);
      //fOut.Write(Result,Length(Result));
      //Result:='';
    end else begin    //jen tabulka nebo graf
      if(sType='Table') then Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i)+CRLF
      else begin
        Output(Result);
        //graf pomoci ECharts
        Result:=EChartsPieChart(sId,sEData,sELabels,0,SetPieHeightDefault())+CRLF;
        Output(Result);
        Result:='';
        //graf pomoci Plotly
        //sId:=sId+'_PLOTLY';
        //Result:=Result+PlotlyChart(sId,sPlotlyData,sPlotlyLayout);
        //fOut.Write(Result,Length(Result));
        //Result:='';
      end;
    end;
  finally
    aTmpPar.Free();
  end;
end;
