procedure FindsByTerrain_AddEmpty(idx:integer; var aTmpPar:TStringList);
var s:string;
begin //prida k datum radek dat indexu, ktery nema zadny nalez
  s:=IntToStr((5*(2+idx))/10);
  if((idx mod 2)=1) then s:=s+'.5';
  aTmpPar.Add(s); //ikona terenu
  aTmpPar.Add(s); //teren
  aTmpPar.Add('0'); //pocet
  aTmpPar.Add('0'); //procenta
  aTmpPar.Add('0'); //histogram
end;

function FindsByTerrain_Run(aPar:TStringList):string;
var aTmpPar:TStringList;
    tab: TSqliteTable;
    s,s1,sSql,sType,sColumns,sSortBy,sPieDisp,sTableDisp,sID:string;
    sEData,sELabels:string;
    i,idx:integer;
    bArray:array[0..8] of boolean;
    bSwitch:boolean;
begin
  Result:='';
  s:=aPar.Values['OutputType'];
  sType:=Fetch(s,'-');
  bSwitch:=(aPar.Values['SwitchType']='Yes');
  sID:='ID'+IntToStr(iItem);
  if(sType='Table') then begin
    sPieDisp:='none'; sTableDisp:=''; 
  end else begin
    sPieDisp:=''; sTableDisp:='none';
  end;
  if bSwitch then
    aPar.Values['Title']:=aPar.Values['Title']+'&nbsp;'
        +'<button id="'+sID+'TableB" style="cursor:pointer; display:'+sTableDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'TableB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Table'').style.display=''none'';'
        +'document.getElementById('''+sID+'PieB'').style.display='''';'
        +'document.getElementById('''+sID+'Pie'').style.display='''';'
        +'" title="'+_('Switch to pie chart')+'">'
        +'<img src="%IconLayoutChartPie%"></button>'
        +'<button id="'+sID+'PieB" style="cursor:pointer; display:'+sPieDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'PieB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Pie'').style.display=''none'';'
        +'document.getElementById('''+sID+'TableB'').style.display='''';'
        +'document.getElementById('''+sID+'Table'').style.display='''';'
        +'" title="'+_('Switch to histogram')+'">'
        +'<img src="%IconLayoutList%"></button>';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  
  aTmpPar:=TStringList.Create();
  for i:=0 to 8 do bArray[i]:=false;
  try
    //pripravime parametry
    s1:=aPar.Values['SortBy'];
    sSortBy:=Fetch(s1,'-');
    if(sSortBy='Terrain') then sColumns:='Terrain icon|Terrain=Center;Cnt;Asc|Count|Percent|Histogram'
    else sColumns:='Terrain icon|Terrain=Center;Cnt|Count=;Desc|Percent|Histogram';
    aTmpPar.Text:='Columns='+sColumns+CRLF
                 +'FoundOnly=Yes'+CRLF
                 +'UseFilter='+aPar.Values['UseFilter']+CRLF;
    //vytvorime SQL
    sSql:=TableListMakeSqlFromParams(aTmpPar,true,'',i);
    aTmpPar.Text:='';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      idx:=0;
      while not tab.eof do begin
        s:=ReplaceString(tab.FieldAsString(0),',','.');
        i:=(Round(10.*StrToFloat(s))/5)-2; //index nacteneho terenu
        //pokud je razeno podle terenu a ne podle poctu, musime zaradit tereny bez hodnoty
        if(sSortBy='Terrain') then begin
          while(idx+1<i) do begin
            Inc(idx);
            FindsByTerrain_AddEmpty(idx,aTmpPar);
            bArray[idx]:=true;
          end;
        end;
        idx:=i;
        bArray[i]:=true;
        aTmpPar.Add(tab.FieldAsString(0));
        aTmpPar.Add(tab.FieldAsString(1));
        aTmpPar.Add(tab.FieldAsString(2));
        aTmpPar.Add(tab.FieldAsString(3));
        aTmpPar.Add(tab.FieldAsString(4));
        //pro kolacovy graf pridavame jen pocet a label
        //----------------data pro ECharts
        sELabels:=sELabels+tab.FieldAsString(1)+CRLF;
        sEData:=sEData+tab.FieldAsString(2)+CRLF;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //z nactenych dat vytvorime vystup
    if bSwitch then begin
      Result:=Result+'<div id="'+sID+'Table" style="display:'+sTableDisp+'">'
        +OutputTableList(sColumns,aTmpPar,0,-1,2,i)+'</div>'+CRLF;
      Result:=Result+'<div id="'+sID+'Pie" style="display:'+sPieDisp+'">'
      Output(Result);
      Result:=EChartsPieChart(sId+'PieGraf',sEData,sELabels,0,SetPieHeightDefault())+'</div>'+CRLF;
      Output(Result);
      Result:='';
    end else begin
      if(sType='Table') then begin
        for i:=0 to 8 do begin //pokud uz je pridano kvuli razeni podle terenu, je bArray nastaveno
          if(not bArray[i]) then FindsByTerrain_AddEmpty(i,aTmpPar);
        end;
        Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i)+CRLF
      end else begin
        Output(Result);
        Result:=EChartsPieChart(sId,sEData,sELabels,0,SetPieHeightDefault())+CRLF;
        Output(Result);
        Result:='';
      end;
    end;
  finally
    aTmpPar.Free();
  end;
end;
