//hlavni funkce modulu
function FindsByWeekDay_Run(aPar:TStringList):string;
var 
  s,sSql,sType,sOrder,sPieDisp,sTableDisp,sID:string;
  tab: TSqliteTable;
  aData:TStringList;
  sEData,sELabels:string;
  i,nRows:integer;
  bSwitch:boolean;
begin
  Result:='';
  s:=aPar.Values['OrderBy'];
  sOrder:=Fetch(s,'-');
  s:=aPar.Values['OutputType'];
  sType:=Fetch(s,'-');
  bSwitch:=(aPar.Values['SwitchType']='Yes');
  sID:='ID'+IntToStr(iItem);
  if(sType='Table') then begin
    sPieDisp:='none'; sTableDisp:=''; 
  end else begin
    sPieDisp:=''; sTableDisp:='none';
  end;
  if bSwitch then
    aPar.Values['Title']:=aPar.Values['Title']+'&nbsp;'
        +'<button id="'+sID+'TableB" style="cursor:pointer; display:'+sTableDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'TableB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Table'').style.display=''none'';'
        +'document.getElementById('''+sID+'PieB'').style.display='''';'
        +'document.getElementById('''+sID+'Pie'').style.display='''';'
        +'" title="'+_('Switch to pie chart')+'">'
        +'<img src="%IconLayoutChartPie%"></button>'
        +'<button id="'+sID+'PieB" style="cursor:pointer; display:'+sPieDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'PieB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Pie'').style.display=''none'';'
        +'document.getElementById('''+sID+'TableB'').style.display='''';'
        +'document.getElementById('''+sID+'Table'').style.display='''';'
        +'" title="'+_('Switch to histogram')+'">'
        +'<img src="%IconLayoutList%"></button>';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);

  sSql:='SELECT count(den) pocet,den FROM'
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho den v tydnu a prevedeme tak, aby 0 bylo pondeli
    +'  (SELECT ((strftime("%w",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))+6)%7) den'
    +'    FROM geocache gc where gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar)+') x'
    +' group by den';
  if(sOrder='Count') then sSql:=sSql+' order by count(den) desc'
  else sSql:=sSql+' order by den';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    aData:=TStringList.Create();
    nRows:=0;
    while not tab.eof do begin
      aData.Add('%Day'+tab.FieldAsString(1)+'%');
      aData.Add(tab.FieldAsString(0));
      adata.Add('?');
      adata.Add('?');
      //----------------data pro ECharts
      sELabels:=sELabels+GlobalVarGet('Day'+tab.FieldAsString(1),true)+CRLF;
      sEData:=sEData+tab.FieldAsString(0)+CRLF;
      Inc(nRows);
      tab.Next();
    end;
    //z nactenych dat vytvorime vystup
    if bSwitch then begin
      Result:=Result+'<div id="'+sID+'Table" style="display:'+sTableDisp+'">'
        +OutputTableList('Day|Count|Percent|Histogram',aData,0,nRows,1,i)+'</div>'+CRLF;
      Result:=Result+'<div id="'+sID+'Pie" style="display:'+sPieDisp+'">'
      Output(Result);
      Result:=EChartsPieChart(sId+'PieGraf',sEData,sELabels,0,SetPieHeightDefault())+'</div>'+CRLF;
      Output(Result);
      Result:='';
    end else begin
      if(sType='Table') then Result:=Result+OutputTableList('Day|Count|Percent|Histogram',aData,0,nRows,1,i)+CRLF
      else begin
        Output(Result);
        Result:=EChartsPieChart(sId,sEData,sELabels,0,SetPieHeightDefault())+CRLF;
        Output(Result);
        Result:='';
      end;
    end;
  finally
    tab.free;
  end;
  if(aData<>nil) then aData.Free();
end;