function MyOwnBestFinders_Run(aPar:TStringList):string; //generuje ministatistiku
var s,s1,sSql,sColumns,sCaches,sCachesSQL:string;
    tab: TSqliteTable;
    aTmpPar:TStringList;
    nRest,iWidthOld:integer;
    i,n,iFin:integer;
begin
  Result:='';
  //-------------------------------------------------------------
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //
  //vlastn kee-------------------------------------------------------------
  Log(_('INFO: Loading all caches...'));
  //ziskame SQL prikaz z parametru (to aby byl urcite stejny)
  s:=GlobalVarget('OwnedIDsForInPhrase',false);
  if(s='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: No own caches found!'));
    Log(_('ERR: No own caches found!'));
		exit;
  end;
  s:=ReplaceString(ReplaceString(s,'''',''),'"',''); //zbavime se uvozovek/apostrofu
  s:=ReplaceString(s,',',CRLF);
  //-----------------------------------------------------------------------------
  n:=0;
  while(s<>'') do begin
    s1:=Fetch(s,CRLF);
    if(sCaches<>'') then sCaches:=sCaches+',';
	sCaches:=sCaches+Fetch(s1,'-'); 				//jen GC kod bez jmena kese
	Inc(n);
  end;
  //-----------------------------------------------------------------------------
  Log('INFO: caches for MyOwnStatistic='+sCaches);
  sCachesSQL:=''''+ReplaceString(sCaches,',',''',''')+'''';
  //-----------------------------------------------------------------------------
  iFin:=10;
  if aPar.Values['Finders']<>'' then iFin:=StrToInt(aPar.Values['Finders'])/2;
  
  sSql:='SELECT count(finder),finder FROM geolog WHERE id IN ('+sCachesSQL+') '
    +'AND (type=''Found it'' OR type=''Attended'' OR type=''Webcam Photo Taken'') '
    +'AND finder<>'''+GEOGET_OWNER+''' '
    +'GROUP BY finder ORDER BY count(finder) desc, finder asc';
  //Log('SQL='+sSql);
  sColumns:='Count=Center;Desc|Finder=Left|Histogram explicit';
  aTmpPar:=TStringList.Create();
  try
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      nRest:=0;
      while not tab.eof do begin
        aTmpPar.Add(tab.FieldAsString(0));
        aTmpPar.Add(tab.FieldAsString(1));
        aTmpPar.Add('');   //sem prijde procentualni hodnota
        inc(nRest);
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //podle celkoveho poctu nalezcu vypocteme procenta a ulozime do pole
    for i:=0 to aTmpPar.Count-1 do begin
      aTmpPar[i+2]:=FloatToStr(100.*StrToFloat(aTmpPar[i])/(n+1));
      i:=i+2;
    end;
    //Log('Pocet nalezcu: '+IntToStr(nRest));
    //z nactenych dat vytvorime vystup do dvou tabulek vedle sebe
    iWidthOld:=iWidth;
    i:=StrToInt(GlobalVarGet('StyleMarginWidthColumn',false))
      +StrToInt(GlobalVarGet('StyleBorderWidthColumn',false))
      +StrToInt(GlobalVarGet('StylePaddingWidthColumn',false));
    iWidth:=Trunc(0.5*iWidth-2*i);  //nova sirka tabulky
    Result:=Result+'<table style="margin:10px auto 0px auto; border-collapse:collapse;border-spacing:2px;"><tr><td>'+CRLF
      +OutputTableList(sColumns,aTmpPar,0,iFin,2,nRest)+CRLF //(urceni sloupce -2 je pro potlaceni hlaseni chyby o neplatnem indexu)
      +'</td><td style="vertical-align:top;">'+CRLF
      +OutputTableList(sColumns,aTmpPar,iFin,iFin,2,nRest)+CRLF
      +'</td></tr></table>'+CRLF;
    iWidth:=iWidthOld;
    if(nRest>0) then Result:=Result+'<p style="text-align:center; margin-bottom:20px;">'
      +_('... and ')+IntToStr(nRest)+_(' next finders.')+'</p>';
  finally
    aTmpPar.Free();
  end;
end;
