procedure MyOwnByDifficulty_AddEmpty(idx:integer; var aTmpPar:TStringList);
var s:string;
begin //prida k datum radek dat indexu, ktery nema zadny nalez
  s:=IntToStr((5*(2+idx))/10);
  if((idx mod 2)=1) then s:=s+'.5';
  aTmpPar.Add(s); //ikona obtiznosti
  aTmpPar.Add(s); //obtiznost
  aTmpPar.Add('0'); //pocet
  aTmpPar.Add('0'); //procenta
  aTmpPar.Add('0'); //histogram
end;

function MyOwnByDifficulty_Run(aPar:TStringList):string;
var aTmpPar:TStringList;
    tab: TSqliteTable;
    s,s1,sSql,sType,sSortBy,sColumns:string;
    sEData,sELabels:string;
    i,idx:integer;
    bArray:array[0..8] of boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  for i:=0 to 8 do bArray[i]:=false;
  aTmpPar:=TStringList.Create();
  try
    //pripravime parametry
    s:=aPar.Values['OutputType'];
    sType:=Fetch(s,'-');
    s1:=aPar.Values['SortBy'];
    sSortBy:=Fetch(s1,'-');
    if(sSortBy='Difficulty') then sColumns:='Difficulty icon|Difficulty=Center;Cnt;Asc|Count=Center|Percent|Histogram'
    else sColumns:='Difficulty icon|Difficulty=Center;Cnt|Count=Center;Desc|Percent|Histogram';
    sSql:='SELECT difficulty "Difficulty icon", difficulty "Difficulty=Left;;;Cnt;Asc", count(difficulty) "Count=Center",0 "Percent", 0 "Histogram"'+CRLF
         +' FROM geocache WHERE id IN ('+GlobalVarGet('OwnedIDsForInPhrase',false)+')'+CRLF
         +' GROUP BY difficulty'+CRLF;
    if(sSortBy='Difficulty') then sSql:=sSql+' ORDER BY (0+difficulty) asc'+CRLF
    else sSql:=sSql+' ORDER BY count(difficulty) desc'+CRLF;
    aTmpPar.Text:='';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      idx:=0;
      while not tab.eof do begin
        if(sType='Table') then begin //pridame vsechny polozky
          s:=ReplaceString(tab.FieldAsString(0),',','.');
          i:=(Round(10.*StrToFloat(s))/5)-2; //index nacteneho terenu
          //pokud je razeno podle obtiznosti a ne podle poctu, musime zaradit obtiznosti bez hodnoty
          if(sSortBy='Difficulty') then begin
            while(idx<i) do begin
              MyOwnByDifficulty_AddEmpty(idx,aTmpPar);
              bArray[idx]:=true;
              Inc(idx);
            end;
          end;
          idx:=i;
          Inc(idx);
          bArray[i]:=true;
          aTmpPar.Add(tab.FieldAsString(0));
          aTmpPar.Add(tab.FieldAsString(1));
          aTmpPar.Add(tab.FieldAsString(2));
          aTmpPar.Add(tab.FieldAsString(3));
          aTmpPar.Add(tab.FieldAsString(4));
        end
        else begin //pro kolacovy graf pridavame jen pocet a label
          sELabels:=sELabels+tab.FieldAsString(1)+CRLF;
          sEData:=sEData+tab.FieldAsString(2)+CRLF;
        end;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //z nactenych dat vytvorime vystup
    if(sType='Table') then begin
      //pridame vsechny obtiznosti, ktere nemaji zadnou hodnotu
      //z nactenych dat. Pokud uz je pridano kvuli razeni podle
      //obtiznosti, je bArray nastaveno
      for i:=0 to 8 do begin
        if(not bArray[i]) then MyOwnByDifficulty_AddEmpty(i,aTmpPar);
      end;
      Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i)+CRLF
    end
    else begin
      Output(Result);
      Result:=EChartsPieChart('ID'+IntToStr(iItem),sEData,sELabels,0,SetPieHeightDefault())+CRLF;
      Output(Result);
      Result:='';
    end;
  finally
    aTmpPar.Free();
  end;
end;
