//hlavni funkce modulu
function MyOwnByMonth_Run(aPar:TStringList):string;
var s,sSql,sType,sOrder:string;
  tab: TSqliteTable;
  sEData,sELabels:string;
  aData:TStringList;
  i,nRows:integer;
begin
  Result:='';
  s:=aPar.Values['OutputType'];
  sType:=Fetch(s,'-');
  s:=aPar.Values['OrderBy'];
  sOrder:=Fetch(s,'-');
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //typy nalezovych logu, ktere nas zajimaji
  s:='(type=''Found it'' OR type=''Webcam Photo Taken''';
  if(UpperCase(aPar.Values['IncludeEvents'])='YES') then s:=s+' OR type=''Attended''';
  s:=s+')';
  sSql:='SELECT count(mesic) pocet,mesic FROM'
    //datum nalezu prevedeme mesic
    +'  (SELECT substr(dt,5,2) mesic'
    +'    FROM geolog'
    +'    WHERE id IN ('+GlobalVarGet('OwnedIDsForInPhrase',false)+') AND '+s
    +'  ) x'
    +' group by mesic';
  if(sOrder='Count') then sSql:=sSql+' order by count(mesic) desc'
  else sSql:=sSql+' order by mesic';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    aData:=TStringList.Create();
    nRows:=0;
    while not tab.eof do begin
      if(sType='Table') then begin
        aData.Add('%Month'+tab.FieldAsString(1)+'%');
        aData.Add(tab.FieldAsString(0));
        adata.Add('?');
        adata.Add('?');
      end
      else begin
        sELabels:=sELabels+GlobalVarGet('Month'+tab.FieldAsString(1),true)+CRLF;
        sEData:=sEData+tab.FieldAsString(0)+CRLF;
      end;
      Inc(nRows);
      tab.Next();
    end;
    case sType of
    'Table': begin
               Result:=Result+OutputTableList('Month|Count|Percent|Histogram',aData,0,nRows,1,i)+CRLF;
             end;
    'Pie':   begin
               Output(Result);
               Result:=EChartsPieChart('ID'+IntToStr(iItem),sEData,sELabels,0,SetPieHeightDefault())+CRLF;
               Output(Result);
               Result:='';
             end;
    else Log(_('ERR: unknown type of output: ')+s);
    end;
  finally
    tab.free;
  end;
  if(aData<>nil) then aData.Free();
end;