function SQLTable_Run(aPar:TStringList):string;
var s,s1,sColumns,sSql:string;
    i,idxCount:integer;
    n,nCols,nRows,nRest:integer;
    tab: TSqliteTable;
    aData:TStringList;
begin
  Result:='';
  idxCount:=-1;
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=ReplaceString(aPar.Values['SQL'],'%CRLF%',CRLF);
  //pokud jde o soubor, nacteme z nej SQL
  if(FileExists(s)) then s:=FileToString(s);
  sSql:=GlobalVarReplace(ReplaceString(s,'%CRLF%',CRLF));
{$ifdef DEBUG_HELPER}
  //LDH('YYYYY nactene SQL: '+sSql);
  LDH('YYYYY ANSI SQL s nahrazenymi promennymi: '+sSql);
{$endif}
  s:=aPar.Values['IndexCount'];
  idxCount:=StrToInt(s);
{$ifdef DEBUG_HELPER}
  LDH('YYYYY s='+s+', idxCount='+IntToStr(idxCount));
{$endif}
  if((idxCount<0) or (s='')) then idxCount:=-1;
  //vykoname prikaz a nacteme data
  Log('SQL='+sSql);
  tab:=Geoget_DB.GetTable((sSql), false);
  Log('Stop SQL');
  aData:=TStringList.Create();
  try
    //zjistime jmena sloupcu
    nCols:=tab.ColCount;
    sColumns:='';
    for i:=0 to nCols-1 do begin
      if(i>0) then sColumns:=sColumns+'|';
      //protoze SQL neprevede znaky s diakritikou na velka pismena, musime je
      //prevest explicitne
      sColumns:=sColumns+AnsiUpperCase((tab.Columns[i]));
    end;
    nRows:=0;
    //Log('Nacteni dat do pole');
    while (not tab.Eof) do begin
      Inc(nRows);
      for i:=0 to nCols-1 do begin
        aData.Add(tab.FieldAsString(i));
        //Log(IntToStr(i)+': '+tab.FieldAsString(i));
      end;
      tab.Next();
    end;
    if(nRows<=0) then Log(_('WARN: SQL does not return any valid data'));
  finally
    if(tab<>nil) then tab.Free();
  end;
  s:=aPar.Values['FirstRow'];
  i:=StrToInt(s);
  if((i<0) or (s='')) then i:=0;
  s:=aPar.Values['CountRow'];
  n:=StrToInt(s);
  if((n<0) or (s='')) then n:=-1;
  if(aPar.Values['HaveHeader']='No') then aData.Insert(0,'!NoHeader!');
  Result:=Result+OutputTableList(sColumns,aData,i,n,idxCount,nRest)+CRLF;
  aData.Free();
  //pokud je treba zobrazit nejaky text pod tabulkou, zobrazime ho s nahrazenim
  //nekterych hodnot
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //nahradime specificke hodnoty
    s1:=IntToStr(nRows);
    s:=ReplaceString(s,'%RowCount%',s1);
    //nRest:=nRest-i;
    s1:=IntToStr(nRest);
    s:=ReplaceString(s,'%RowRest%',s1);
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;