//nastaveni globalni promenne Set_ReleventCaches, podle ktere je mozne omezit
//vyber kesi zpracovavanych na mapy
function SetFilter_Run(aPar:TStringList):string;
var s,sSql:string;
    iDummy:integer;
    tab: TSqliteTable;
    nRows:integer;
    bIncludeIgnoring:boolean;
begin
  Result:='';
  bIncludeIgnoring:=(UpperCase(aPar.Values['IncludeIgnoringCaches'])='YES');
  //vytvorime SQL v zavislosti na zadanych sloupcich
  aPar.Values['Columns']:=aPar.Values['Conditions'];
  //nastavime do parametru priznak toho, aby v SQL byla pouzita primo hodnota
  //tagu misto pouziti promenne ':jmeno'
  aPar.Values['SqlReplaceTagValues']:='YES';
  sSql:=TableListMakeSqlFromParams(aPar, bIncludeIgnoring, aPar.Values['IgnoreCacheTypes'],iDummy);
 {$ifdef DEBUG_HELPER} LDH('LLLL 1 SQL='+sSql); {$endif}
  //SQL upravime tak, abychom ziskali jen ID kesi
  //sSql:=RegexReplace('(?is)^.*?FROM\s*geocache\s*gc',ReplaceString(sSql,CRLF,' '),'SELECT gc.id FROM geocache gc',false);
  //pridame na zacatek sloupc gc.id, aby byl vzdy prvni
  sSql:=RegexReplace('(?is)^.*?SELECT',ReplaceString(sSql,CRLF,' '),'SELECT distinct gc.id,',false);
{$ifdef DEBUG_HELPER} LDH('LLLL 2 SQL='+sSql); {$endif}
  Log('SQL='+sSql);
  //ziskame seznam ID
  tab:=Geoget_DB.GetTable(sSql, false);
  nRows:=0;
  s:='';
  try
    while (not tab.Eof) do begin
      s:=s+tab.FieldAsString(0)+CRLF;
      Inc(nRows);
      tab.Next();
    end;
    if(nRows<=0) then begin
      s:='-empty list-'+CRLF;
      //Log(_('WARN: SQL does not return any valid data'));
    end;
  finally
    if(tab<>nil) then tab.Free();
  end;
  s:=''''+ReplaceString(Trim(s),CRLF,''',''')+'''';
  GlobalVarSet('Set_FilteredCaches',s);
{$ifdef DEBUG_HELPER} LDH('LLLL 3 Pocet vyfiltrovanych kesi='+IntToStr(nRows)); {$endif}
 Log('Pocet vyfiltrovanych kesi='+IntToStr(nRows));
 Log('Set_FilteredCaches='+GlobalVarGet('Set_FilteredCaches',false));

end;

procedure SetFilter_Free;
begin
end;