// asov ada msnch nlez

function TimelineMonthlyMdcp_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iY,iM,{iMax,}iYearMin,iYearMax,iMonthMin,iMonthMax:integer;
    iBars,iWidthGr,iHeightGr,iBarSp,iBarWd,iStepLabels:integer;
    s,ss,sData,sLabM, sLabY,sSql,sT:string;
    sEData,sENames:string;
    aData:TStringList;
		iMaxFl:extended;
begin
  // rozmry a parametry grafu
  iHeightGr:=250;                             // vka grafu
  iWidthGr:=iWidth;
  // test na limitn velikosti grafu v bodech
  if (iWidthGr*iHeightGr) > MAX_GraphAreaSize then iWidthGr:=Trunc(MAX_GraphAreaSize/iHeightGr);
  iStepLabels:=3;                             // krok popisk vodorovn osy
  if iWidthGr<400 then iStepLabels:=6;

  // pprava dat pro graf
	s:=aPar.Values['mdCachingPointsType']; sT:=Fetch(s,'-');
	//
  aData:=TStringList.Create();
  sSql:='SELECT dtfound/100 YearMonth,'
	if sT = 'C' then
		sSql:=sSql+' ROUND(SUM(gv.value)*100)/100 Count'
	else
		sSql:=sSql+' ROUND((SUM(gv.value)/COUNT(gv.value))*100)/100 Count';
  sSql:=sSql+' FROM geocache gc';
	sSql:=sSql+' INNER JOIN geotag gt ON gc.id = gt.id';
  sSql:=sSql+' INNER JOIN geotagcategory gtc ON gt.ptrkat = gtc.key AND gtc.value = "mdCachingPoints"';
  sSql:=sSql+' INNER JOIN geotagvalue gv ON gt.ptrvalue = gv.key';
	sSql:=sSql+' WHERE gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar)+' GROUP BY YearMonth';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYearMax:=StrToInt(Copy(s,1,4));
      iMonthMax:=StrToInt(Copy(s,5,2));
      s:=IntToStr(iYearMax)+IntToStr(iMonthMax);
      if iYearMin=0 then iYearMin:=iYearMax;
      if iMonthMin=0 then iMonthMin:=iMonthMax;
      ss:=tab.FieldByName['Count'];
      if StrToFl(ss)>iMaxFl then iMaxFl:=StrToFl(ss);
      aData.Add(s+'='+ss);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // rozmry a parametry grafu
  iBars:=(iYearMax-iYearMin)*12+iMonthMax-iMonthMin+1; // poet sloupc histogramu
  // pokud nejsou data, koncime natvrdo bez grafu
  if iBars=0 then exit;
  iBarSp:=1;                                           // mezera mezi bary histogramu
  iBarWd:=Trunc((iWidthGr-31)/iBars)-iBarSp;           // ka baru histogramu

  // generovn datovch ad a popis
  iY:=iYearMin;
  iM:=iMonthMin;
  while true do begin
    s:=aData.Values[IntToStr(iY)+IntToStr(iM)];
    if s='' then s:='0';
    sEData:=sEData+Fetch(s,'.')+CRLF;  //odrizneme desetinnou cast
    sENames:=sENames+IntToStr(iM)+'/'+IntToStr(iY)+CRLF;
    if(sData='') then sData:=s else sData:=sData+','+s;
    if (iM mod iStepLabels)=0 then sLabM:=sLabM+'|'+IntToStr(iM) else sLabM:=sLabM+'|';
    if iM=6 then sLabY:=sLabY+'|'+IntToStr(iY) else sLabY:=sLabY+'|';
    Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if ((iY=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax) then break;
  end;
  //-------------
	iMaxFl := Trunc(iMaxFl+1);
  // finln akce
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  Result:='';
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',
    +_('MDCP in month<br/>{b}: {c}'),false,true,iWidth,250);    
  //upravime typ grafu
  s:=aPar.Values['GraphType'];
  if(Fetch(s,'-')='Line') then Result:=ReplaceString(Result,'type:''bar'',','type:''line'',');
  Output(Result);
  Result:='';
  // klid
  if(aData<>nil) then aData.Free();
end;