//ulozi nactena data do docasne tabulky
function Trackable_Run(aPar:TStringList):string;
var s,sPath,sFileIn,sSort,sSql,sDivStart,sDivEnd:string;
    tab: TSqliteTable;
    bGrouping:boolean;
    n:integer;
    //aData:TStringList;
    //i,iHandle:integer;
    //dt: TDateTime;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  //modul vyuziva data stazena jinym pluginem, protoze k tomu je potreba GJ
  //a neni zadouci, aby GJ bylo primo pouzivano ze Statoru. S timto postupem
  //Geby souhlasi. Data jsou stahovana anonymnim pristupem GJ. Je vsap potreba
  //UID, ktere bez prihlaseni zjisti nejde. Samostatny plugin se prihlasi,
  //zjisti UID, to si ulozi a pri dalsim pozadavku jiz bude pouzivat drive
  //zjistene UID
  //////////////////////////////////////////////////////////////////////////////
  //zjistime, zda existuje plugin, ktery potrebujeme spustit pro ziskani dat
  sPath:=GetMyDir+'GetTrackList\';
  s:=sPath+'GetTrackList.ggp.pas';
  if(not FileExists(s)) then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('ERR: Plugin GetTrackList does not exist.'));
    Log(_('ERR: Plugin GetTrackList does not exist.'));
    exit;
  end;
  //vytvorime docasnou tabulku pro ulozeni dat, abychom je mohli snadno seradit
  //podle potreby
  s:=aPar.Values['Relationship'];
  sFileIn:=Fetch(s,'-');
  //docasna tabulka uz je vytvorena z CalcTrackable_Run()
  if(sFileIn='All') then sFileIn:='Logged,Owned';
  sFileIn:=''''+ReplaceString(sFileIn,',',''',''')+'''';
  //podle pozadavku seradime a seskupime nactena data
  sSql:=aPar.Values['Grouping'];
  bGrouping:=(Fetch(sSql,'-')='Yes');
  sSql:=aPar.Values['SortBy'];

  sSort:=Fetch(sSql,'-');
  sSql:='SELECT count(ico) pocet FROM temp.StatorTrackable ico WHERE file in ('+sFileIn+')';
  n:=Geoget_DB.GetTableValue(sSql);
  if(bGrouping) then begin
    //pri seskupeni nema smysl radit podle niceho jineho nez podle ikony
    sSql:='SELECT count(ico) pocet, ico, km, name FROM'
      +' temp.StatorTrackable WHERE file in ('+sFileIn+') GROUP BY ico ORDER BY count(ico) desc';
  end
  else begin
    sSql:='SELECT id, ico, km, name FROM temp.StatorTrackable WHERE file in ('+sFileIn+') ';
    if(sSort='Distance') then sSql:=sSql+' ORDER BY (0+km) desc' //to ale nema smysl pri seskupovani
    else if(sSort='Icon') then sSql:=sSql+' ORDER BY ico'
    //radit podle poctu jde jen kdyz je seskupeno, jinak to bude davat bludy
    else if(sSort='Count') then //takze neradime nijak
    else sSql:=sSql+' ORDER BY name';
  end;
  //generujeme vystup
  sDivStart:='<div style="'+GlobalVarGet('StyleTrackableDiv',false)+'">';
  //ShowMessage('DDDDD syl='+sDivStart);
  //pokud nahodou nenipromenna definovana, pouzijeme styl z atributu
  if(sDivStart='') or (sDivStart='StyleTrackableDiv') then
    sDivStart:='<div style="'+GlobalVarGet('StyleAttribDiv',false)+'">';
  sDivEnd:='</div>';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    Result:=Result+'<p>'+_('Number of trackables:')+' '+IntToStr(n)+'</p>'+CRLF;
    if(bGrouping) then Result:=Result+'<p>'+_('This number represents the number of logged trackables with the same icon.')+'</p>'+CRLF
    else Result:=Result+'<p>'+_('This number represents the distance reached by trackable item.')+'</p>'+CRLF;
    while (not tab.eof) do begin
      Inc(n);
      //pokud je ikona bez cesty, dame standardni, jinak pouzijeme tu zadanou
      s:=tab.FieldByName['ico'];
      if(Pos('http',s)<1) then s:='https://www.geocaching.com/images/wpttypes/'+s;
      s:='<img src="'+s+'"';
      if(bGrouping) then s:=s+' /><br />'+tab.FieldByName['pocet']
      else s:='<a href="https://www.geocaching.com/track/details.aspx?id='
          +tab.FieldByName['id']+'" target="StatorTrackable">'+s  //odkaz na konkretni stranku
          +' title="'+ReplaceString(UtfToAnsi(tab.FieldByName['name']),'"','&quot;')+' ('+tab.FieldByName['km']+' km)" /></a>'
          +'<br />'+tab.FieldByName['km'];
      Result:=Result+sDivStart+s+sDivEnd+CRLF;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
end;