//funkce pro vytvoreni kopie Default profilu
//pri kopirovani se opta, jaky bude cilovy jazyk, a podle toho zkopiruje
//Content_EN/CZ/SK.ini, Config_EN/CZ/SK.ini a ColumnNames_EN/CZ/SK.ini

//pouziva se i v poinstalacnim scriptu

procedure CopyDefaultProfile(sName:string; bSK:boolean);
var sFiles,sFile,sLang,sDir:string;
    i:integer;
    Form:TForm;
    sLabel:TLabel;
    lList:TListBox;
    butOk:TButton;
begin
  sDir:=GEOGET_SCRIPTDIR+'\Stator\Profiles\';

  sName:=StringCompress(sName);
  //  if(not DirectoryExists(GetProfilesDir()+s)) then break
  //  else ShowMessage(s+CRLF+_('Profile already exists'));
  CopyTree(sDir+'Default',sDir+sName);
  //dotaz na cilovy jazyk
  Form:=TForm.Create(nil);   Form.Width:=380;  Form.Height:=250;
  Form.BorderStyle:=bsDialog;  Form.BorderIcons := [];
  Form.Caption:='Stator - '+_('select language');
  Form.Position:=poScreenCenter;

  sLabel:=TLabel.Create(Form);
  sLabel.Caption:=_('Select language used in statistics output')+': '+sName;
  sLabel.Parent:=Form;
  sLabel.SetBounds(10,20,350,24);

  lList:=TListbox.Create(Form);
  lList.Parent:=Form;
  lList.SetBounds(10,50,350,100);
  lList.Items.Text:='CS - Cestina'+CRLF+'EN - English';//CRLF se na konec doplni automaticky
  if(bSK) then lList.Items.Text:=lList.Items.Text+'SK - Slovencina';
  //podle aktualniho jazyka zvolime implicitni
  sLang:=UpperCase(copy(GetCurrentLanguage(),1,2));
  //ShowMessage('Lan='+sLang);
  case sLang of
  'CS': i:=0;
  'SK': if(bSK) then i:=2 else i:=1;
  else i:=1;
  end;
  lList.ItemIndex:=i;

  butOk:=TButton.Create(Form);
  butOk.Parent:=Form;
  butOk.SetBounds(235,185,75,26);
  butOk.Caption:='OK';
  butOk.Modalresult:=1;
  butOk.font.style:=[fsBold];

  if(Form.ShowModal()=1) then begin
    case lList.ItemIndex of
    0: sLang:='CS';
    2: sLang:='SK';
    else sLang:='EN';
    end;
  end;
  //zkopirujeme soubory
  sFiles:='Content, Config, ColumnNames';
  while sFiles<>'' do begin
    sFile:=Fetch(sFiles,',');
    if(FileExists(sDir+sName+'\'+sFile+'_'+sLang+'.ini')) then begin
      //ShowMessage(sDir+sName+'\'+sFile+'_'+sLang+'.ini'+CRLF+'===>'
      //  +CRLF+sDir+sName+'\'+sFile+'.ini');
      CopyFile(sDir+sName+'\'+sFile+'_'+sLang+'.ini', sDir+sName+'\'+sFile+'.ini');
    end;
  end;
  //uvolnime dialog
  butOk.Free();
  sLabel.Free();
  lList.Free();
  Form.Free();
end;