function SwapRB(str:string):string;
begin
  Result:=copy(str,5,2)+copy(str,3,2)+copy(str,1,2);
end;

function RGBToColor(str:string):integer;
begin
  //zmenime poradi bytu
  str:=SwapRB(str);
  Result:=HexToDec('02'+str);
end;

function ColorIdxToName(idx:integer; bBkg:boolean):string;
begin   //ziska jmeno promenne s barvou
  case idx of
  0:   if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorMainBkg';
  1:   if(not bBkg) then Result:='ColorFrameTitleText'
       else Result:='ColorFrameTitleBkg';
  2:   if(not bBkg) then Result:='ColorFrameTitleBorder'
       else Result:='ColorFrameTitleBkg';
  3:   if(not bBkg) then Result:='ColorFrameBorder'
       else Result:='ColorMainBkg';
  4:   if(not bBkg) then Result:='ColorTabText'
       else Result:='ColorTabBkg';
  5:   if(not bBkg) then Result:='ColorTabActiveText'
       else Result:='ColorTabActiveBkg';
  6:   if(not bBkg) then Result:='ColorTabBorder'
       else Result:='ColorTabBkg';
  7:   if(not bBkg) then Result:='ColorTitleText'
       else Result:='ColorTitleBkg';
  8:   if(not bBkg) then Result:='ColorTitleBorder'
       else Result:='ColorTitleBkg';
  9:   if(not bBkg) then Result:='ColorTableListHeaderText'
       else Result:='ColorTableListHeaderBkg';
  10:  if(not bBkg) then Result:='ColorTableListHeaderBorder'
       else Result:='ColorTableListHeaderBkg';
  11:  if(not bBkg) then Result:='ColorTableListHeaderText'
       else Result:='ColorTableMatrixHeaderBkg1';
  12:  if(not bBkg) then Result:='ColorTableListHeaderText'
       else Result:='ColorTableMatrixHeaderBkg2';
  13:  if(not bBkg) then Result:='ColorTableMatrixHeaderMaxText'
       else Result:='ColorTableMatrixHeaderMaxBkg';
  14:  if(not bBkg) then Result:='ColorTableText'
       else Result:='ColorTableBkg';
  15:  if(not bBkg) then Result:='ColorTableTextOdd'
       else Result:='ColorTableBkgOdd';
  16:  if(not bBkg) then Result:='ColorTableText'
       else Result:='ColorTableHighlightedBkg';
  17:  if(not bBkg) then Result:='ColorTableTextOdd'
       else Result:='ColorTableHighlightedBkgOdd';
  18:  if(not bBkg) then Result:='ColorTableValueText'
       else Result:='ColorTableValueBkg';
  19:  if(not bBkg) then Result:='ColorTableMinText'
       else Result:='ColorTableValueBkg';
  20:  if(not bBkg) then Result:='ColorTableAvgText'
       else Result:='ColorTableValueBkg';
  21:  if(not bBkg) then Result:='ColorTableMaxText'
       else Result:='ColorTableValueBkg';
  22:  if(not bBkg) then Result:='ColorTableScaleText'
       else Result:='ColorTableScaleMinBkg';
  23:  if(not bBkg) then Result:='ColorTableScaleText'
       else Result:='ColorTableScaleAvgBkg';
  24:  if(not bBkg) then Result:='ColorTableScaleMaxText'
       else Result:='ColorTableScaleMaxBkg';
  25:  if(not bBkg) then Result:='ColorTableNumbersText'
       else Result:='ColorTableNumbersBkg';
  26:  if(not bBkg) then Result:='ColorTableNumbersValueText'
       else Result:='ColorTableNumbersValueBkg';
  27:  if(not bBkg) then Result:='ColorCacheDisabledText'
       else Result:='ColorTableBkg';
  28:  if(not bBkg) then Result:='ColorCacheArchivedText'
       else Result:='ColorTableBkg';
  29:  if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheEnabled';
  30:  if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheDisabled';
  31:  if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheArchived';
  32:   if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheTraditional';
  33:   if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheMulti';
  34:   if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorGraphCacheUnknown';
  35:   if(not bBkg) then Result:='ColorGraphYearlyTotals'
       else Result:='ColorMainBkg';
  36:   if(not bBkg) then Result:='ColorMapCountText'
       else Result:='ColorMapMinBkg';
  37:   if(not bBkg) then Result:='ColorMapPercentText'
       else Result:='ColorMapAvgBkg';
  38:  if(not bBkg) then Result:='ColorMapAbbrevText'
       else Result:='ColorMapMaxBkg';
  39:  if(not bBkg) then Result:='ColorMainText'
       else Result:='ColorMapRegionDNF';
  40:  if(not bBkg) then Result:='ColorMapDots'
       else Result:='ColorMainBkg';
  end;
end;

procedure lColorDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte //podle dokumentace je typu TOwnerDrawState, ale v enginu je byte
  );
var s:string;
begin
  //pokud je oznaceno, udelame inverzni ramecek kolem
  //radek je vybarven barvou pozadi, text je vybarven prislusnou barvou textu
  with GGForm_lLayColors.Canvas do begin
    //najdeme hodnotu barvy v globalnich promennych
    Font.Color:=RGBToColor(GlobalVarGetColor(ColorIdxToName(Index,false),'dd44dd'));
    Brush.Color:=RGBToColor(GlobalVarGetColor(ColorIdxToName(Index,true),'dddd44'));
    //if((State AND 1)=1) then begin                 //polozka je vybrana
    //  Brush.Color:=COLOR_BKG_SEL;
    //  Font.Color:=COLOR_TXT_SEL;
    //end;
    FillRect(Rect);                                //vybarvit pozadi
    s:=GGForm_lLayColors.Items[Index];
    TextOut(Rect.Left+2,Rect.Top+2,Fetch(s,';'));
  end;
end;

procedure lColorOnClick(sender:TObject);
begin
  //povoli nebo zakaze tlacitka pro upravu barev, pokud je to potreba
  //pro vetsinu je povoleno oboje
  case GGForm_lLayColors.ItemIndex of
  //uprava jen barvy textu
  2,3,6,8,10,19,20,21,27,28,35,40:
      begin GGForm_butLayColorEditText.Enabled:=true; GGForm_butLayColorEditBkg.Enabled:=false; end;
  //uprava jen barvy pozadi
  11,12,16,17,23,29,30,31,32,33,34,39:
       begin GGForm_butLayColorEditText.Enabled:=false;  GGForm_butLayColorEditBkg.Enabled:=true; end;
  //uprava obou barev
  else begin GGForm_butLayColorEditText.Enabled:=true;  GGForm_butLayColorEditBkg.Enabled:=true; end;
  end;
end;

procedure ShowColorPreview;
var 
  s,sMin,sAvg,sMax:string;
begin
  //nepouzivame RGBToColor, protoze to tam dava navic 02, ktere zde nesmi byt
  GGForm_colMainBkg.Color:=HexToDec(SwapRB(GlobalVarGet('ColorMainBkg',false)));
  GGForm_colMainBkg.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorMainTxt',false)));
  GGForm_colMainText.Font.Color:=GGForm_colMainBkg.Font.Color;

  GGForm_colTabLine.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTabBorder',false)));
  GGForm_colTab1.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTabText',false)));
  GGForm_colTab1.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTabBkg',false)));
  GGForm_colTab1Border.Color:=GGForm_colTabLine.Color;
  GGForm_colTabActive.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTabActiveText',false)));
  GGForm_colTabActive.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTabActiveBkg',false)));
  GGForm_colTabActiveBorder.Color:=GGForm_colTabLine.Color;
  GGForm_colTab2.Font.Color:=GGForm_colTab1.Font.Color;
  GGForm_colTab2.Color:=GGForm_colTab1.Color;
  GGForm_colTab2Border.Color:=GGForm_colTabLine.Color;
  GGForm_colTab3.Font.Color:=GGForm_colTab1.Font.Color;
  GGForm_colTab3.Color:=GGForm_colTab1.Color;
  GGForm_colTab3Border.Color:=GGForm_colTabLine.Color;

  GGForm_colFrameTitleBorder.Color:=HexToDec(SwapRB(GlobalVarGet('ColorFrameTitleBorder',false)));
  GGForm_colFrameTitle.Color:=HexToDec(SwapRB(GlobalVarGet('ColorFrameTitleBkg',false)));
  GGForm_colFrameTitle.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorFrameTitleText',false)));
  GGForm_colFrameBorder.Color:=HexToDec(SwapRB(GlobalVarGet('ColorFrameBorder',false)));
  GGForm_colFrame.Color:=GGForm_colMainBkg.Color;
  GGForm_colFrame.Font.Color:=GGForm_colMainBkg.Font.Color;

  GGForm_colTitle1Border.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTitleBorder',false)));
  GGForm_colTitle1.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTitleBkg',false)));
  GGForm_colTitle1.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTitleText',false)));
  GGForm_colModule1.Color:=GGForm_colMainBkg.Color;

  GGForm_colTableListHeader1Border.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderBorder',false)));
  GGForm_colTableListHeader2Border.Color:=GGForm_colTableListHeader1Border.Color;
  GGForm_colTableListHeader3Border.Color:=GGForm_colTableListHeader1Border.Color;
  GGForm_colTableListHeader1.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderBkg',false)));
  GGForm_colTableListHeader1.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderText',false)));
  GGForm_colTableListHeader2.Color:=GGForm_colTableListHeader1.Color;
  GGForm_colTableListHeader2.Font.Color:=GGForm_colTableListHeader1.Font.Color;
  GGForm_colTableListHeader3.Color:=GGForm_colTableListHeader1.Color;
  GGForm_colTableListHeader3.Font.Color:=GGForm_colTableListHeader1.Font.Color;
  GGForm_colTable11.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableBkgOdd',false)));
  GGForm_colTable11.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableTextOdd',false)));
  GGForm_colTable12.Color:=GGForm_colTable11.Color;
  GGForm_colTable12.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable13.Color:=GGForm_colTable11.Color;
  GGForm_colTable13.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable21.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableHighlightedBkg',false)));
  GGForm_colTable21.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableText',false)));
  GGForm_colTable22.Color:=GGForm_colTable21.Color;
  GGForm_colTable22.Font.Color:=GGForm_colTable21.Font.Color;
  GGForm_colTable23.Color:=GGForm_colTable21.Color;
  GGForm_colTable23.Font.Color:=GGForm_colTable21.Font.Color;
  GGForm_colTable31.Color:=GGForm_colTable11.Color;
  GGForm_colTable31.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable32.Color:=GGForm_colTable11.Color;
  GGForm_colTable32.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable33.Color:=GGForm_colTable11.Color;
  GGForm_colTable33.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable41.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableBkg',false)));
  GGForm_colTable41.Font.Color:=GGForm_colTable21.Font.Color;
  GGForm_colTable42.Color:=GGForm_colTable41.Color;
  GGForm_colTable42.Font.Color:=GGForm_colTable21.Font.Color;
  GGForm_colTable43.Color:=GGForm_colTable41.Color;
  GGForm_colTable43.Font.Color:=GGForm_colTable21.Font.Color;
  GGForm_colTable51.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableHighlightedBkgOdd',false)));
  GGForm_colTable51.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable52.Color:=GGForm_colTable51.Color;
  GGForm_colTable52.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable53.Color:=GGForm_colTable51.Color;
  GGForm_colTable53.Font.Color:=GGForm_colTable11.Font.Color;
  GGForm_colTable13Bar.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableScaleMinBkg',false)));
  s:=ScaleColor(19,0,82,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false));
  GGForm_colTable23Bar.Color:=HexToDec(SwapRB(s));
  GGForm_colTable33Bar.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableScaleAvgBkg',false)));
  GGForm_colTable43Bar.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableScaleMaxBkg',false)));
  s:=ScaleColor(61,0,82,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false));
  GGForm_colTable53Bar.Color:=HexToDec(SwapRB(s));

  GGForm_colTableNumberHeader1Border.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderBorder',false)));
  GGForm_colTableNumberHeader2Border.Color:=GGForm_colTableNumberHeader1Border.Color;
  GGForm_colTableNumberHeader1.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderBkg',false)));
  GGForm_colTableNumberHeader1.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderText',false)));
  GGForm_colTableNumberHeader2.Color:=GGForm_colTableNumberHeader1.Color;
  GGForm_colTableNumberHeader2.Font.Color:=GGForm_colTableNumberHeader1.Font.Color;
  GGForm_colTableNumber11.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableNumbersBkg',false)));
  GGForm_colTableNumber11.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableNumbersText',false)));
  GGForm_colTableNumber12.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableNumbersValueBkg',false)));
  GGForm_colTableNumber12.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableNumbersValueText',false)));
  GGForm_colTableNumber21.Color:=GGForm_colTableNumber11.Color;
  GGForm_colTableNumber21.Font.Color:=GGForm_colTableNumber11.Font.Color;
  GGForm_colTableNumber22.Color:=GGForm_colTableNumber12.Color;
  GGForm_colTableNumber22.Font.Color:=GGForm_colTableNumber12.Font.Color;
  GGForm_colTableNumber31.Color:=GGForm_colTableNumber11.Color;
  GGForm_colTableNumber31.Font.Color:=GGForm_colTableNumber11.Font.Color;
  GGForm_colTableNumber32.Color:=GGForm_colTableNumber12.Color;
  GGForm_colTableNumber32.Font.Color:=GGForm_colTableNumber12.Font.Color;

  GGForm_colTitle2Border.Color:=GGForm_colTitle1Border.Color;
  GGForm_colTitle2.Color:=GGForm_colTitle1.Color;
  GGForm_colTitle2.Font.Color:=GGForm_colTitle1.Font.Color;
  GGForm_colModule2.Color:=GGForm_colMainBkg.Color;

  GGForm_colTitle3Border.Color:=GGForm_colTitle1Border.Color;
  GGForm_colTitle3.Color:=GGForm_colTitle1.Color;
  GGForm_colTitle3.Font.Color:=GGForm_colTitle1.Font.Color;
  GGForm_colModule3.Color:=GGForm_colMainBkg.Color;

  GGForm_colModule3.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableListHeaderText',false)));
  GGForm_colTableMatrixHeader11.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableMatrixHeaderBkg1',false)));
  GGForm_colTableMatrixHeader12.Color:=GGForm_colTableMatrixHeader11.Color;
  GGForm_colTableMatrixHeader21.Color:=GGForm_colTableMatrixHeader11.Color;
  GGForm_colTableMatrixHeader22.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableMatrixHeaderBkg2',false)));
  GGForm_colTableMatrixHeader23.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader24.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader25.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader26.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader27.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader32.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader33.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader34.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader35.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader36.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader37.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader47.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader57.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableMatrixHeaderMaxBkg',false)));
  GGForm_colTableMatrixHeader57.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableMatrixHeaderMaxText',false)));
  GGForm_colTableMatrixHeader67.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader77.Color:=GGForm_colTableMatrixHeader22.Color;
  GGForm_colTableMatrixHeader87.Color:=GGForm_colTableMatrixHeader22.Color;

  sMin:=GlobalVarGet('ColorTableScaleMinBkg',false);
  sAvg:=GlobalVarGet('ColorTableScaleAvgBkg',false);
  sMax:=GlobalVarGet('ColorTableScaleMaxBkg',false);
  GGForm_colTableMatrix11.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix11.Caption),0,100,sMin,sAvg,sMax)));
  if(GGForm_bLayColorScale.Checked) then GGForm_colTableMatrix11.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableScaleText',false)))
  else GGForm_colTableMatrix11.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableText',false)));
  GGForm_colTableMatrix12.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix12.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix12.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix13.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix13.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix13.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix14.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix14.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix14.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix15.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix15.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix15.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix21.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix21.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix21.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix22.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix22.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix22.Font.Color:=HexToDec(SwapRB(GlobalVarGet('ColorTableScaleMaxText',false)));
  GGForm_colTableMatrix23.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix23.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix23.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix24.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix24.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix24.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix25.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix25.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix25.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix31.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix31.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix31.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix32.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix32.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix32.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix33.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix33.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix33.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix34.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix34.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix34.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix35.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix35.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix35.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix41.Color:=GGForm_colMainBkg.Color;
  GGForm_colTableMatrix41.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix42.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix42.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix42.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix43.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix43.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix43.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix44.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix44.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix44.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix45.Color:=GGForm_colMainBkg.Color;
  GGForm_colTableMatrix45.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix51.Color:=GGForm_colMainBkg.Color;
  GGForm_colTableMatrix51.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix52.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix52.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix52.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix53.Color:=GGForm_colMainBkg.Color;
  GGForm_colTableMatrix53.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix54.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix54.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix54.Font.Color:=GGForm_colTableMatrix11.Font.Color;
  GGForm_colTableMatrix55.Color:=HexToDec(SwapRB(ScaleColor(StrToInt(GGForm_colTableMatrix55.Caption),0,100,sMin,sAvg,sMax)));
  GGForm_colTableMatrix55.Font.Color:=GGForm_colTableMatrix11.Font.Color;

  GGForm_colModule4.Color:=GGForm_colMainBkg.Color;
end;

procedure butColorEdit(sender:TObject);
var cd:TColorDialog;
    s,sName:string;
begin
  cd:=TColorDialog.create(nil);
  if(sender=GGForm_butLayColorEditText) then
    sName:=ColorIdxToName(GGForm_lLayColors.ItemIndex,false)
  else sName:=ColorIdxToName(GGForm_lLayColors.ItemIndex,true);
  s:=GlobalVarGet(sName,false);
  cd.Color:=RGBtoColor(s);
  cd.Options:=[cdFullOpen];
  //cd.Options:=[cdFullOpen,cdAnyColor,cdSolidColor];
  try
    if(cd.Execute()) then begin
      //cd.Color;  //toto je zmena barva, ulozime ji do promenne s
      s:=DecToHex(cd.Color,8);
      //ShowMessage('Nova barva 1:'+DecToHex(cd.Color,6)+', '+IntToStr(cd.Color));
      s:=SwapRB(copy(s,3,8));   //prohodime barvy
      //ShowMessage('Nova barva 1:'+DecToHex(cd.Color,8)+', '+IntToStr(cd.Color));
      //ShowMessage('Nova barva 2:'+s);
      GlobalVarSet(sName,s);
      GGForm_lLayColors.Invalidate();
      GGForm_butSave.Enabled:=true;
      ShowColorPreview();
    end;
  finally
    cd.Free();
  end;
end;

procedure bColorScaleOnClick(sender:TObject);
begin
  if(GGForm_bLayColorScale.Checked) then GlobalVarSet('ColorScale','Yes')
  else GlobalVarSet('ColorScale','No');
  GGForm_butSave.Enabled:=true;
  ShowColorPreview();
end;

procedure SaveLayoutFile;
var ini:TMemIniFile;
    sSection:string;
begin

  //ulozime vsechna nastaveni souvisejici s barvami do globalnich promennych
  sSection:='COLORS';
  ini:=TMemIniFile.Create(GetProfileDir()+'Colors.ini');
  ini.WriteString(sSection,'Scale',GlobalVarGet('ColorScale',false));
  ini.WriteString(sSection,'MainText',GlobalVarGetColor('ColorMainText','000000'));
  ini.WriteString(sSection,'MainBkg',GlobalVarGetColor('ColorMainBkg','ffffff'));
  ini.WriteString(sSection,'FrameTitleText',GlobalVarGetColor('ColorFrameTitleText','000000'));
  ini.WriteString(sSection,'FrameTitleBkg',GlobalVarGetColor('ColorFrameTitleBkg','ffffff'));
  ini.WriteString(sSection,'FrameTitleBorder',GlobalVarGetColor('ColorFrameTitleBorder','000000'));
  ini.WriteString(sSection,'FrameBorder',GlobalVarGetColor('ColorFrameBorder','000000'));
  ini.WriteString(sSection,'TabText',GlobalVarGetColor('ColorTabText','000000'));
  ini.WriteString(sSection,'TabBkg',GlobalVarGetColor('ColorTabBkg','ffffff'));
  ini.WriteString(sSection,'TabActiveText',GlobalVarGetColor('ColorTabActiveText','000000'));
  ini.WriteString(sSection,'TabActiveBkg',GlobalVarGetColor('ColorTabActiveBkg','ffffff'));
  ini.WriteString(sSection,'TabBorder',GlobalVarGetColor('ColorTabBorder','000000'));
  ini.WriteString(sSection,'TitleText',GlobalVarGetColor('ColorTitleText','000000'));
  ini.WriteString(sSection,'TitleBkg',GlobalVarGetColor('ColorTitleBkg','ffffff'));
  ini.WriteString(sSection,'TitleBorder',GlobalVarGetColor('ColorTitleBorder','000000'));
  ini.WriteString(sSection,'TableListHeaderText',GlobalVarGetColor('ColorTableListHeaderText','000000'));
  ini.WriteString(sSection,'TableListHeaderBkg',GlobalVarGetColor('ColorTableListHeaderBkg','ffffff'));
  ini.WriteString(sSection,'TableListHeaderBorder',GlobalVarGetColor('ColorTableListHeaderBorder','000000'));
  ini.WriteString(sSection,'TableMatrixHeaderBkg1',GlobalVarGetColor('ColorTableMatrixHeaderBkg1','ffffff'));
  ini.WriteString(sSection,'TableMatrixHeaderBkg2',GlobalVarGetColor('ColorTableMatrixHeaderBkg2','ffffff'));
  ini.WriteString(sSection,'TableMatrixHeaderMaxBkg',GlobalVarGetColor('ColorTableMatrixHeaderMaxBkg','ffffff'));
  ini.WriteString(sSection,'TableMatrixHeaderMaxText',GlobalVarGetColor('ColorTableMatrixHeaderMaxText',GlobalVarGetColor('ColorTableMatrixHeaderMaxText','000000')));
  ini.WriteString(sSection,'TableText',GlobalVarGetColor('ColorTableText','000000'));
  ini.WriteString(sSection,'TableBkg',GlobalVarGetColor('ColorTableBkg','ffffff'));
  ini.WriteString(sSection,'TableTextOdd',GlobalVarGetColor('ColorTableTextOdd','000000'));
  ini.WriteString(sSection,'TableBkgOdd',GlobalVarGetColor('ColorTableBkgOdd','ffffff'));
  ini.WriteString(sSection,'TableHighlightedBkg',GlobalVarGetColor('ColorTableHighlightedBkg','ffffff'));
  ini.WriteString(sSection,'TableHighlightedBkgOdd',GlobalVarGetColor('ColorTableHighlightedBkgOdd','ffffff'));
  ini.WriteString(sSection,'TableValueText',GlobalVarGetColor('ColorTableValueText','000000'));
  ini.WriteString(sSection,'TableValueBkg',GlobalVarGetColor('ColorTableValueBkg','ffffff'));
  ini.WriteString(sSection,'TableMaxText',GlobalVarGetColor('ColorTableMaxText','000000'));
  ini.WriteString(sSection,'TableAvgText',GlobalVarGetColor('ColorTableAvgText','000000'));
  ini.WriteString(sSection,'TableMinText',GlobalVarGetColor('ColorTableMinText','000000'));
  ini.WriteString(sSection,'TableScaleText',GlobalVarGetColor('ColorTableScaleText','000000'));
  ini.WriteString(sSection,'TableScaleMinBkg',GlobalVarGetColor('ColorTableScaleMinBkg','ffffff'));
  ini.WriteString(sSection,'TableScaleAvgBkg',GlobalVarGetColor('ColorTableScaleAvgBkg','ffffff'));
  ini.WriteString(sSection,'TableScaleMaxBkg',GlobalVarGetColor('ColorTableScaleMaxBkg','ffffff'));
  ini.WriteString(sSection,'TableScaleMaxText',GlobalVarGetColor('ColorTableScaleMaxText',GlobalVarGetColor('ColorTableScaleText','000000')));
  ini.WriteString(sSection,'TableNumbersText',GlobalVarGetColor('ColorTableNumbersText','000000'));
  ini.WriteString(sSection,'TableNumbersBkg',GlobalVarGetColor('ColorTableNumbersBkg','ffffff'));
  ini.WriteString(sSection,'TableNumbersValueText',GlobalVarGetColor('ColorTableNumbersValueText','000000'));
  ini.WriteString(sSection,'TableNumbersValueBkg',GlobalVarGetColor('ColorTableNumbersValueBkg','ffffff'));
  ini.WriteString(sSection,'GraphCacheEnabled',GlobalVarGetColor('ColorGraphCacheEnabled','000000'));
  ini.WriteString(sSection,'GraphCacheDisabled',GlobalVarGetColor('ColorGraphCacheDisabled','404040'));
  ini.WriteString(sSection,'CacheDisabledText',GlobalVarGetColor('ColorCacheDisabledText','000000'));
  ini.WriteString(sSection,'GraphCacheArchived',GlobalVarGetColor('ColorGraphCacheArchived','ff0000'));
  ini.WriteString(sSection,'CacheArchivedText',GlobalVarGetColor('ColorCacheArchivedText','ff0000'));
  ini.WriteString(sSection,'GraphCacheTraditional',GlobalVarGetColor('ColorGraphCacheTraditional','00ff00'));
  ini.WriteString(sSection,'GraphCacheMulti',GlobalVarGetColor('ColorGraphCacheMulti','008080'));
  ini.WriteString(sSection,'GraphCacheUnknown',GlobalVarGetColor('ColorGraphCacheUnknown','000080'));
  ini.WriteString(sSection,'GraphYearlyTotals',GlobalVarGetColor('ColorGraphYearlyTotals','ff0000'));
  ini.WriteString(sSection,'MapMaxBkg',GlobalVarGetColor('ColorMapMaxBkg','ffffff'));
  ini.WriteString(sSection,'MapAvgBkg',GlobalVarGetColor('ColorMapAvgBkg','ffffff'));
  ini.WriteString(sSection,'MapMinBkg',GlobalVarGetColor('ColorMapMinBkg','ffffff'));
  ini.WriteString(sSection,'MapCountText',GlobalVarGetColor('ColorMapCountText','000000'));
  ini.WriteString(sSection,'MapPercentText',GlobalVarGetColor('ColorMapPercentText','000000'));
  ini.WriteString(sSection,'MapAbbrevText',GlobalVarGetColor('ColorMapAbbrevText','000000'));
  ini.WriteString(sSection,'MapRegionDNF',GlobalVarGetColor('ColorMapRegionDNF','ffffff'));
  ini.WriteString(sSection,'MapDots',GlobalVarGetColor('ColorMapDots','ff0000'));
  ini.UpdateFile();
  ini.Free();
end;

procedure LayOnChange(sender:TObject);
begin
  GGForm_butSave.Enabled:=true;
end;

procedure InitLayout;
begin
{$ifdef PROFILER}ProfileStart('InitLayout');{$endif}  //OK
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitLayout(), start');
{$endif}
  GeoBusyKind(_('Loading schemes')); 
  ReadIniFiles(false);
  GGForm_bLayColorScale.checked:=(UpperCase(GlobalVarGet('ColorScale',false))='YES');

  GGForm_lLayColors.OnDrawItem:=@lColorDrawItem;
  GGForm_lLayColors.OnClick:=@lColorOnClick;
  GGForm_butLayColorEditText.OnClick:=@butColorEdit;
  GGForm_butLayColorEditBkg.OnClick:=@butColorEdit;
  GGForm_bLayColorScale.OnClick:=@bColorScaleOnClick;

  ShowColorPreview();
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitLayout(), stop');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;