//obsluha samostatneho formulare pro upravu parametru modulu

const MAX_ColumnDesc=200;

var aColumnDesc: array [0..MAX_ColumnDesc] of string;
    bReadPict:boolean;

procedure FreePar;    //uvolneni vsech promennych
begin
end;

procedure ItemsFromParam(str:string; var sOrg, sType, sName, sValue:string);
var s:string;
begin
  s:=str;
  sOrg:=Fetch(s,'.');
  sType:=Fetch(s,'|');
  sName:=Fetch(s,'=');
  sValue:=s;
end;

procedure lParamsDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte //podle dokumentace je typu TOwnerDrawState, ale v enginu je byte
  );
var s:string;
begin
  with ParForm_lParams.Canvas do begin
    Brush.Color:=clWindow;
    s:=ParForm_lParams.Items[Index];
    if((State AND 1)=1) then begin                 //polozka je vybrana
      Brush.Color:=COLOR_BKG_SEL;
      Font.Color:=COLOR_TXT_SEL;
    end;
    //pokud nemame dostatecnou uroven k uprave parametru, zobrazime text sede
    if(LevelToInt(s[2])>GGForm_lMode.ItemIndex) then Font.Color:=COLOR_TXT_DISABLE;
    FillRect(Rect);                                //vybarvit pozadi
    //vypsat text
    if(GGForm_lMode.ItemIndex<MODE_DEBUG) then begin
      Fetch(s,'.');
      Fetch(s,'|');
    end;
    //podle typu nastavime odsazeni
    if(Length(s)>100) then s:=Copy(s,1,100)+'...';
    TextOut(Rect.Left+5,Rect.Top+2,s);
  end;
end;

procedure lValuesDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte //podle dokumentace je typu TOwnerDrawState, ale v enginu je byte
  );
var s:string;
    aList:TListBox;
begin
  aList:=(list as TListBox);
  with aList.Canvas do begin
    Brush.Color:=clWindow;
    s:=aList.Items[Index];
    if((State AND 1)=1) and (s<>'') and (Pos('---',s)<>1) then begin //polozka je vybrana a neni oddelovac
      Brush.Color:=COLOR_BKG_SEL;
      Font.Color:=COLOR_TXT_SEL;
    end;
    if(Pos('---',s)=1) or (s='') then begin
      //Brush.Color:=COLOR_TXT_DISABLE;
      Font.Color:=COLOR_TXT_SEL;
      Font.style:=[fsBold];
      //Rect.Top:=Rect.Top-2;
      //Rect.Bottom:=Rect.Bottom+2;
    end;
    //pokud nemame dostatecnou uroven k uprave parametru, zobrazime text sede
    FillRect(Rect);                                //vybarvit pozadi
    //podle typu nastavime odsazeni
    TextOut(Rect.Left+5,Rect.Top,s);
  end;
end;

procedure lPictDrawItem(list: TWinControl; Index: Integer; Rect: TRect;
  State: byte //podle dokumentace je typu TOwnerDrawState, ale v enginu je byte
  );
var s:string;
begin
  with ParForm_lPictures.Canvas do begin
    Brush.Color:=clWindow;
    if((State AND 1)=1) then begin                 //polozka je vybrana
      Brush.Color:=COLOR_BKG_SEL;
      Font.Color:=COLOR_TXT_SEL;
    end;
    FillRect(Rect);                                //vybarvit pozadi
    //vypsat text
    s:=ParForm_lPictures.Items[Index];
    if(GGForm_lMode.ItemIndex<MODE_DEBUG) then begin
      s:=RegexReplace('.*/',s,'',false);
    end;
    TextOut(Rect.Left+5,Rect.Top-1,s);
  end;
end;

procedure lParColumnSrcOnClick(sender:TObject);
var i,j:integer;
    s,s1:string;
begin
  j:=-1;
  i:=ParForm_lColumnSrc.ItemIndex;
  //netusim proc, ale tato funkce je vyvolana, i v pripade, ze byl focus na
  //lColumnSrc a uzivatel klika na lParam a lColumnSrc tedy neni zobrazen!
  //prtoto testujeme jeho viditelnost, aby nedoslo k prepsani popisu parametru
  if(i>-1) and (ParForm_lColumnSrc.Visible) then begin
    ParForm_eDesc.Caption:=ReplaceString(aColumnDesc[i],'\r',CRLF);
    s:=ParForm_lColumnSrc.Items[i];
    s1:=Fetch(s,'('); //nechame jen jmeno bez komentare v zavorce)
    j:=ParForm_lColumnTrg.Items.IndexOf(s1);
    if(j<0) then begin //pokud neni, zjistime, zda je sloupec formatovany
      j:=ParForm_lColumnTrg.Items.IndexOfName(s1);
    end;
  end;
  ParForm_butAdd.Enabled:=(j=-1) and (i>-1);
end;

procedure lParColumnTrgOnClick(sender:TObject);
var i,j:integer;
    s,sTag:string;
    flags:REC_COLUMN_FLAGS;
begin
  i:=ParForm_lColumnTrg.ItemIndex;
  if(i>=0) then sTag:=Trim(ParForm_lColumnTrg.Items[ParForm_lColumnTrg.ItemIndex]);
  ParForm_butUp.Enabled:=(i>=1);
  ParForm_butDown.Enabled:=(i>-1) and (i<ParForm_lColumnTrg.Items.Count-1);
  ParForm_butDel.Enabled:=(i>-1);
  ParForm_butLeft.Enabled:=(i>-1);
  ParForm_butCenter.Enabled:=(i>-1);
  ParForm_butRight.Enabled:=(i>-1);
  ParForm_butHide.Enabled:=(i>-1);
  ParForm_butAscending.Enabled:=(i>-1);
  ParForm_butDescending.Enabled:=(i>-1);
  ParForm_bCounting.Enabled:=((i>-1) and
    (UpperCase(sTag)<>'COUNT') and (UpperCase(sTag)<>'PERCENT')
    and (UpperCase(sTag)<>'HISTOGRAM'));
  ParForm_PanelValue.Enabled:=(i>-1);
  //pokud jsme na TAGu, zobrazime moznost doplneni hodnoty tagu
  s:=Fetch(sTag,'-');
  ParForm_bTagMustExist.Visible:=((s='tag') and (ParForm_lColumnTrg.Visible));
  ParForm_eDesc.Visible:=((not ParForm_bValue.Visible));
  //nastavime hodnoty podle parametru
  s:='';
  if(i>-1) then s:=ParForm_lColumnTrg.Items[i];
  ParseColumnFlags(s,flags);

  j:=ParForm_lOperator.Items.IndexOf(flags.sOperator);
  if(j<0) then j:=0; //prvni polozka je libovolna hodnota
  ParForm_lOperator.ItemIndex:=j;
  ParForm_bColNumeric.Checked:=flags.bNumeric;
  ParForm_bCounting.Checked:=flags.bCounting;
  ParForm_bTagMustExist.Checked:=flags.bTagMustExist;
  ParForm_eTagValue.Text:=flags.sValue;
end;

procedure lPictOnClick(sender:TObject);
var sUrl,sImg,sMime,sType,sFile:string;
    iX,iY,iBpp:integer;
    b:boolean;
begin
  if(bReadPict) then exit; //probiha nacitani jineho obrazku, ukoncime se hned
  bReadPict:=true;
  try
    //zobrazime obrazek v htmlView
    sUrl:='';
    if(ParForm_lPictures.ItemIndex>=0) then sUrl:=ParForm_lPictures.Items[ParForm_lPictures.ItemIndex];
    ParForm_eValue.Text:=sUrl;
    sImg:='';
    //nacteme obrazek - napred zkusime, zda je v adresari s obrazky
    //muze tam vubec obrazek byt? zjistime to podle serveru
    b:=false;
    sMime:=RegexReplace('/.*?$',sUrl,'',false);
    sMime:=RegexSubstitute('(.*)(/.*)',sUrl,'$1');
    if(sMime='http://www.geocaching.cz/stator/img') then b:=true;
    if(sMime='http://kiregps.sweb.cz/Stator/tab') then b:=true;
    sType:=lowercase(RegexReplace('.*\.',sUrl,'',false));
    sFile:='Stator_icon_pom.'+sType;
    //zkusime nacist sobrazek z adresare
    if(b) then sMime:=GetCommonDir()+'ImagesPreview\'+RegexReplace('.*/',sUrl,'',false);
    if(sMime<>'') and (FileExists(sMime)) then sImg:=FileToString(sMime)
    else begin
      //------------
      //neni tam, nacteme ho z webu podle zadaneho URL
      //podle pripony obrazku zvolime spravny MIME typ
      case sType of
      'bmp': sMime:='image/bmp';
      'gif': sMime:='image/gif';
      'jpg','jpeg','jpe': sMime:='image/png';
      'png': sMime:='image/png';
      'tiff','tif': sMime:='image/tiff';
      else sMime:='';
      end;
      if(sMime<>'') then begin
        if(not HttpAsk('GET',sUrl,sMime,'',sImg)) then sImg:='';
      end;
    end;
    if(sImg<>'') then begin
      sImg:=ImageConvert(sImg,sType);   //prevedeme obrazek do jpg
      ImageInfo(sImg,sType,iX,iY,iBpp);
      //zmenime rozmery nahledu, pokud je to potreba
      if(iX>100) or (iY>100) then sImg:=ImageResize(sImg,100,100,true,true);
      StringToFile(sImg,sFile);
      ParForm_hPicture.Picture.LoadFromFile(sFile);
      ParForm_hPicture.Visible:=true;
      DeleteFile(sFile);
      //zobrazime jmeno a rozmery
      sMime:=RegexReplace('.*/',sUrl,'',false);
      sMime:=RegexReplace('\..*',sMime,'',false);
      ParForm_sPictureName.Caption:=sMime;
      ParForm_sPictureXY.Caption:=IntToStr(iX)+' x '+IntToStr(iY)+' ('+IntToStr(iBpp)+' bpp)';
    end;
    ParForm_hPicture.Visible:=sImg<>'';;
    ParForm_sPictureName.Visible:=sImg<>'';;
    ParForm_sPictureXY.Visible:=sImg<>'';;
  finally ;
  end;
  bReadPict:=false;
end;

procedure ParFillListFromIni(sCmd:string);
var s,sFile,sSec,sMask,sSep:string;
    aList:TStringList;
    ini:TMemIniFile;
    bAdd:boolean;
    i:integer;
begin
  //naplni do listboxu hodnoty z INI souboru podle pozadavku
  //!INI_SECTIONS=<soubor>,<maska_sekce>,<oddelovac> nebo
  //!INI_VALUES=<soubor>,<sekce><maska_promenne>,<oddelovac>
  bAdd:=false; //nepridany zadny radek
  s:=GlobalVarReplace(sCmd);
  //pro pripad, ze je v masce (regularnim vyrazu) '||' ma byt ve skutecnem
  //vyrazu jen '|', upravime prikaz
  s:=ReplaceString(s,'&&+&&','|');
  sCmd:=Fetch(s,'=');    //separujeme prikaz
  sFile:=Fetch(s,';'); //a nacteme z nej hodnoty oddelene strednikem
  sSec:=Fetch(s,';');
  sMask:=Fetch(s,';');
  sSep:=s;
  if(sCmd='!INI_SECTIONS') then begin
    sSep:=sMask;
    sMask:=sSec;
  end;
  //cesta k INI muze byt relativni vuci Modules
  sFile:=RelToAbsFilename(sFile,GetModulesDir());
  if(Pos(':',sFile)<1) then sFile:=GetModulesDir()+sFile;
{$ifdef DEBUG_HELPER}
  LDH('PPPPP sCmd='+sCmd+', sMsFileask='+sFile);
  LDH('PPPPP sSec='+sSec+', sMask='+sMask+', sSep='+sSep);
{$endif}
  if(not FileExists(sFile)) then begin
    ShowMessage(_('ERR: File not found:')+' '+sFile);
    exit;
  end;
  ini:=TMemIniFile.Create(sFile);
  try
    aList:=TStringList.Create();
    try
      //nacteme seznam sekci nebo seznam promennych v sekci
      if(sCmd='!INI_VALUES') then ini.ReadSection(sSec,aList)
      else ini.ReadSections(aList);
      //porovname vsechny nactene radky, zda odpovidaji masce a pripadne je pridame
      for i:=0 to aList.Count-1 do begin
        if(not RegexFind('(?i)'+sMask,aList[i])) then continue;
        //radek odpovida masce, pridame jej
        if(not bAdd) then begin
          if(Pos('---',sSep)=1) and (ParForm_lValues.Items.Count>0) then ParForm_lValues.Items.Add('');
          ParForm_lValues.Items.Add(sSep);
          bAdd:=true;
        end;
        //s:=RegexSubstitute('(?i)'+sMask,aList[i],'$1');
        //if(s='') then s:=aList[i];
        //ParForm_lValues.Items.Add(s);
        ParForm_lValues.Items.Add(aList[i]);
      end;
    finally
      aList.Free();
    end;
  finally
    ini.Free();
  end;
end;


procedure ParShowElem;             //zobrazi ovladaci prvky pro upravu parametru
var s,s1,s2,sOrg,sType,sName:string;
    sParOrg,sParType,sParName,sParValue,sDbPath:string;
    i,j:integer;
    aList:TStringList;
    MyDB:TSqliteDatabase;
begin
  {
    Mozne typy parametru jsou:
         INT, REAL, STRING, LONGTEXT, CHECK, LIST, LISTMULTI
         FILE, DIR
         COLOR, ICON, COORD
         COLUMNS
  }

  i:=ParForm_lParams.ItemIndex;
  if(i>=0) then begin
    s1:=ParForm_lParams.Items[i];
{$ifdef DEBUG_HELPER}
  LDH('Radek: '+s1);
{$endif}
    ItemsFromParam(s1,sOrg,sType,sName,s);
    ParForm_eValue.Text:=s;
    ParForm_eLongText.Lines.Text:=ReplaceString(s,'%CRLF%',CRLF);
    //pokud nemame povoleni k uprave, vymazeme typ
    if(LevelToInt(sOrg[2])>GGForm_lMode.ItemIndex) then sType:='';
  end
  else sType:='';
{$ifdef DEBUG_HELPER}
  LDH('Nastaveni parametru typ='+sType);
{$endif}
  ParForm_hPicture.Visible:=false;
  if(sType='ICON') and (ParForm_eValue.Text<>'') then begin
    i:=ParForm_lPictures.Items.IndexOf(ParForm_eValue.Text);
    //pridame novy radek, pokud tam URL jeste neni
    if(i<0) then i:=ParForm_lPictures.Items.Add(ParForm_eValue.Text);
    ParForm_lPictures.ItemIndex:=i;
    ParForm_hPicture.Visible:=(i>=0);
    if(i>=0) then lPictOnClick(nil);
  end;
  if(sType='LIST') or (sType='LISTMULTI')  then begin
    //naplnime mozne hodnoty
//LDH('XXX 1');
    s:=ParamValueFromIni(ParForm_eModule.Caption,sName,'VALUES','');
    //zbavime se snaku ##_??_## (komentar pro preklad do jinych jazyku)
    //a nahradime || v SQL, aby nedoslo k jeho zkraceni
    s:=Trim(ReplaceString(RegexReplace('##.*##',s,'',false),'||','&&+&&'));
    ParForm_lValues.Items.Clear();
    while(s<>'') do begin
      s1:=Fetch(s,'|');
//LDH('XXX s1='+s1);
      if(Pos('!DB=',s1)>0) then begin //zmena pouzivane databaze
        sDbPath:=ReplaceString(GlobalVarReplace(s1),'!DB=','');
        //musime zajistit nahradu promenne nastavene mezi parametry,
        //jmeno promenne patrici modulu je uzavreno do hranatych zavorek []
        s1:=RegexSubstitute('\[(.*)\]',sDbPath,'$1');
        if(s1<>'') then begin
//LDH('XXX jmeno promenne: '+s1);
          //najdeme mezi parametry modulu tento parametr
          for i:=0 to ParForm_lParams.Items.Count-1 do begin
            s2:=ParForm_lParams.Items[i];
            ItemsFromParam(s2,sParOrg,sParType,sParName,sParValue);
            if(sParName=s1) then begin
              sDbPath:=ReplaceString(sDbPath,'['+s1+']',sParValue);
              break;
            end;
          end;
        end;
        //cesta musi byt absolutni nebo relativni vuci DATADIR nebo scriptdir
        s1:=RelToAbsFilename(sDbPath,GEOGET_SCRIPTDIR);
        if(FileExists(s1)) then sDbPath:=s1
        else sDbPath:=RelToAbsFilename(sDbPath,GEOGET_DATADIR);
//LDH('XXX sDbPath='+sDbPath);
      end
      else if(Pos('!SQL=',s1)>0) then begin //hodnoty jsou vysledkem SQL prikazu
        s1:=ReplaceString(GlobalVarReplace(s1),'!SQL=','');
//LDH('XXX sSql='+s1);
        //protoze SQL muze obsahovat nabodenicka a podobne hruzy, prevedeme jej na UTF
        //s:=AnsiToUtf(s);  //pokud to prevedu, prestane chodit treba uzivatel
                            //PT@ nebo Kbko
                            //tomu nerozumim ze by nejaka automaticka konverze?
                            //v DB je to v UTF, kde se to prevede z ANSI?
        //ShowMessage('MMMM SLQ='+s);
        aList:=TStringList.Create();
        try
          //v SQL musime vratit spojovani stringu
          s1:=ReplaceString(s1,'&&+&&','||');
          //pokud je treba pracovat s jinou databazi, pouzijeme ji
          if(sDbPath='') then Geoget_DB.GetTableStrings(s1,aList)
          else begin
            if(FileExists(sDbPath)) then begin
//LDH('XXX Otviram databazi '+sDbPath);
              MyDB:=TSqliteDatabase.Create(sDbPath); //otevreme databazi
              try
//LDH('XXX Databaze otevrena');
                MyDb.GetTableStrings(s1,aList);
              finally
                MyDB.Free();
              end;
            end;
          end;
          //if(ParForm_lValues.Items.Count>0) then //pridat k jiz existujicimu seznamu
            ParForm_lValues.Items.Text:=ParForm_lValues.Items.Text+UtfToAnsi(aList.Text);
          //else //nastavit do prazdneho seznamu
          //  ParForm_lValues.Items.Text:=UtfToAnsi(ParForm_lValues.Items.Text);
        finally
          aList.Free();
        end;
      end
      else if(Pos('!INI_SECTIONS=',s1)>0) then begin //hodnoty jsou vysledkem SQL prikazu
        ParFillListFromIni(s1);
      end
      else if(Pos('!INI_VALUES=',s1)>0) then begin //hodnoty jsou vysledkem SQL prikazu
        ParFillListFromIni(s1);
      end
      else begin
        //pokud je to oddelovac, pridame pred nej jeden prazxdny radek
        if(Pos('---',s1)=1) and (ParForm_lValues.Items.Count>0) then ParForm_lValues.Items.Add('');
        ParForm_lValues.Items.Add(s1);
      end;
    end;
    //vybereme vybranou hodnotu
    if(sType='LIST') then begin
      i:=ParForm_lValues.Items.IndexOf(ParForm_eValue.Text);
      if(i>=0) then ParForm_lValues.ItemIndex:=i;
    end
    else begin
      ParForm_lValues.ItemIndex:=-1;  //na zadne polozce neni kurzor, aby se to nepletlo s vybranymi
      ParForm_lValues.MultiSelect:=true;
      s:=ParForm_eValue.Text;
      while (s<>'') do begin //divne, zustane oznacena jen posleni polozka, ne vsechny!
        s1:=Fetch(s,'|');
        //porovnani je potreba delat case sensitive, ale ParForm_lValues.Items.CaseSensitive
        //nejde nastvait (neznamy parametr), tak to musime obejit
//LDH('JJJJ hledam '+s1);
        i:=-1;
        //i:=ParForm_lValues.Items.IndexOf(s1) //toto vyhledava bez ohledu na velikost pismen
        for j:=0 to ParForm_lValues.Items.Count-1 do begin
//LDH('JJJJ j='+IntToStr(j));
          s2:=ParForm_lValues.Items[j];
          if(s1<>s2) then continue;
          i:=j;
          break;
        end;
        if(i>=0) then begin
//LDH('JJJJ oznacuji '+IntToStr(i)+'. '+ParForm_lValues.Items[i]);
          ParForm_lValues.Selected[i]:=true;
        end;
      end;
    end;
//LDH('JJJJ konec typu LIST [MULTI]');
  end;
  if(sType='COLUMNS')  then begin
    //naplnime mozne hodnoty
    s:=ParForm_eValue.Text;
    ParForm_lColumnTrg.Items.Clear();
    ParForm_lColumnTrg.Items.Text:=ReplaceString(s,'|',CRLF);
    ParForm_lValues.ItemIndex:=0;
  end;
  //int/real/string/list/listmulti/color/file/dir (/check ... jde nahradit LISTem)
  s:=ParamValueFromIni(ParForm_eModule.Caption,sName,'DESC',_('No description'));
  //zbavime se snaku ##_??_## (komentar pro preklad do jinych jazyku)
  s:=Trim(RegexReplace('##.*##',s,'',false));
  ParForm_eDesc.Caption:=ReplaceString(s,'\n',CRLF);
  //if(sType='LONGTEXT') then ParForm_eDesc.Caption:=ParForm_eDesc.Caption
  //  +CRLF+_('(Maximum length is 4000 chars!)');
  ParForm_eDesc.Visible:=true; //pro zaskrtavatko je text u zaskrtavatka
  if(sType='CHECK')  then begin  //zobrazime zvolenou hodnotu
    ParForm_bValue.Checked:=(ParForm_eValue.Text='Yes');
    //prepiseme vysvetlujici text primo k zaskrtavatku
    ParForm_bValue.Caption:=ParForm_eDesc.Caption;
    ParForm_eDesc.Visible:=false; //pro zaskrtavatko je text u zaskrtavatka
  end;
  ParForm_eValue.Visible:=(sType<>'COLUMNS')
         and (sType<>'LIST') and (sType<>'LISTMULTI')
         and (sType<>'CHECK') and (sType<>'LONGTEXT') and (sType<>'ICON')
         //and (sType<>'COLOR') and (sType<>'COORD')
         //and (sType<>'FILE') and (sType<>'DIR')
         ;
  if((sType='INT') or (sType='REAL') or (sType='STRING')
    or (sType='FILE') or (sType='DIR') or (sType='COLOR') or (sType='COORD')) then begin
    ParForm_eValue.Visible:=true;
    ParForm_eValue.Enabled:=(sType<>'COORD');
  end;
  ParForm_butFile.Visible:=(sType='FILE');
  ParForm_butDir.Visible:=(sType='DIR');
  ParForm_butColor.Visible:=(sType='COLOR');
  ParForm_butCoord.Visible:=(sType='COORD');
  ParForm_lValues.Visible:=((sType='LIST') or (sType='LISTMULTI'));
  ParForm_lPictures.Visible:=(sType='ICON');
  ParForm_PanelPicture.Visible:=(sType='ICON');

  ParForm_bValue.Visible:=(sType='CHECK');
  ParForm_lValues.Multiselect:=((sType='LISTMULTI'));

  ParForm_eLongText.Visible:=(sType='LONGTEXT');

  ParForm_lColumnTrg.Visible:=(sType='COLUMNS');
  ParForm_lColumnSrc.Visible:=(sType='COLUMNS');
  ParForm_butCustomTableHelp.Visible:=(sType='COLUMNS');
  ParForm_butAdd.Visible:=(sType='COLUMNS');
  ParForm_butDel.Visible:=(sType='COLUMNS');
  ParForm_butUp.Visible:=(sType='COLUMNS');
  ParForm_butDown.Visible:=(sType='COLUMNS');
  ParForm_PanelValue.Visible:=(sType='COLUMNS');
  ParForm_bTagMustExist.Visible:=(sType='COLUMNS');
  //nektere prvky nejsou zobrazene pro modul SetFilter
  ParForm_PanelAlign.Visible:=((sType='COLUMNS') and (ParForm_eModule.Caption<>'SetFilter'));
  ParForm_PanelSort.Visible:=((sType='COLUMNS') and (ParForm_eModule.Caption<>'SetFilter'));
  ParForm_bCounting.Visible:=((sType='COLUMNS') and (ParForm_eModule.Caption<>'SetFilter'));

  if((sType='INT') or (sType='REAL') or (sType='COLOR')) then ParForm_eValue.Width:=100
  else if((sType='FILE') or (sType='DIR')) then ParForm_eValue.Width:=459-27
  else if((sType='COORD')) then ParForm_eValue.Width:=200
  else ParForm_eValue.Width:=459;
  
  ParForm_ScrollBox1.VertScrollBar.Position:=0; //posuneme scrollbar nahoru

  lParColumnTrgOnClick(nil);
  lParColumnSrcOnClick(nil);
  
  ParForm_bPom.Checked:=false;
  //zobrazime hodnotu parametru
end;

procedure SavePar;
var s,sOrg,sName,sType:string;
    i:integer;
begin
  //pri otevreni formulare nic neukladame, prepsaly by se drive zobrazene hodnoty
  //do aktualne vybraneho parametru
  if(ParForm_eLastItem.Text='') then exit;
  s:=ParForm_lParams.Items[StrToInt(ParForm_eLastItem.Text)];
  ItemsFromParam(s,sOrg,sType,sName,s);
  case UpperCase(sType) of
  'INT','REAL','STRING','COLOR','COORD': s:=ParForm_eValue.Text;
  'ICON': s:=ParForm_eValue.Text;
  'LONGTEXT': s:=ReplaceString(ParForm_eLongText.Lines.Text,CRLF,'%CRLF%');
  'FILE','DIR':  s:=ParForm_eValue.Text;
  'LIST': if(ParForm_lValues.Items[ParForm_lValues.ItemIndex]<>'') and
            (Pos('---',ParForm_lValues.Items[ParForm_lValues.ItemIndex])<>1) then
            //jen pokud to neni oddelovac
            s:=ParForm_lValues.Items[ParForm_lValues.ItemIndex];
  'LISTMULTI': begin
                 s:='';
                 for i:=0 to ParForm_lValues.Items.Count-1 do begin
                   if(ParForm_lValues.Selected[i]) and (ParForm_lValues.Items[i]<>'')
                     and (Pos('---',ParForm_lValues.Items[i])<>1) //a neni to oddelovac
                     then s:=s+CRLF+ParForm_lValues.Items[i];
                 end;
                 s:=ReplaceString(Trim(s),CRLF,'|');
               end;
  'CHECK':if(ParForm_bValue.Checked) then s:='Yes' else s:='No';
  'COLUMNS': begin
               s:=ReplaceString(Trim(ParForm_lColumnTrg.Items.Text),CRLF,'|');
               //s:='';
               //for i:=0 to ParForm_lColumnTrg.Items.Count-1 do s:=s+ParForm_lColumnTrg.Items[i]+CRLF;
               //s:=ReplaceString(Trim(s),CRLF,'|');
             end;  
  end;
  s:=sOrg+'.'+sType+'|'+sName+'='+s;
  ParForm_lParams.Items[StrToInt(ParForm_eLastItem.Text)]:=s;
  ParForm_lParams.Invalidate(); //prekreslime polozku
end;

procedure lParamsOnClick(sender:TObject);
begin
  //pokud je treba, prepiseme zmenenou hodnotu parametru
  if(ParForm_bPom.Checked) then begin
    SavePar();
    ParForm_butOk.Enabled:=true; //poznacime zmenene hodnoty k ulozeni
  end;
  ParShowElem();
  //poznacime si aktualne vybrany parametr
  ParForm_eLastItem.Text:=IntToStr(ParForm_lParams.ItemIndex);
end;

function EditParams(module:string; aList:TStringList):integer;
var ini:TMemIniFile;
    i:integer;
    s,s1,sOrg,sType,sName,sParams,sStatus:string;
begin
  ParForm_eLastItem.Text:='';
  ParForm_lParams.Clear();
  ParForm_eModule.Caption:=module;
  //ShowMessage('SSSS EditParams 1');
  ini:=TMemIniFile.Create(GetModuleDirFromName(module)+module+'.ini');
  try
    sParams:=','+ini.ReadString('Module','PARAMS','')+',';
//{$ifdef DEBUG_HELPER} LDH('seznam parametru: '+sParams); {$endif}
    for i:=0 to aList.Count-1 do begin
      //zkontrolovat, zda je to existujici parametr, jinak jej ignorujeme
      s:=aList[i];
      if(sStatus='') then sStatus:=s[4]; //zapamatujeme si stav pro pridani dalsich parametru
      sOrg:=Fetch(s,'.');
      sName:=Fetch(s,'=');
//{$ifdef DEBUG_HELPER} LDH('sName='+sName); {$endif}
      if(Pos(','+sName+',',sParams)<>0) then begin
        sType:=UpperCase(ParamValueFromIni(ParForm_eModule.Caption,sName,'TYPE',''));
        ParForm_lParams.Items.Add(sOrg+'.'+sType+'|'+sName+'='+s);
        sParams:=ReplaceString(sParams,','+sName+',',',');    //vypuststeni zpracovaneho parametru ze seznamu
      end;
    end;
  finally
    ini.Free();
  end;
  //ShowMessage('SSSS EditParams 2');
  if(sStatus='') then sStatus:='E'; //implicitni hodnota je Enable
  //pridame vsechny zbyvajici parametry
  while (sParams<>'') do begin
    sName:=Fetch(sParams,',');
    //jeste by to chtelo ziskat organizacni cast a implicitni hodnotu
    if(sName='') then continue;
    s:=UpperCase(ParamValueFromIni(ParForm_eModule.Caption,sName,'Level',''));
    case s of
    'BEGINNER': s:='B';
    //'EASY':  s:='E';
    'EXPERT':s:='X';
    'DEBUG': s:='D';
    else s:='X';
    end;
    sType:=UpperCase(ParamValueFromIni(ParForm_eModule.Caption,sName,'TYPE',''));
    s:=ParamValueFromIni(ParForm_eModule.Caption,sName,'Default','');
    if(sType='FILE') then begin //pokud je pozadovan soubor, musime oddelit implicitni jmeno souboru od pripony a implicitniho adresare
      s1:=Fetch(s,'|');
      s:=s1;
    end;
    sName:='P'+s+'M'+sStatus+'.'+sType+'|'+sName+'=';
    ParForm_lParams.Items.Add(sName+s);
  end;
  ParForm_lParams.ItemIndex:=0;
  lParamsOnClick(nil);
  Result:=ParForm.ShowModal();
end;

procedure ParOnChange(sender:TObject);
var b,b1:boolean;
    iPozadi:integer;
begin
  ParForm_bPom.Checked:=true;
  ParForm_butOk.Enabled:=true;
  if(ParForm_eLongText.Visible) then begin
    //otestujeme pocet znaku v eLongText poli, kvuli TMemIniFile je omezeni na 2000 znaku,
    //ale testujeme mene, protoze misto CRLF se fo INI uklada %CRLF%, tedy na
    //kazdy radek o 2 znaky vic
    b:=false;
    //TMemIniFile uz omezeni nema
    //b:=Length(ParForm_eLongText.Lines.Text)>1800;
    b1:=false;
    iPozadi:=ParForm_eDesc.Font.Color;
    //zmenu provadime jen kdyz je potreba
    if(b) and (iPozadi<>$020000ff) then begin
      ParForm_eLongText.Brush.Color:=$02cbc0ff; //zmenime barvu pozadi
      ParForm_eDesc.Font.Color:=$020000ff;
      ParForm_eDesc.Font.Style:=[fsBold];
      b1:=true;
    end;
    if(not b) and (iPozadi=$020000ff) then begin
      ParForm_eLongText.Brush.Color:=$02ffffff; //zmenime barvu pozadi
      ParForm_eDesc.Font.Color:=$02000000;
      ParForm_eDesc.Font.Style:=[];
      b1:=true;
    end;
    if(b1) then ParForm_eLongText.Refresh(); //prekreslime, aby se projevila zmena pozadi hned
  end;
end;

procedure butParOkOnClick(sender:TObject);
begin
  //ulozime zmenenou a neulozenou polozku
  if(ParForm_bPom.Checked) then SavePar();
end;

procedure butParAddOnClick(sender:TObject);
var s1,s:string;
begin
  s:=ParForm_lColumnSrc.Items[ParForm_lColumnSrc.ItemIndex];
  s1:=Fetch(s,'('); //bez pripadneho komentare v zavorce 
  ParForm_lColumnTrg.Items.Insert(ParForm_lColumnTrg.ItemIndex+1,s1);
  ParForm_lColumnTrg.ItemIndex:=ParForm_lColumnTrg.ItemIndex+1;
  lParColumnSrcOnClick(nil);
  lParColumnTrgOnClick(nil);
  ParOnChange(nil);
end;

procedure butParDelOnClick(sender:TObject);
var i:integer;
begin
  i:=ParForm_lColumnTrg.ItemIndex;
  ParForm_lColumnTrg.Items.Delete(i);
  if(i>ParForm_lColumnTrg.Items.Count-1) then i:=ParForm_lColumnTrg.Items.Count-1;
  ParForm_lColumnTrg.ItemIndex:=i;
  lParColumnSrcOnClick(nil);
  lParColumnTrgOnClick(nil);
  ParOnChange(nil);
end;

procedure butParUpOnClick(sender:TObject);
var i:integer;
    //s:string;
begin
  i:=ParForm_lColumnTrg.ItemIndex;
  ParForm_lColumnTrg.Items.Move(i,i-1);
  ParForm_lColumnTrg.ItemIndex:=i-1;
  lParColumnTrgOnClick(nil);
  ParOnChange(nil);
end;

procedure butParDownOnClick(sender:TObject);
var i:integer;
    //s:string;
begin
  i:=ParForm_lColumnTrg.ItemIndex;
  ParForm_lColumnTrg.Items.Move(i,i+1);
  ParForm_lColumnTrg.ItemIndex:=i+1;
  lParColumnTrgOnClick(nil);
  ParOnChange(nil);
end;

procedure butParLeftOnClick(sender:TObject);
var flags:REC_COLUMN_FLAGS;
begin
  if(ParForm_lColumnTrg.ItemIndex<0) then exit;
  ParseColumnFlags(ParForm_lColumnTrg.Items[ParForm_lColumnTrg.ItemIndex],flags);
  case sender of
    ParForm_butLeft:   if(UpperCase(flags.sAlign)='LEFT')   then flags.sAlign:='' else flags.sAlign:='Left';
    ParForm_butCenter: if(UpperCase(flags.sAlign)='CENTER') then flags.sAlign:='' else flags.sAlign:='Center';
    ParForm_butRight:  if(UpperCase(flags.sAlign)='RIGHT')  then flags.sAlign:='' else flags.sAlign:='Right';
    ParForm_butHide:   if(UpperCase(flags.sAlign)='HIDE')   then flags.sAlign:='' else flags.sAlign:='Hide';
  
    ParForm_butAscending: if(UpperCase(flags.sSort)='ASC')   then flags.sSort:='' else flags.sSort:='Asc';
    ParForm_butDescending: if(UpperCase(flags.sSort)='DESC')  then flags.sSort:='' else flags.sSort:='Desc';
  
    ParForm_eTagValue: flags.sValue:=ParForm_eTagValue.Text;
    ParForm_lOperator: begin
                         ParForm_eTagValue.Enabled:=(ParForm_lOperator.ItemIndex<>0);
                         if(ParForm_lOperator.ItemIndex=0) then begin
                           flags.sOperator:='';
                           //ParForm_eTagValue.Text:='';
                         end
                         else flags.sOperator:=ParForm_lOperator.Items[ParForm_lOperator.ItemIndex];
                       end;
    ParForm_bColNumeric: flags.bNumeric:=ParForm_bColNumeric.Checked;
    ParForm_bCounting: flags.bCounting:=ParForm_bCounting.Checked;
    ParForm_bTagMustExist: flags.bTagMustExist:=ParForm_bTagMustExist.Checked;
  end;
  ParForm_lColumnTrg.Items[ParForm_lColumnTrg.ItemIndex]:=MakeColumnFlags(flags);
  ParOnChange(nil);
end;

procedure butParAscOnClick(sender:TObject);
begin
  ParOnChange(nil);
end;

{
procedure ParTagValueOnChange(sender:TObject);  //prepsat hodnotu tagu
var i:integer;
    s,s1,s2:string;
begin
  i:=ParForm_lColumnTrg.ItemIndex;
  if(i<0) then exit;
  s:=ParForm_lColumnTrg.Items[i];
  s1:=Fetch(s,'=');
  s2:=Fetch(s1,'#');
  s1:=ParForm_eTagValue.Text;
  if(s1<>'') then s1:='#'+s1;
  if(s<>'') then s:='='+s;
  s:=s2+s1+s;
  ParForm_lColumnTrg.Items[i]:=s;
  ParOnChange(nil);
end;
}

procedure ParOnKeyDown(sender:TObject;var Key: Word; Shift: TShiftState);
var i:integer;
begin
  //pri ESC uzavreme dialog
  if(Key=27) then begin
    //ShowMessage('Key='+IntToStr(Key));
    PostMessage(ParForm.Handle,$10{=WM_CLOSE},0,0);
    Key:=0; //priznak zpracovaneho tlacitka
  end;
  if(Key=13) then begin //Pri Enter kliknout na OK
    //ShowMessage('Key='+IntToStr(Key));
    PostMessage(ParForm_butOK.Handle,$F5{=WM_CLICK},0,0);
    Key:=0; //priznak zpracovaneho tlacitka
  end;
  if(sender=ParForm_lValues) and (ParForm_lValues.MultiSelect=true) then begin
    //CTRL+A oznaci vsechny polozky
    if((Key=65) and (Shift=[ssCtrl])) then begin
      for i:=0 to ParForm_lValues.Items.Count-1 do begin
        ParForm_lValues.Selected[i]:=true;
      end;
      Key:=0; //priznak zpracovaneho tlacitka
    end;
  end;
end;

procedure butParFileOnClick(sender:TObject);
var s,sExt,sDir:string;
begin
  //ziskame parametry pro inicializaci dialogu z DEFAULT hodnot
  s:=ParForm_lParams.Items[ParForm_lParams.ItemIndex]; //jmeno parametru
  sDir:=Fetch(s,'=');
  s:=Fetch(sDir,'|');
  if(sDir<>'') then s:=sDir;
  sExt:=ParamValueFromIni(ParForm_eModule.Caption,s,'Values','');
  s:=Fetch(sExt,'|');
  if(ParForm_eValue.Text<>'') then s:=ParForm_eValue.Text;
  sDir:=Fetch(sExt,'|');
  sDir:=ReplaceString(sDir,'GEOGET_DATADIR',GEOGET_DATADIR);
  sDir:=ReplaceString(sDir,'GEOGET_SCRIPTDIR',GEOGET_SCRIPTDIR);
  if(sDir='') then sDir:=GetProfileDir();
  if(sExt='') then sExt:=_('HTML files')+' (*.html,*.htm)|*.html;*.htm'   //filtr
                    +'|'+_('All files')+' (*.*)|*.*';   //filtr
  if(OpenDlg(_('Select file'),                //title
               sDir,                          //InitDir
              'ofFileMustExist,ofHideReadOnly,ofNoChangeDir', //options
              sExt,                           //filtr pripon
              s)) then begin
    //soubor (pro CmdFileOutput) se hleda napred v adresari profilu, pak ve
    //scriptdir a nakonec v datadir, proto hledame tuto cestu a pripadne ji smazeme
    s:=ReplaceString(s,GetProfileDir(),'');
    s:=ReplaceString(s,GEOGET_SCRIPTDIR+'\','');
    s:=ReplaceString(s,GEOGET_DATADIR+'\','');
    ParForm_eValue.Text:=s;
    ParOnChange(nil);
  end;
end;

procedure butParDirOnClick(sender:TObject);
var s:string;
begin
  s:=ParForm_eValue.Text;
  if(s='') then s:=GetProfileDir();
  s:=SelectDir(s,_('Select directory'));
  if(s<>'') then begin
    ParForm_eValue.Text:=s;
    ParOnChange(nil);
  end;
end;

procedure butParCoordOnClick(sender:TObject);
var s:string;
    x,y:extended;
    b:boolean;
begin
  s:=Trim(ParForm_eValue.Text); //stavajici souradnice
  if(s='') then s:='50 00.000; 14 00.000'; //aby tam nejake byly
  ParseWgsStr(s,x,y);           //parsujeme
  b:=CoordEdit(_('Map center coordinates'),'',x,y); 
  if(b) then begin
    ParForm_eValue.Text:=FormatCoordNum(x,y);
    ParOnChange(nil);
  end;
end;

function StringToRGB(str:string):TColor;
var rgb,r,g,b:integer;
begin
  rgb:=HexToDec(str);
  r:=(rgb div $10000);
  g:=((rgb mod $10000) div $100) shl 8;
  b:=(rgb mod $100) shl 16;
  Result:=b+g+r;
end;

procedure butParColorOnClick(sender:TObject);
var cd:TColorDialog;
    s:string;
begin
  cd:=TColorDialog.create(nil);
  s:=ParForm_eValue.Text;        //nacteme RGB barvu a prevedeme ji na TColor
  cd.Color:=StringToRGB(s);      //do dialogu
  cd.Options:=[cdFullOpen];
  if(cd.Execute()) then begin
    s:=DecToHex(cd.Color as integer, 6);
    s:=copy(s,5,2)+copy(s,3,2)+copy(s,1,2);
    ParForm_eValue.Text:=s;     //barvu zapiseme do textoveho pole
  end;
end;

procedure butCustomTableHelpOnClick(sender:TObject);
var s:string;
begin
  //naplnime help vysvetlujici obsah a jeho zadavani
  if(ParForm_eModule.Caption<>'SetFilter') then begin
    s:=GetModulesDir()+'CustomizedTable_'+sLang+'.html';
    if(not FileExists(s)) then s:=GetModulesDir()+'CustomizedTable_EN.html';
    s:=FileToString(s);
    ShowHTMLMessageSize('CustomizeTable - Help',s,800,500);
    exit;
  end;
  s:=GetModulesDir()+'Conditions_'+sLang+'.html';
  if(not FileExists(s)) then s:=GetModulesDir()+'Conditions_EN.html';
  s:=FileToString(s);
  ShowHTMLMessageSize('Conditions - Help',s,800,500);
  exit;
end;

procedure InitPar;
var aList:TStringList;
    i,j:integer;
begin
{$ifdef PROFILER}ProfileStart('InitPar');{$endif}   //OK
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitPar(), start');
{$endif}
  GeoBusyKind(_('Loading parameters')); 
  ParForm_bPom.Visible:=false{(Uppercase(GEOGET_OWNER)='GORDICI')};
  ParForm_eLastItem.Visible:=false{(Uppercase(GEOGET_OWNER)='GORDICI')};
  //ParForm_lValues.Items.CaseSensitive:=true; //zatim to nezna, musim si porovnani delat sam
  bReadPict:=false;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 2');
{$endif}
  ParForm_lParams.OnDrawItem:=@lParamsDrawItem;
  ParForm_lParams.OnClick:=@lParamsOnClick;
  ParForm_butOk.Enabled:=false;
  ParForm_butOk.OnClick:=@butParOkOnClick;
  ParForm_lValues.OnDrawItem:=@lValuesDrawItem;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 3');
{$endif}
  ParForm_eValue.OnChange:=@ParOnChange;
  ParForm_eLongText.OnChange:=@ParOnChange;
  ParForm_bValue.OnClick:=@ParOnChange;
  ParForm_lValues.OnClick:=@ParOnChange;
  //ParForm_eTagValue.OnChange:=@ParTagValueOnChange;
  ParForm_eTagValue.OnChange:=@butParLeftOnClick;
  //ParForm_eTagValue.OnClick:=@butParLeftOnClick;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 4');
{$endif}
  ParForm_butAdd.OnClick:=@butParAddOnClick;
  ParForm_butDel.OnClick:=@butParDelOnClick;
  ParForm_butUp.OnClick:=@butParUpOnClick;
  ParForm_butDown.OnClick:=@butParDownOnClick;
  
{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 5');
{$endif}
  ParForm_lColumnSrc.OnClick:=@lParColumnSrcOnClick;
  ParForm_lColumnTrg.OnClick:=@lParColumnTrgOnClick;

  ParForm_butLeft.OnClick:=@butParLeftOnClick;
  ParForm_butCenter.OnClick:=@butParLeftOnClick;
  ParForm_butRight.OnClick:=@butParLeftOnClick;
  ParForm_butHide.OnClick:=@butParLeftOnClick;

  ParForm_butAscending.OnClick:=@butParLeftOnClick;
  ParForm_butDescending.OnClick:=@butParLeftOnClick;
  ParForm_bCounting.OnClick:=@butParLeftOnClick;
  ParForm_bColNumeric.OnClick:=@butParLeftOnClick;
  ParForm_bTagMustExist.OnClick:=@butParLeftOnClick;
  ParForm_lOperator.OnChange:=@butParLeftOnClick;

  ParForm_butCustomTableHelp.OnClick:=@butCustomTableHelpOnClick;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 6');
{$endif}
  //umistime ovladaci prvky, nastavime velikosti
  ParForm_eValue.Top:=36;      ParForm_eValue.Left:=322;    ParForm_eValue.Width:=459;
  //    ParForm_eValue.Brush.Color:=$02123456; //zmenime barvu pozadi
  ParForm_lValues.Top:=36;     ParForm_lValues.Left:=322;   ParForm_lValues.Height:=280;  ParForm_lValues.Width:=459;
  ParForm_eLongText.Top:=36;   ParForm_eLongText.Left:=322; ParForm_eLongText.Height:=280;ParForm_eLongText.Width:=459;
  ParForm_bValue.Top:=36;      ParForm_bValue.Left:=322;    ParForm_bValue.Height:=60;    ParForm_bValue.Width:=459;
  ParForm_butFile.Top:=35;     ParForm_butFile.Left:=753;   ParForm_butFile.Caption:='';  ParForm_butFile.Width:=26;
  ParForm_butDir.Top:=35;      ParForm_butDir.Left:=753;    ParForm_butDir.Caption:='';   ParForm_butDir.Width:=26;
  ParForm_butColor.Top:=35;    ParForm_butColor.Left:=424;  ParForm_butColor.Caption:=''; ParForm_butColor.Width:=26;
  ParForm_butCoord.Top:=35;    ParForm_butCoord.Left:=524;  ParForm_butCoord.Caption:=''; ParForm_butCoord.Width:=26;
  ParForm_lPictures.Top:=36;   ParForm_lPictures.Left:=322; ParForm_lPictures.Height:=280;ParForm_lPictures.Width:=354;
  ParForm_PanelPicture.Top:=36;ParForm_PanelPicture.Left:=322+359;
  ParForm_lColumnTrg.Top:=36;  ParForm_lColumnTrg.Height:=202;
  ParForm_lColumnSrc.Top:=36;  ParForm_lColumnSrc.Height:=202;
  ParForm_PanelValue.Top:=264; ParForm_PanelValue.Left:=322; ParForm_PanelValue.Width:=459;
  ParForm_bTagMustExist.Top:=242;   ParForm_bTagMustExist.Left:=574;
  ParForm_eDesc.Top:=0;        ParForm_eDesc.Left:=0;       ParForm_eDesc.Height:=150; ParForm_eDesc.Width:=432;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 7');
{$endif}
  //pro ovladani Esc
  ParForm.OnKeyDown:=@ParOnKeyDown;
  ParForm_bPom.OnKeyDown:=@ParOnKeyDown;
  ParForm_lParams.OnKeyDown:=@ParOnKeyDown;
////////
  ParForm_eValue.OnKeyDown:=@ParOnKeyDown;
  ParForm_lValues.OnKeyDown:=@ParOnKeyDown;
  ParForm_bValue.OnKeyDown:=@ParOnKeyDown;
  ParForm_butFile.OnClick:=@butParFileOnClick;
  ParForm_butDir.OnClick:=@butParDirOnClick;
  ParForm_butCoord.OnClick:=@butParCoordOnClick;
  ParForm_butColor.OnClick:=@butParColorOnClick;
  //ParForm_butColor.OnKeyDown:=@ParOnKeyDown;
  ParForm_lColumnTrg.OnKeyDown:=@ParOnKeyDown;
  ParForm_lColumnSrc.OnKeyDown:=@ParOnKeyDown;
  ParForm_lPictures.OnClick:=@lPictOnClick;
  ParForm_lPictures.OnDrawItem:=@lPictDrawItem;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 8');
{$endif}
  //naplnime popis sloupcu
  aColumnDesc[0]:=_('Include cache ID');
  aColumnDesc[1]:=_('Include cache type in text format (Traditional, Unknown, ...)');
  aColumnDesc[2]:=_('Include cache type icon');
  aColumnDesc[3]:=_('Include cache type in text format + icon');
  aColumnDesc[4]:=_('Include cache name');
  aColumnDesc[5]:=_('Include cache size in text format (Small, Large, ...)');
  aColumnDesc[6]:=_('Include cache size icon');
  aColumnDesc[7]:=_('Include cache size in text format + icon');
  aColumnDesc[8]:=_('Include cache size as a number that allows proper sorting by size cache (column alignment should be set to Hide)');
  aColumnDesc[9]:=_('Include cache difficulty in text format (1.5, 4, ...)');
  aColumnDesc[10]:=_('Include cache difficulty icon (stars)');
  aColumnDesc[11]:=_('Include cache difficulty in text format + icon (stars)');
  aColumnDesc[12]:=_('Include cache terrain in text format (2, 4.5, ...)');
  aColumnDesc[13]:=_('Include cache terrain icon (stars)');
  aColumnDesc[14]:=_('Include cache terrain in text format + icon (stars)');
  aColumnDesc[15]:=_('Include cache status in text format (Disabled, Archived, ...)');
  aColumnDesc[16]:=_('Include cache status icon');
  aColumnDesc[17]:=_('Include cache status in text format + icon');
  aColumnDesc[18]:=_('Include cache owner');
  aColumnDesc[19]:=_('Include date when the cache was created');
  aColumnDesc[20]:=_('Include cache coordinates');
  aColumnDesc[21]:=_('Include country in which the cache is hidden');
  aColumnDesc[22]:=_('Include country flag');
  aColumnDesc[23]:=_('Include country flag and name');
  aColumnDesc[24]:=_('Include name for state in which the cache id hidden');
  aColumnDesc[25]:=_('Include ID, type (as icon), status, name and country (as flag)');
  aColumnDesc[26]:=_('Include ID, type (as icon), status, name');
  aColumnDesc[27]:=_('Include distace from home coordinates');
  aColumnDesc[28]:=_('Include direction from home coordinates');
  aColumnDesc[29]:=_('Include icon for direction from home coordinates');
  aColumnDesc[30]:=_('Include date of find');
  aColumnDesc[31]:=_('Include time of find');
  aColumnDesc[32]:=_('Include date ant time of find');
  aColumnDesc[33]:=_('Include interval (number of days from previous row)');
  aColumnDesc[34]:=_('Include find order');
  aColumnDesc[35]:=_('Show row order number');
  aColumnDesc[36]:=_('Include date of last find');
  aColumnDesc[37]:=_('Number of order in column (by Counting chcekbox)');
  aColumnDesc[38]:=_('Percent (count from column by Counting chcekbox)');
  aColumnDesc[39]:=_('Histogram (count from column by Counting chcekbox)');
  aColumnDesc[40]:=_('Percent as the result of SQL commands in the module SQLTable');
  aColumnDesc[41]:=_('Histogram - histogram bar length (in percentage) is the result of SQL commands in the module SQLTable');

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 9');
{$endif}
  //doplnime seznam vsech tagu
  j:=ParForm_lColumnSrc.Items.Count;
  aList:=TStringList.Create();
{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 9a');
{$endif}
  Geoget_DB.GetTableStrings('SELECT value FROM geotagcategory order by value',aList);
{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 9b count='+IntToStr(aList.Count));
{$endif}
  for i:=0 to aList.Count-1 do begin
{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 9c - i='+IntToStr(i)+', '+UtfToAnsi(aList[i]));
{$endif}
    if(i+j+1>MAX_ColumnDesc) then
      ShowMessage(_('ERR: Too many TAGs for choosing columns in CustomizedTable')+CRLF
        +'('+IntToStr(i)+'. tag: '+UtfToAnsi(aList[i])+')')
    else begin
      ParForm_lColumnSrc.Items.Add('tag-'+UtfToAnsi(aList[i]));
      aColumnDesc[i+j]:=_('Tag category:')+' '+UtfToAnsi(aList[i]);
    end;
  end;

{$ifdef DEBUG_HELPER}
  //LDH('InitPar() -> 10');
{$endif}
  //naplnime seznam vsech obrazku
  for j:=0 to nGlobalVar-1 do begin
    if(Pos('IconLayout',aGlobVarName[j])>0) then ParForm_lPictures.Items.Add(aGlobVarValue[j]);
  end;
  aList.Free();
{$ifdef DEBUG_HELPER}
  LDH('FormInit() -> InitPar(), stop');
{$endif}
{$ifdef PROFILER}ProfileStop();{$endif}
end;