const 
  CalcMain_sModuleTmp = '\Stator\Tmp\';
  CalcMain_CachersStatGUID = 'http://www.cacherstats.com/cgi-bin/GeocacherLocations.pl?Language=EN&UserGUID=';

//uvolnovaci funkce modulu
procedure CalcMain_Free;
begin
  Log('Start CalcMain_Free()');
end;

//ukazkova funkce pro nahradu globalnich promennych
//nedela nic, jen do vystupu vypise predane parametry
function CalcMain_ReplaceVars(aPar:TStringList):string;
begin
  Log(aPar.Text);
  Result:='<p>Parametry funkce CalcMain_ReplaceVar():<ul><li>'+ReplaceString(aPar.Text,CRLF,'</li><li>')+'konec parametru</li></ul></p>';
end;

procedure CalcMain_SetVarFromSql(sName,sSql:string; idx:integer);
var tab: TSqliteTable;
    s:string;
    //s1:string;
    //i:integer;
begin
  s:='';
  //s1:='ABCDEF: var='+sName+', idx='+IntToStr(idx)+':    ';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    //vypiseme do logu vsechny sloupce
    //for i:=0 to tab.ColCount-1 do begin
    //  s1:=s1+tab.Columns[i]+'='+tab.FieldAsString(i)+'; ';
    //end;
    s:=tab.FieldAsString(idx);
  finally
    tab.Free();
  end;
  GlobalVarSet(sName,s);
  //s1:=s1+', s='+s+', var='+GlobalVarGet(sName,false);
  //Log(s1);
end;

//Integer varianta - pevede na INT a ulo
procedure CalcMain_SetVarFromSql_Int(sName,sSql:string; idx:integer);
var tab: TSqliteTable;
    s:string;
    val:integer;
begin
	s:='';
	tab:=Geoget_DB.GetTable(sSql, false);
	try
		s:=tab.FieldAsString(idx);
		val := Round(StrToFl(s));
	finally
		tab.Free();
	end;
	GlobalVarSet(sName,IntToStr(val));
end;

//----------------------------------------------------------------------------------------------
function CalcMain_GetTableValue(Const Input, Param:String):String;
var
	s, sPar: String;
begin
	Result := '0';
	while Input <> '' do begin
		s := Fetch(Input,'|');
		sPar := Fetch(s,',');
		if (sPar = Param) then begin
			Result := s;
			break;
		end;
	end;
end;

//----------------------------------------------------------------------------------------------
//hlavni funkce modulu
function CalcMain_Run(aPar:TStringList):string;
var sSql,s, sa, sb, sc, sEvent, stmp, msg, f:string;
    tab: TSqliteTable;
    i,n,nDnuCelkem,nDnuKesek,nMonth,nYear,nFTF,ico,ieo,m:integer;
    fPerDay,fPerCachingDay, fYearCelkem, fl:extended;
    b:boolean;
    ls, lc: TStringList;
    dt: TDateTime;
begin
  Result:=''; ico:=0; ieo:=0;
  Log('Start CalcMain_Run()');
  //registrovat ukazkovou funkci
  GlobalVarRegisterReplaceFunction('CalcMain_ReplaceVars',@CalcMain_ReplaceVars);

  //Celkovy pocet nalezu: XXXX nalezu za XXXX dnu hledani behem XXXX dnu (existence uctu) celkem.
    //pocet dnu od zalozeni uctu beru jako pocet dnu od nalezu prvni kese, nemam kde ten den ziskat
    sSql:='SELECT'
      +' round(1+julianday("now")-julianday(substr(mi,1,4)||"-"||substr(mi,5,2)||"-"||substr(mi,7,2))) PocetCelkem'
      +', PocetKeskovacich'
      +', substr(mi,1,4) miRok, substr(mi,5,2) miMes'
      +', strftime("%Y","now") maRok, strftime("%m","now") maMes'
      +' FROM ('
      +' SELECT min(dny) mi, max(dny) mx, count(dny) PocetKeskovacich'
      +'  FROM (SELECT distinct(dtfound) dny FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql
      +') x)';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    s:=tab.FieldByName['PocetCelkem'];
    nDnuCelkem:=StrToInt(Fetch(s,'.'));           //vysledne cislo ma desetinnou tecku!
    if(nDnuCelkem<=0) then nDnuCelkem:=1;          //abychom nikde nedelili nulou
  	fYearCelkem:=nDnuCelkem/365.00
    GlobalVarSet('Calc_DaysTotal',IntToStr(nDnuCelkem));
    GlobalVarSet('Calc_YearsTotal', FormatFloatDot('0.0',fYearCelkem));
    nDnuKesek:=StrToInt(tab.FieldByName['PocetKeskovacich']);
    if(nDnuKesek<=0) then nDnuCelkem:=1;          //abychom nikde nedelili nulou
    GlobalVarSet('Calc_DaysCaching',IntToStr(nDnuKesek));
    nYear:=StrToInt(tab.FieldByName['maRok'])-StrToInt(tab.FieldByName['miRok']);
    nMonth:=1+StrToInt(tab.FieldByName['maMes'])-StrToInt(tab.FieldByName['miMes']);
    nMonth:=12*nYear+nMonth;
    if(nYear=0) then Inc(nYear);
  finally
    tab.Free();
  end;
  if(nDnuCelkem<=0) then nDnuCelkem:=1;
  if(nDnuKesek<=0) then nDnuKesek:=1;
  n:=StrToInt(GlobalVarGet('FoundCachesCount',false));
  fPerDay:=(0.+n)/nDnuCelkem;
  fPerCachingDay:=(0.+n)/nDnuKesek;
  GlobalVarSet('Calc_AvgPerCachingDay',FormatFloatDot('0.############',fPerCachingDay));
  GlobalVarSet('Calc_AvgPerCachingDayRound2',FormatFloatDot('0.00',fPerCachingDay));
  GlobalVarSet('Calc_AvgPerDay',FormatFloatDot('0.############',fPerDay));
  GlobalVarSet('Calc_AvgPerDayRound2',FormatFloatDot('0.00',fPerDay));
  GlobalVarSet('Calc_AvgPerWeek',FormatFloatDot('0.############',(0.+n)/nDnuCelkem*7));
  GlobalVarSet('Calc_AvgPerWeekRound2',FormatFloatDot('0.00',(0.+n)/nDnuCelkem*7));
  if(nMonth=0) then s:=IntToStr(n) else begin
    s:=FormatFloatDot('0.############',(0.+n)/nMonth);
    GlobalVarSet('Calc_AvgPerMonth',s);
    GlobalVarSet('Calc_AvgPerMonthRound2',FormatFloatDot('0.00',(0.+n)/nMonth));
  end;
  if(nYear=0) then s:=IntToStr(n) else begin
    s:=FormatFloatDot('0.############',(0.+n)/nYear);
    GlobalVarSet('Calc_AvgPerYear',s);
    GlobalVarSet('Calc_AvgPerYearRound2',FormatFloatDot('0.00',(0.+n)/nYear));
  end;

  //Nejvice nalezu tydne: xxx od xx.xx.yyyy do xx.xx.yyyy
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho tyden v roce a prevedeme tak, aby 0 bylo pondeli
    //%W vraci poradi tydne v roce 00 - 53, seskupit a count podle teto hodnoty
  sSql:='SELECT count(rok||tyden) pocet, tyden, rok, dtfound, pondeli,nedele FROM'
   +' ('
   +' SELECT substr(dtfound,1,4) rok, dtfound, (strftime("%W",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))) tyden'
   +'   ,(strftime("%d.%m.%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"-6 days","weekday 1")) pondeli'
   +'   ,(strftime("%d.%m.%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"weekday 0")) nedele'
   +'   FROM geocache gc where gc.dtfound>0 AND '+sCachePrefixForSql
   +' ) x'
   +' GROUP BY rok||tyden ORDER BY count(rok||tyden) desc LIMIT 1'
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_SumMaxInWeekCount',tab.FieldByName['Pocet']);
    GlobalVarSet('Calc_SumMaxInWeekFrom',tab.FieldByName['pondeli']);
    GlobalVarSet('Calc_SumMaxInWeekTo',tab.FieldByName['nedele']);
  finally
    tab.Free();
  end;

  //Nejvice nalezu za vikend: 40 v soubotu 15.10.2011 a nedeli 16.10.2011
    //takto postaveny select vraci "nahodne vikendove datum" (So nebo Ne), proto
    //vracim i poradi dne v tydnu - 5=So, 6=Ne, abych vedel, jak a co vlastne vypsat
  sSql:='SELECT count(RokTyden) pocet, substr(dtfound,7,2)||"."||substr(dtfound,5,2)||"."||substr(dtfound,1,4) datum, den FROM ('
    +' SELECT dtfound'
    +'  ,substr(dtfound,1,4)||"."||strftime("%W",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2)) RokTyden'
    +'  ,((strftime("%w",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))+6)%7) den'
    +'  ,strftime("%W",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2)) tyden'
    +'  FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+' AND'
    +'   ((strftime("%w",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))+6)%7)>=5'
    +'  ) x'
    +' GROUP by RokTyden ORDER BY count(RokTyden) desc LIMIT 1';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_SumMaxInWeekendCount',tab.FieldByName['Pocet']);
    GlobalVarSet('Calc_SumMaxInWeekendFrom',tab.FieldByName['datum']);
  finally
    tab.Free();
  end;
  
  // Nejvice nalezu behem mesice a roku
  sSql:='SELECT count(mesic) pocet, substr(mesic,5,2) mesic,substr(mesic,1,4) rok FROM'
    +' (SELECT substr(dtfound,1,6) mesic FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +' GROUP BY mesic ORDER BY count(mesic) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_SumMaxInMonthCount',tab.FieldByName['Pocet']);
    GlobalVarSet('Calc_SumMaxInMonth',GlobalVarGet('Month'+tab.FieldByName['mesic'],false));
    GlobalVarSet('Calc_SumMaxInMonthYear',tab.FieldByName['rok']);
  finally
    tab.Free();
  end;
  sSql:='SELECT count(rok) pocet, rok FROM'
    +' (SELECT substr(dtfound,1,4) rok FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +' GROUP BY rok ORDER BY count(rok) desc';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_SumMaxInYearCount',tab.FieldByName['pocet']);
    GlobalVarSet('Calc_SumMaxInYear',tab.FieldByName['rok']);
  finally
    tab.Free();
  end;

  // stare, mlade, archivy a disable
  CalcMain_SetVarFromSql('Calc_AgeOldestID','SELECT min(dthidden) mi, id FROM geocache gc WHERE gc.dtfound>0'
    +' AND '+sCachePrefixForSql,1);
  CalcMain_SetVarFromSql('Calc_AgeYoungestID','SELECT max(dthidden) mx, id FROM geocache gc WHERE gc.dtfound>0'
    +' AND '+sCachePrefixForSql,1);
  CalcMain_SetVarFromSql('Calc_AgeArchivedCount','SELECT count(id) pocet FROM geocache gc WHERE gc.dtfound>0 and gc.cachestatus=2'
    +' AND '+sCachePrefixForSql,0);
  CalcMain_SetVarFromSql('Calc_AgeDisabledCount','SELECT count(id) pocet FROM geocache gc WHERE gc.dtfound>0 and gc.cachestatus=1'
    +' AND '+sCachePrefixForSql,0);

  //------ poloha kese
  //nejblizsi kes
  sSql:='SELECT min(0+st.Distance) dist, st.ID id FROM '+TEMP_TABLE+' st, geocache gc WHERE gc.id=st.id'
    +CONST_SQL_IGNORE_CACHETYPES;
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  CalcMain_SetVarFromSql('Calc_LocNearestID',sSql,1);
  //nejvzdalenejsi kes
  sSql:=ReplaceString(sSql,'SELECT min(0','SELECT max(0');
  CalcMain_SetVarFromSql('Calc_LocFurthestID',sSql,1);
  //nejsevernejsi kes
  sSql:='SELECT max(0+gc.x) mx, gc.id FROM geocache gc WHERE dtfound>0 AND '+sCachePrefixForSql;
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id not in ('+sIgnoreCaches+')';
  sSql:=sSql+CONST_SQL_IGNORE_CACHETYPES;
  CalcMain_SetVarFromSql('Calc_LocNortherlyID',sSql,1);
  //nejjiznejsi
  sSql:=ReplaceString(sSql,'SELECT max(0','SELECT min(0');
  CalcMain_SetVarFromSql('Calc_LocSoutherlyID',sSql,1);
  //nejvychodnejsi
  sSql:=ReplaceString(sSql,'SELECT min(0+gc.x)','SELECT max(0+gc.y)');
  CalcMain_SetVarFromSql('Calc_LocEasterlyID',sSql,1);
  //nejzapadnejsi
  sSql:=ReplaceString(sSql,'SELECT max(0','SELECT min(0');
  CalcMain_SetVarFromSql('Calc_LocWesterlyID',sSql,1);
  //nejvyssi/nejnizsi
  sSql:='SELECT max(0.+gtv.value) mx, gt.id'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql+CONST_SQL_IGNORE_CACHETYPES
    +'     AND gc.dtfound>0'
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''Elevation'' AND gtv.key=gt.ptrvalue';
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND gc.id NOT IN ('+sIgnoreCaches+')';
  CalcMain_SetVarFromSql_Int('Calc_LocHighestAlt',sSql,0);
  CalcMain_SetVarFromSql('Calc_LocHighestID',sSql,1);
  sSql:=ReplaceString(sSql,'T max(0.','T min(0.');
  //Log('SSSSSS '+sSql);
  CalcMain_SetVarFromSql_Int('Calc_LocLowestAlt',sSql,0);
  CalcMain_SetVarFromSql('Calc_LocLowestID',sSql,1);
  //nejvzdalenejsi FTF
  sSql:='SELECT max(0+st.Distance) dist, st.ID id FROM '+TEMP_TABLE+' st, ('
    +' SELECT gc.id, gc.cachetype'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql+CONST_SQL_IGNORE_CACHETYPES
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value="FTF"'
     +'    AND gtv.key=gt.ptrvalue and gtv.value like "%FTF%"'
    +') gcFTF'
    +' WHERE gcFTF.id=st.id'
    ;
  if(sIgnoreCaches<>'') then sSql:=sSql+' AND st.id not in ('+sIgnoreCaches+')';
  CalcMain_SetVarFromSql('Calc_LocFurthestFTFID',sSql,1);

  //------ pocty slov logu
  sSql:='SELECT sum(0.+gtv.value) n'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'
    +'     AND gc.CacheType<>''Lab Cache'''
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''FoundLogWordsCount'' AND gtv.key=gt.ptrvalue';
  CalcMain_SetVarFromSql_Int('Calc_LogsSum',sSql,0);
  sSql:=ReplaceString(sSql,'T sum(0.','T avg(0.');
  CalcMain_SetVarFromSql_Int('Calc_LogsAvg',sSql,0);
  sSql:=ReplaceString(sSql,'T avg(0.+gtv.value) n','T min(0.+gtv.value) n, gt.id');
  sSql:='SELECT min(0.+gtv.value) n, gt.id, gl.gs_logid'
    +'     FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
    +'       LEFT JOIN geolog gl ON (gc.id=gl.id and gl.finder='''+GEOGET_OWNER+''' COLLATE NOCASE'
    +'         AND (gl.type=''Found it'' OR gl.type=''Attended'' OR gl.type=''Webcam Photo Taken''))'
    +'     WHERE gt.id=gc.id AND '+sCachePrefixForSql
    +'     AND gc.dtfound>0'
    +'     AND gc.CacheType<>''Lab Cache'''
    +'     AND gtc.key=gt.ptrkat AND gtc.value=''FoundLogWordsCount'' AND gtv.key=gt.ptrvalue';
  CalcMain_SetVarFromSql_Int('Calc_LogsMinCount',sSql,0);
  CalcMain_SetVarFromSql('Calc_LogsMinID',sSql,1);
  CalcMain_SetVarFromSql('Calc_LogsMinLogID',sSql,2);
  sSql:=ReplaceString(sSql,'T min(0.','T max(0.');
  CalcMain_SetVarFromSql_Int('Calc_LogsMaxCount',sSql,0);
  CalcMain_SetVarFromSql('Calc_LogsMaxID',sSql,1);
  CalcMain_SetVarFromSql('Calc_LogsMaxLogID',sSql,2);

  /////////////// hotova 1. strana z https://docs.google.com/file/d/0B0GoaIrKr6t8LWxaVkJHRV9kUlk/edit
  /// bez posledniho radku a hodnot ziskavanych sekvencnim pruchodem

  // FTF
  sSql:='SELECT count(*) pocet'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value="FTF"'
     +'    AND gtv.key=gt.ptrvalue and gtv.value like "%FTF%"';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    nFTF:=StrToInt(tab.FieldByName['pocet']);
    GlobalVarSet('Calc_FTFCount',IntToStr(nFTF));
    // potan hodnoty: FTFIndex, FTFAvgInterval
    if(n<=0) then GlobalVarSet('Calc_FTFIndex','')
    else GlobalVarSet('Calc_FTFIndex',FormatFloatDot('0.00',(100.*nFTF)/n)+'&nbsp;%');
    if(nFTF<=0) then GlobalVarSet('Calc_FTFAvgInterval','')
    else GlobalVarSet('Calc_FTFAvgInterval',FormatFloatDot('0.00',nDnuCelkem/nFTF));
  finally
    tab.Free();
  end;

  // STF
  sSql:='SELECT count(*) pocet'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value=''FTF'''
     +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%STF%''';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_STFCount',tab.FieldByName['pocet']);
  finally
    tab.Free();
  end;

  // TTF
  sSql:='SELECT count(*) pocet'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value=''FTF'''
     +'    AND gtv.key=gt.ptrvalue and gtv.value like ''%TTF%''';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_TTFCount',tab.FieldByName['pocet']);
  finally
    tab.Free();
  end;

  // xTF celkem
  sSql:='SELECT count(*) pocet'
     +'  FROM geocache gc, geotag gt, geotagcategory gtc'
     +'  WHERE gt.id=gc.id and gc.dtfound>0 AND '+sCachePrefixForSql
     +'    AND gtc.key=gt.ptrkat'
     +'    AND gtc.value=''FTF''';
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    GlobalVarSet('Calc_xTFCount',tab.FieldByName['pocet']);
  finally
    tab.Free();
  end;
  //Nejspnj dny
    //----------------------------
	sSQL := 'SELECT dt.cnt, group_concat(dt.found,'', '')';
	sSql := sSql + ' FROM (';
	sSql := sSql + ' SELECT strftime(''%d/%m/%Y'', substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)) found, COUNT(gc.[dtfound]) cnt';
	sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY gc.[dtfound]) dt';
	sSql := sSql + ' GROUP BY dt.cnt';
	sSql := sSql + ' ORDER BY dt.cnt desc';
	sSql := sSql + ' LIMIT 3';
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		For i := 1 to 3 do begin
			s := Trim(IntToStr(i));
			if (not tab.eof) then begin
				GlobalVarSet('Calc_SumFindsMaxPerDayCount'+s,IntToStr(tab.FieldAsInteger(0)));
				GlobalVarSet('Calc_SumFindsMaxPerDay'+s,ReplaceString(tab.FieldAsString(1),'/','.'));
			end
			else begin
				GlobalVarSet('Calc_SumFindsMaxPerDayCount'+s,'-');
				GlobalVarSet('Calc_SumFindsMaxPerDay'+s,'');
			end;
			tab.Next;
		end;
	finally
		tab.Free();
	end;
  //Nejspnj weekend (sobota, nedle)
	sSQL := 'SELECT MAX(t.wcnt), t.[sobota], t.[nedele]';
	sSql := sSql + ' FROM (SELECT SUM(dt.cnt) wcnt, dt.sobota, dt.nedele';
	sSql := sSql + ' FROM (SELECT CASE WHEN (strftime("%w",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2))) IN ("0","6") THEN "1" ELSE "0" END tday,';       
    sSql := sSql + ' COUNT(gc.[dtfound]) cnt,';
    sSql := sSql + ' (strftime("%d.%m.%Y",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2),"-1 days","weekday 6")) sobota,';       
    sSql := sSql + ' (strftime("%d.%m.%Y",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2),"weekday 0")) nedele';                 
	sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND tday = "1" AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY gc.[dtfound]';
	sSql := sSql + ' ORDER BY gc.[dtfound]) dt';
	sSql := sSql + ' GROUP BY dt.sobota, dt.nedele) t'
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		GlobalVarSet('Calc_SumFindsMaxInWeekendCount',IntToStr(tab.FieldAsInteger(0)));
		GlobalVarSet('Calc_SumFindsMaxInWeekendFrom',tab.FieldAsString(1));
		GlobalVarSet('Calc_SumFindsMaxInWeekendTo',tab.FieldAsString(2));
	finally
		tab.Free();
	end;
  //Nejspnj tden (pondl a nedle)
    sSql := 'SELECT MAX(t.wcnt), t.[pondeli], t.[nedele]';
	sSql := sSql + ' FROM (SELECT strftime("%Y.%W",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)) tweek,'
	sSql := sSql + ' count(gc.[dtfound]) wcnt,';
    sSql := sSql + ' (strftime("%d.%m.%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"-6 days","weekday 1")) pondeli,';
    sSql := sSql + ' (strftime("%d.%m.%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"weekday 0")) nedele';
	sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY (strftime("%Y.%W",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)))';
	sSql := sSql + ' ORDER BY gc.[dtfound]) t';
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		GlobalVarSet('Calc_SumFindsMaxInWeekCount',IntToStr(tab.FieldAsInteger(0)));
		GlobalVarSet('Calc_SumFindsMaxInWeekFrom',tab.FieldAsString(1));
		GlobalVarSet('Calc_SumFindsMaxInWeekTo',tab.FieldAsString(2));
	finally
		tab.Free();
	end;
  //Nejspnj msc
	sSql := 'SELECT MAX(t.mcnt) cnt, t.[mmonth], t.[myear]';
	sSql := sSql + ' FROM (SELECT strftime("%Y.%m",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)) tweek,';
	sSql := sSql + ' count(gc.[dtfound]) mcnt,';
    sSql := sSql + ' (strftime("%m",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"-6 days","weekday 1")) mmonth,';
    sSql := sSql + ' (strftime("%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"weekday 0")) myear';
	sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY (strftime("%Y.%m",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)))';
	sSql := sSql + ' ORDER BY gc.[dtfound]) t';
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		GlobalVarSet('Calc_SumFindsMaxInMonthCount',IntToStr(tab.FieldAsInteger(0)));
		GlobalVarSet('Calc_SumFindsMaxInMonth',GlobalVarReplace('%Month'+Trim(tab.FieldAsString(1))+'%'));
		GlobalVarSet('Calc_SumFindsMaxInMonthYear',tab.FieldAsString(2));
	finally
		tab.Free();
	end;
  //Nejspnj rok
	sSql := 'SELECT MAX(t.ycnt) cnt, t.[yyear]';
	sSql := sSql + ' FROM (SELECT strftime("%Y",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)) tweek,';
	sSql := sSql + ' count(gc.[dtfound]) ycnt,';
    sSql := sSql + ' (strftime("%Y",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2),"weekday 0")) yyear';
	sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY (strftime("%Y",substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)))';
	sSql := sSql + ' ORDER BY gc.[dtfound]) t';
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		GlobalVarSet('Calc_SumFindsMaxInYearCount',IntToStr(tab.FieldAsInteger(0)));
		GlobalVarSet('Calc_SumFindsMaxInYear',tab.FieldAsString(1));
	finally
		tab.Free();
	end;
  //Poslednch 365 dn
	sSql := 'SELECT SUM(t.ccnt) cachecount, COUNT(t.ccnt) daycount';
	sSql := sSql + ' FROM (SELECT COUNT(gc.[dtfound]) ccnt';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.[dtfound]>0 AND '+sCachePrefixForSql+' and gc.[dtfound] BETWEEN strftime("%Y%m%d","now","-365 days") AND strftime("%Y%m%d","now")';
	sSql := sSql + ' GROUP BY gc.[dtfound]) t';
	//
	tab:=Geoget_DB.GetTable(sSql, false);
	//
	try
		GlobalVarSet('Calc_OtherLast365DaysCount',IntToStr(tab.FieldAsInteger(0)));
		GlobalVarSet('Calc_OtherLast365DaysCaching',IntToStr(tab.FieldAsInteger(1)));
	finally
		tab.Free();
	end;
  //mdCachingPoints (viz www.macdefender.org)
	//mdCachingPoints-------------
	sSql := 'SELECT count(*) rows, mdkey FROM (SELECT key as mdkey FROM geotagcategory WHERE value = "mdCachingPoints")';
	tab:=Geoget_DB.GetTable(sSql, false);
	try
		if tab.FieldAsInteger(0) = 0 then sc := ''
		else sc := IntToStr(tab.FieldAsInteger(1));
	finally
		tab.Free();
	end;
	//
	if sc <> '' then begin
		sSql := 'SELECT CAST(ROUND(SUM(CAST(gtv.[value] AS MONEY)),2) AS NVARCHAR) mdsum';
		sSql := sSql + ' FROM geocache gc';
		sSql := sSql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat = '+sc+')';
		sSql := sSql + ' INNER JOIN geotagvalue gtv ON (gt.[ptrvalue] = gtv.[key])';
		sSql := sSql + ' WHERE gc.dtfound > 0 AND '+sCachePrefixForSql;
	end
	else begin
		sSql := 'SELECT CAST(ROUND(SUM(num.typekoef * num.difficulty * num.terrain * num.cnt),2) AS NVARCHAR) mdsum';
		sSql := sSql + ' FROM (SELECT gc.[cachetype],'; 
		sSql := sSql + ' CASE WHEN gc.[cachetype] IN (''Traditional Cache'',''Webcam Cache'')'; //1 
		sSql := sSql + ' THEN 1 ELSE (CASE WHEN gc.[cachetype] IN (''Letterbox Hybrid'',''Event Cache'',''Earthcache'',''Cache In Trash Out Event'')'; //1.5
		sSql := sSql + ' THEN 1.5 ELSE (CASE WHEN gc.[cachetype] IN (''Multi-cache'',''Unknown Cache'',''Wherigo Cache'',''GPS Adventures Exhibit'',''Giga-Event Cache'',''Lost and Found Event Cache'')';  //2
		sSql := sSql + ' THEN 2 ELSE (CASE WHEN gc.[cachetype] IN (''Virtual Cache'',''Locationless (Reverse) Cache'')'; //0.5
		sSql := sSql + ' THEN 0.5 ELSE (CASE WHEN gc.[cachetype] IN (''Mega-Event Cache'')'; //1.75
		sSql := sSql + ' THEN 1.75 ELSE (CASE WHEN gc.[cachetype] IN (''Project APE'')';  //4
		sSql := sSql + ' THEN 4 ELSE 0 END) END) END) END) END) END typekoef,';
		sSql := sSql + ' gc.[difficulty], gc.[terrain], count(gc.[cachetype]) cnt';
		sSql := sSql + ' FROM geocache gc WHERE gc.[dtfound] > 0 AND '+sCachePrefixForSql;
		sSql := sSql + ' GROUP BY gc.[cachetype], gc.[difficulty], gc.[terrain] ) num';
	end;
	//
	fl := StrToFl(Geoget_DB.GetTableString(sSql));  //SQL Result
	s := FormatFloatDot('0',fl);                    //mdCachingPoints
	GlobalVarSet('Calc_OtherMdCachingPoints',s);
	//
	s := FormatFloatDot('0.0',fl/(0.+StrToInt(GlobalVarGet('FoundCachesCount',false))));     //Average mdCachingPoints
	GlobalVarSet('Calc_OtherAverageMdCachingPoints',s);
	if sc <> '' then begin
		sSql := 'SELECT CAST(ROUND(maxsuma,2) AS NVARCHAR) suma, maxdate';
		sSql := sSql + ' FROM (SELECT SUM(CAST(gtv.[value] AS MONEY)) maxsuma,'; 
		sSql := sSql + ' strftime(''%d.%m.%Y'', substr(gc.[dtfound],1,4)||"-"||substr(gc.[dtfound],5,2)||"-"||substr(gc.[dtfound],7,2)) maxdate';
		sSql := sSql + ' FROM geocache gc';
		sSql := sSql + ' INNER JOIN geotag gt ON (gc.id = gt.id AND gt.ptrkat = '+sc+')';
		sSql := sSql + ' INNER JOIN geotagvalue gtv ON (gt.[ptrvalue] = gtv.[key])';
		sSql := sSql + ' WHERE gc.dtfound > 0 AND '+sCachePrefixForSql;
		sSql := sSql + ' GROUP BY gc.[dtfound]';
		sSql := sSql + ' ORDER BY maxsuma DESC';
		sSql := sSql + ' LIMIT 1)';
		//
		tab:=Geoget_DB.GetTable(sSql, false);
		try
			fl := StrToFl(tab.FieldAsString(0));
			s := FormatFloatDot('0',fl);
			GlobalVarSet('Calc_OtherDayMaxMdCachingPoints',s);       					//DAILY MAX mdCachingPoints
			GlobalVarSet('Calc_OtherDayMaxDateMdCachingPoints',tab.FieldAsString(1));	//DAILY MAX DATE mdCachingPoints
		finally
			tab.Free();
		end;	
	end
	else begin
		GlobalVarSet('Calc_OtherDayMaxMdCachingPoints','-1');		//nen
		GlobalVarSet('Calc_OtherDayMaxDateMdCachingPoints','');		//nen
	end;

  //Penos BG hodnot
  //Type------------------------
	sSql := 'SELECT group_concat(t.typ||'', ''||t.cnt,''|'')';
	sSql := sSql + ' FROM(';
	sSql := sSql + ' SELECT gc.[cachetype] typ, COUNT(gc.[cachetype]) cnt';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.[dtfound]>0 AND '+sCachePrefixForSql;
	sSql := sSql + ' group by gc.[cachetype]) t';
	//
	s := Geoget_DB.GetTableString(sSql);				//SQL Result
	//
	GlobalVarSet('Calc_CacheTraditionalCount',CalcMain_GetTableValue(s,'Traditional Cache'));
	GlobalVarSet('Calc_CacheMultiCount',CalcMain_GetTableValue(s,'Multi-cache'));
	GlobalVarSet('Calc_CacheMysteryCount',CalcMain_GetTableValue(s,'Unknown Cache'));
	GlobalVarSet('Calc_CacheVirtualCount',CalcMain_GetTableValue(s,'Virtual Cache'));
	GlobalVarSet('Calc_CacheEarthCount',CalcMain_GetTableValue(s,'Earthcache'));
	GlobalVarSet('Calc_CacheLetterboxCount',CalcMain_GetTableValue(s,'Letterbox Hybrid'));
	GlobalVarSet('Calc_CacheWherigoCount',CalcMain_GetTableValue(s,'Wherigo Cache'));
	GlobalVarSet('Calc_CacheMegaEventCount',CalcMain_GetTableValue(s,'Mega-Event Cache'));
	GlobalVarSet('Calc_CacheGigaEventCount',CalcMain_GetTableValue(s,'Giga-Event Cache'));
	GlobalVarSet('Calc_CacheGPSAdventuresExhibitCount',CalcMain_GetTableValue(s,'GPS Adventures Exhibit'));
	GlobalVarSet('Calc_CacheEventCount',CalcMain_GetTableValue(s,'Event Cache'));
	GlobalVarSet('Calc_CacheCITOCount',CalcMain_GetTableValue(s,'Cache In Trash Out Event'));
	GlobalVarSet('Calc_CacheLostAndFoundCount',CalcMain_GetTableValue(s,'Lost and Found Event Cache'));
	GlobalVarSet('Calc_CacheWebcamCount',CalcMain_GetTableValue(s,'Webcam Cache'));
	GlobalVarSet('Calc_CacheAPECount',CalcMain_GetTableValue(s,'Project APE Cache'));
	GlobalVarSet('Calc_CacheLabCount',CalcMain_GetTableValue(s,'Lab Cache'));
	GlobalVarSet('Calc_CacheLocationlessCount',CalcMain_GetTableValue(s,'Locationless (Reverse) Cache'));
	GlobalVarSet('Calc_CacheGroundspeakHQCount',CalcMain_GetTableValue(s,'Groundspeak HQ'));
	//daj se dopsat dal skript vyjede vechny typy...
  //Size-------------------------
	sSql := 'SELECT group_concat(t.typ||'', ''||t.cnt,''|'')';
	sSql := sSql + ' FROM(';
	sSql := sSql + ' SELECT gc.[cachesize] typ, COUNT(gc.[cachesize]) cnt';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.[dtfound]>0 AND '+sCachePrefixForSql;
	sSql := sSql + ' group by gc.[cachesize]) t';
	//
	s := Geoget_DB.GetTableString(sSql);				//SQL Result
	//
	GlobalVarSet('Calc_CacheMicroCount',CalcMain_GetTableValue(s,'Micro'));
	GlobalVarSet('Calc_CacheSmallCount',CalcMain_GetTableValue(s,'Small'));
	GlobalVarSet('Calc_CacheRegularCount',CalcMain_GetTableValue(s,'Regular'));
	GlobalVarSet('Calc_CacheLargeCount',CalcMain_GetTableValue(s,'Large'));
	//daj se dopsat dal skript vyjede vechny velikosti...
  //Unique
	sSql := 'SELECT max(cntx)';
	sSql := sSql + ' FROM (SELECT count(gg.dtf) cntx';
	sSql := sSql + ' FROM (SELECT gc.[dtfound] dtf, count(gc.cachetype) max';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.dtfound > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' GROUP BY gc.dtfound, gc.[cachetype]) gg';
	sSql := sSql + ' GROUP BY gg.dtf)';
	GlobalVarSet('Calc_CacheMaxUniqueDailyType',IntToStr(Geoget_DB.GetTableValue(sSql)));	
  //D/T	
  //D5/T5
	sSql := 'select count(gc.id)';
	sSql := sSql + ' from geocache gc';
	sSql := sSql + ' where gc.dtfound>0 and gc.difficulty = 5 and gc.terrain = 5 AND '+sCachePrefixForSql;
	GlobalVarSet('Calc_CacheD5T5Count',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //D1/T1
	sSql := 'select count(gc.id)';
	sSql := sSql + ' from geocache gc';
	sSql := sSql + ' where gc.dtfound>0 and gc.difficulty = 1 and gc.terrain = 1 AND '+sCachePrefixForSql;
	GlobalVarSet('Calc_CacheD1T1Count',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //D5
	sSql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.difficulty = 5 AND '+sCachePrefixForSql;
	GlobalVarSet('Calc_CacheD5Count',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //T5
	sSql := 'select count(gc.id) from geocache gc where gc.dtfound>0 and gc.terrain = 5 AND '+sCachePrefixForSql;
	GlobalVarSet('Calc_CacheT5Count',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //Matrix
    sSql := 'select count(distinct trim(CAST(CAST(gc.terrain as money) as text))||''-''||trim(CAST(CAST(gc.difficulty as money) as text))) cnt';
	sSql := sSql + ' from geocache gc';
	sSql := sSql + ' where gc.dtfound > 0 AND '+sCachePrefixForSql;
	sSql := sSql + ' and (CAST(gc.terrain as money) > 0 and CAST(gc.terrain as money) < 5.1)';
	sSql := sSql + ' and (CAST(gc.difficulty as money) > 0 and CAST(gc.difficulty as money) < 5.1);';
	GlobalVarSet('Calc_MatrixDifficultyTerrain',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //Strike Found------------------------
    //--------------------------------------------------------------------------------
	//Mus se to rozsekat jednm povelem to prost nejde -----------------------------
	//--------------------------------------------------------------------------------
	//nati uniktn data nlez
	sSql := 'drop table if exists StatorStreakInputDates;';
	Geoget_DB.ExecSQL(sSql);								//SQL 1
	sSql := 'create temp table StatorStreakInputDates (rn integer primary key, dt date);';
	Geoget_DB.ExecSQL(sSql);								//SQL 2
	sSql := 'insert into StatorStreakInputDates (dt) values (''1900-01-01'');';
	Geoget_DB.ExecSQL(sSql);								//SQL 3
	sSql := 'insert into StatorStreakInputDates (dt)';
	sSql := sSql + ' select distinct';
    sSql := sSql + ' SubStr(Cast(dtfound as varchar), 1, 4)';
	sSql := sSql + ' || ''-'' || SubStr(Cast(dtfound as varchar), 5, 2)';
	sSql := sSql + ' || ''-'' || SubStr(Cast(dtfound as varchar), 7, 2)';
    sSql := sSql + ' from geocache';
	sSql := sSql + ' where dtfound > 0';
	sSql := sSql + ' order by dtfound asc;';
	Geoget_DB.ExecSQL(sSql);								//SQL 4
	sSql := 'insert into StatorStreakInputDates (dt) values';
	sSql := sSql + ' ((select Date(Max(dt), ''+2 days'') from StatorStreakInputDates));';
	Geoget_DB.ExecSQL(sSql);								//SQL 5
	//zjisti mezery, tj. kad dva po sob jdouc nlezy, kde ale data nlez nejsou po sob jdouc
	sSql := 'drop table if exists StatorStreakGaps;';
	Geoget_DB.ExecSQL(sSql);								//SQL 6
	sSql := 'create temp table StatorStreakGaps (rn integer primary key, GapStart date, GapEnd date);';
	Geoget_DB.ExecSQL(sSql);								//SQL 7
	sSql := 'insert into StatorStreakGaps (GapStart, GapEnd)';
	sSql := sSql + ' select TStart.DT GapStart, TEnd.DT GapEnd';
	sSql := sSql + ' from StatorStreakInputDates TStart';
    sSql := sSql + ' inner join StatorStreakInputDates TEnd on TStart.RN = TEnd.RN - 1';
	sSql := sSql + ' where JulianDay(TEnd.DT) - JulianDay(TStart.DT) > 1;';
	Geoget_DB.ExecSQL(sSql);								//SQL 8
	//z kad "mezery" vem konec a z t nsledujc mezery vem zatek
	sSql := 'select';
	sSql := sSql + ' Cast(Cast(JulianDay(TEnd.GapStart) - JulianDay(TStart.GapEnd) + 1 as integer) as nvarchar)';
	sSql := sSql + ' || '', '' || Strftime(''%d/%m/%Y'', TStart.GapEnd)';
	sSql := sSql + ' || '', '' || Strftime(''%d/%m/%Y'', TEnd.GapStart) as Result';
	sSql := sSql + ' from StatorStreakGaps TStart';
    sSql := sSql + ' inner join';
	sSql := sSql + ' StatorStreakGaps TEnd on TStart.RN = TEnd.RN -1';
	sSql := sSql + ' order by JulianDay(TEnd.GapStart) - JulianDay(TStart.GapEnd) desc';
	sSql := sSql + ' limit 1;';
	//----------------------------------------------------------------------------
	//konec obludria :)
	//----------------------------------------------------------------------------
	s := Geoget_DB.GetTableString(sSql);				//SQL Result
	//Vye ppadn NULL-------------
	sa := Fetch(s,',');
	if sa = '' then sa := '0';
	//---------------------------------
	GlobalVarSet('Calc_FoundStreakDaily',sa);
	GlobalVarSet('Calc_FoundStreakDailyFrom',ReplaceString(Fetch(s,','), '/', '.'));
	GlobalVarSet('Calc_FoundStreakDailyTo',ReplaceString(Fetch(s,','), '/', '.'));
  //Strike not Found------------------
    sSql := 'DROP TABLE IF EXISTS StatorStreak;';
	Geoget_DB.ExecSQL(sSql);							//SQL 1
	sSql := 'CREATE TEMP TABLE StatorStreak';
	sSql := sSql + ' (KEYX INTEGER PRIMARY KEY,';
	sSql := sSql + '  KEYP INTEGER,';
	sSql := sSql + '  DTREAL DATE,';
	sSql := sSql + '  DT REAL,';
	sSql := sSql + '  DTP REAL,';
	sSql := sSql + '  DIFF INTEGER);';
	Geoget_DB.ExecSQL(sSql);							//SQL 2
	sSql := 'INSERT INTO StatorStreak (DTREAL)';
	sSql := sSql + ' SELECT substr(CAST(gc.[dtfound] AS VARCHAR),1,4)||''-''||substr(CAST(gc.[dtfound] AS VARCHAR),5,2)||''-''||substr(CAST(gc.[dtfound] AS VARCHAR),7,2)';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.[dtfound] > 0';
	sSql := sSql + ' ORDER BY gc.[dtfound] ASC;';
	Geoget_DB.ExecSQL(sSql);							//SQL 3
	sSql := 'UPDATE StatorStreak SET';
	sSql := sSql + '  DT = julianday(DTREAL),'; 
	sSql := sSql + '  KEYP = KEYX+1;';
	Geoget_DB.ExecSQL(sSql);							//SQL 4
	sSql := 'UPDATE StatorStreak SET';
	sSql := sSql + '  DTP = (SELECT sx.[DT] FROM StatorStreak sx WHERE sx.[KEYX] = StatorStreak.[KEYP])'; 
	sSql := sSql + ' WHERE StatorStreak.[KEYP] > 0;';
	Geoget_DB.ExecSQL(sSql);							//SQL 5
	sSql := 'UPDATE StatorStreak SET';
	sSql := sSql + '  DTP = julianday(date(''now''))'; 
	sSql := sSql + ' WHERE KEYX = (SELECT Max(KEYX) FROM StatorStreak);';
	Geoget_DB.ExecSQL(sSql);							//SQL 6
	sSql := 'UPDATE StatorStreak SET';
	sSql := sSql + '  DIFF = DTP-DT;'; 
	Geoget_DB.ExecSQL(sSql);							//SQL 7
	sSql := 'SELECT (DIFF-2)||'', ''||strftime(''%d/%m/%Y'',Date(ss.[DT]+1))||'', ''||strftime(''%d/%m/%Y'',Date(ss.[DTP]-1)) Result';
	sSql := sSql + ' FROM StatorStreak ss';
	sSql := sSql + ' Order BY DIFF desc';
	sSql := sSql + ' LIMIT 1;';
	//----------------------------------------------------------------------------
	//konec obludria 2 :)
	//----------------------------------------------------------------------------
	s := Geoget_DB.GetTableString(sSql);				//SQL Result
	GlobalVarSet('Calc_EmptyStreakDaily',Fetch(s,','));
	GlobalVarSet('Calc_EmptyStreakDailyFrom',ReplaceString(Fetch(s,','), '/', '.'));
	GlobalVarSet('Calc_EmptyStreakDailyTo',ReplaceString(Fetch(s,','), '/', '.'));
  //Owned-----------------------------
	sEvent := '(''Giga-Event Cache'',''Mega-Event Cache'',''Event Cache'',''Cache In Trash Out Event'',''Lost and Found Event Cache'')';
	//Caches owned
	sSql := 'SELECT COUNT(*) FROM (SELECT *';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' WHERE gc.id IN (' + GlobalVarGet('OwnedIDsForInPhrase',false) + ')';
	sSql := sSql + ' AND gc.[cachetype] not in ' + sEvent + ')';
	//
	ico := Geoget_DB.GetTableValue(sSql);
	GlobalVarSet('Calc_OwnedCount',IntToStr(ico));
	//Event owned
	sSql := ReplaceString(sSql,'not in','in');
	//
	ieo := Geoget_DB.GetTableValue(sSql);
	GlobalVarSet('Calc_EventHostCount',IntToStr(ieo));
	//All owned
	GlobalVarSet('Calc_AllOwnCount',IntToStr(ico+ieo));
	//Owned FP
	sSql := 'SELECT SUM(CAST((SELECT value FROM geotagvalue WHERE key = gt.ptrvalue) AS int))';
	sSql := sSql + ' FROM geocache gc';
	sSql := sSql + ' INNER JOIN geotag gt on (gc.id = gt.id and gt.ptrkat IN (select key from geotagcategory where value = ''favorites'' COLLATE NOCASE))';
	sSql := sSql + ' WHERE gc.id in ('+GlobalVarGet('OwnedIDsForInPhrase',false)+') AND';
	sSql := sSql + ' gc.[cachetype] not in ' + sEvent;
	//
	GlobalVarSet('Calc_OwnedFavoritePoints',IntToStr(Geoget_DB.GetTableValue(sSql)));
  //----------------------------------
  //Calc_YearsTotal (year with at least one cache)
	sSql := 'SELECT COUNT(*) cnt FROM (SELECT distinct substr(CAST(dtfound as text),1,4) FROM geocache gc WHERE gc.dtfound > 0 AND '+sCachePrefixForSql+')';
	GlobalVarSet('Calc_RealYearsTotal',IntToStr(Geoget_DB.GetTableValue(sSql)));

  //----------------------------------
  // Ranking podle CacherStats
	if sGuidCom <> '' then begin
		if not (DirectoryExists(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp)) then begin
			if not (ForceDirectories(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp)) then begin
				msg :='ERR: '+ _('Could not create directory: ') + GEOGET_SCRIPTDIR + CalcMain_sModuleTmp;
				AddError(msg);
				exit;
			end;
		end;

		f := 'CacherStats'+GlobalVarGet('Profile',false)+'.txt';
		m := 0; //zapsat do TMP
		if FileExists(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f) then begin
			dt := GetFileTime(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f);
			s := FileToString(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f);
			//
			Log('Delay: '+IntToStr(24-round(double(Now - dt) * 24))+' hour');
			if round(double(Now - dt) * 24) < 24 then begin   //24 hodiny delay ne se natou nov data z CacherStats
				b := True;    //zpracovat
				m := 1;       //zruit zpis do TMP
				stmp := s;    //pouiju data ze zlohy (TEMP)
				Log('Data from temp file: '+ GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f);
			end
			else begin
				//Log('CacherStats: '+CalcMain_CachersStatGUID+sGuidCom);
				b := HttpAsk('GET',CalcMain_CachersStatGUID+sGuidCom,'','',stmp);  //Z CacherStats
			end;
		end
		else begin
			//Log('CacherStats: '+CalcMain_CachersStatGUID+sGuidCom);
			b := HttpAsk('GET',CalcMain_CachersStatGUID+sGuidCom,'','',stmp);    //Z CacherStats
		end;
		//  
		//Log('CacherStats: <<'+stmp+'>>');
		//
		if b and (stmp <> '') then begin
			//
			sc := 'Europe='+_('Europe')+',America='+_('America')+',Africa=='+_('Africa')+',Asia='+_('Asia')+',Australia='+_('Australia')+',Antarctica='+_('Antarctica');
			lc := TstringList.Create();
			try
				lc.CommaText := sc;
				//
				if Pos('not have 200 finds',stmp) > 0 then begin
					Result := '';
					msg := _('ERR: The geocacher cannot be located. Perhaps the geocacher does not have 200 finds or Stator has not set user GUID!');
					Log(msg);
					//Reset
					//Country
						GlobalVarSet('Calc_CacherStatCountry','');
						GlobalVarSet('Calc_CacherStatCountryRanking','ERR');
					//Continent
						GlobalVarSet('Calc_CacherStatContinent','');
						GlobalVarSet('Calc_CacherStatContinentRanking','ERR');
					//World
						GlobalVarSet('Calc_CacherStatWorldRanking','ERR');
					//
				end
				else begin
					if m = 0 then begin
						//itn HTML kdu
						sb := Fetch(stmp,'<table align=center cellspacing=0 cellpadding=2 border=1>');
						sb := Fetch(stmp,'</table>');
						stmp := sb;
						//
						stmp := Html2Text(stmp);
						sb := Fetch(stmp,'Rank');
						stmp := Trim(stmp);
						//Uloit
						if FileExists(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f) then begin
						if DeleteFile(GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f) then
							StringToFile(stmp,GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f);
						end
						else
						StringToFile(stmp,GEOGET_SCRIPTDIR + CalcMain_sModuleTmp + f);
					end;
					//
					Log('CacherStats: <<'+stmp+'>>');
					//Zpracovani
					s := stmp;
					//Log('XXXXX CacherStats: '+s);
					ls := TStringList.Create();
					try
						try
							 while s <> '' do begin
									sb := Trim(Fetch(s,chr(10)));
									//Log(sb);
									if sb <> '' then begin							  	
										//Log('--> '+sb);
										ls.Add(sb);
									end;
							 end;
							 //Country
							 GlobalVarSet('Calc_CacherStatCountry',ls[0]);
							 GlobalVarSet('Calc_CacherStatCountryRanking',ls[1]);
							 //Continent
							 GlobalVarSet('Calc_CacherStatContinent',lc.Values[Trim(ls[2])]);
							 GlobalVarSet('Calc_CacherStatContinentRanking',ls[3]);
							 //World
							 GlobalVarSet('Calc_CacherStatWorldRanking',ls[5]);
						 except
							 GlobalVarSet('Calc_CacherStatCountry','');
							 GlobalVarSet('Calc_CacherStatCountryRanking','ERR');
							 //Continent
							 GlobalVarSet('Calc_CacherStatContinent','');
							 GlobalVarSet('Calc_CacherStatContinentRanking','ERR');
							 //World
							 GlobalVarSet('Calc_CacherStatWorldRanking','ERR'); 
						 end;
					finally
						ls.Free();
					end;
				end;
				//
			finally
				lc.Free();
			end;
		end
		else begin
		Log('ERR: No data from: http://www.cacherstats.com/');
			//Reset
			//Country
			GlobalVarSet('Calc_CacherStatCountry','');
			GlobalVarSet('Calc_CacherStatCountryRanking','ERR');
			//Continent
			GlobalVarSet('Calc_CacherStatContinent','');
			GlobalVarSet('Calc_CacherStatContinentRanking','ERR');
			//World
			GlobalVarSet('Calc_CacherStatWorldRanking','ERR');
		end;
	end
	else begin
		//Reset
		//Country
		GlobalVarSet('Calc_CacherStatCountry','');
		GlobalVarSet('Calc_CacherStatCountryRanking','ERR');
		//Continent
		GlobalVarSet('Calc_CacherStatContinent','');
		GlobalVarSet('Calc_CacherStatContinentRanking','ERR');
		//World
		GlobalVarSet('Calc_CacherStatWorldRanking','ERR');
	end;

  // Jaro, leto, podzim, zima (ovsem bereme to vzhledem k nasim souradnicim!)
  // Jaro  
  sSql:='SELECT count(x.id) pocet FROM'
    +'     (SELECT id,substr(dtfound,1,4)||substr(dtfound,5,2)||substr(dtfound,7,2)'
    +'      ||substr("000"||dtfoundtime,-4,2)||substr("000"||dtfoundtime,-2,2) datum_cas'
    +'      FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +'  WHERE (datum_cas>="200203202016" AND datum_cas<"200206211524")'
    +'     OR (datum_cas>="200303210200" AND datum_cas<"200306212110")'
    +'     OR (datum_cas>="200403200749" and datum_cas<"200406210257")'
    +'     OR (datum_cas>="200503201333" and datum_cas<"200506210846")'
    +'     OR (datum_cas>="200603201925" and datum_cas<"200606211425")'
    +'     OR (datum_cas>="200703210107" and datum_cas<"200706212006")'
    +'     OR (datum_cas>="200803200648" and datum_cas<"200806210159")'
    +'     OR (datum_cas>="200903201243" and datum_cas<"200906210745")'
    +'     OR (datum_cas>="201003201832" and datum_cas<"201006211328")'
    +'     OR (datum_cas>="201103210021" and datum_cas<"201106211916")'
    +'     OR (datum_cas>="201203200614" and datum_cas<"201206210109")'
    +'     OR (datum_cas>="201303201202" and datum_cas<"201306210704")'
    +'     OR (datum_cas>="201403201757" and datum_cas<"201406211251")'
    +'     OR (datum_cas>="201503202345" and datum_cas<"201506211838")'
    +'     OR (datum_cas>="201603200530" and datum_cas<"201606210034")'
    +'     OR (datum_cas>="201703201128" and datum_cas<"201706210624")'
    +'     OR (datum_cas>="201803201715" and datum_cas<"201806211207")'
    +'     OR (datum_cas>="201903202258" and datum_cas<"201906211754")'
    +'     OR (datum_cas>="202003200449" and datum_cas<"202006202343")';
  CalcMain_SetVarFromSql_Int('Calc_FindsInSpring',sSql,0);
  // Leto
  sSql:='SELECT count(x.id) pocet FROM'
    +'     (SELECT id,substr(dtfound,1,4)||substr(dtfound,5,2)||substr(dtfound,7,2)'
    +'      ||substr("000"||dtfoundtime,-4,2)||substr("000"||dtfoundtime,-2,2) datum_cas'
    +'      FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +'  WHERE (datum_cas>="200206211524" AND datum_cas<"200209230655")'
    +'     OR (datum_cas>="200306212110" AND datum_cas<"200309231247")'
    +'     OR (datum_cas>="200406210257" AND datum_cas<"200409221830")'
    +'     OR (datum_cas>="200506210846" AND datum_cas<"200509230023")'
    +'     OR (datum_cas>="200606211425" AND datum_cas<"200609230603")'
    +'     OR (datum_cas>="200706212006" AND datum_cas<"200709231151")'
    +'     OR (datum_cas>="200806210159" AND datum_cas<"200809221744")'
    +'     OR (datum_cas>="200906210745" AND datum_cas<"200909222318")'
    +'     OR (datum_cas>="201006211328" AND datum_cas<"201009230508")'
    +'     OR (datum_cas>="201106211916" AND datum_cas<"201109231104")'
    +'     OR (datum_cas>="201206210109" AND datum_cas<"201209221649")'
    +'     OR (datum_cas>="201306210704" AND datum_cas<"201309222244")'
    +'     OR (datum_cas>="201406211251" AND datum_cas<"201409230429")'
    +'     OR (datum_cas>="201506211838" AND datum_cas<"201509231020")'
    +'     OR (datum_cas>="201606210034" AND datum_cas<"201609221621")'
    +'     OR (datum_cas>="201706210624" AND datum_cas<"201709222202")'
    +'     OR (datum_cas>="201806211207" AND datum_cas<"201809230354")'
    +'     OR (datum_cas>="201906211004" AND datum_cas<"201909230950")'
    +'     OR (datum_cas>="202006202343" AND datum_cas<"202009221530")';
  CalcMain_SetVarFromSql_Int('Calc_FindsInSummer',sSql,0);
  // Podzim
  sSql:='SELECT count(x.id) pocet FROM'
    +'     (SELECT id,substr(dtfound,1,4)||substr(dtfound,5,2)||substr(dtfound,7,2)'
    +'      ||substr("000"||dtfoundtime,-4,2)||substr("000"||dtfoundtime,-2,2) datum_cas'
    +'      FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +'  WHERE (datum_cas>="200209230655" AND datum_cas<"200212220214")'
    +'     OR (datum_cas>="200309231247" AND datum_cas<"200312220804")'
    +'     OR (datum_cas>="200409221830" AND datum_cas<"200412211342")'
    +'     OR (datum_cas>="200509230023" AND datum_cas<"200512211934")'
    +'     OR (datum_cas>="200609230603" AND datum_cas<"200612220122")'
    +'     OR (datum_cas>="200709231151" AND datum_cas<"200712220708")'
    +'     OR (datum_cas>="200809221744" AND datum_cas<"200812211304")'
    +'     OR (datum_cas>="200909222318" AND datum_cas<"200912211846")'
    +'     OR (datum_cas>="201009230508" AND datum_cas<"201012220038")'
    +'     OR (datum_cas>="201109231104" AND datum_cas<"201112220630")'
    +'     OR (datum_cas>="201209221649" AND datum_cas<"201212211211")'
    +'     OR (datum_cas>="201309222244" AND datum_cas<"201312211811")'
    +'     OR (datum_cas>="201409230429" AND datum_cas<"201412220003")'
    +'     OR (datum_cas>="201509231020" AND datum_cas<"201512220548")'
    +'     OR (datum_cas>="201609221621" AND datum_cas<"201612211144")'
    +'     OR (datum_cas>="201709222202" AND datum_cas<"201712211728")'
    +'     OR (datum_cas>="201809230354" AND datum_cas<"201812212322")'
    +'     OR (datum_cas>="201909230950" AND datum_cas<"201912220519")'
    +'     OR (datum_cas>="202009221530" AND datum_cas<"202012211102")';
  CalcMain_SetVarFromSql_Int('Calc_FindsInAutumn',sSql,0);
  // Zima
  sSql:='SELECT count(x.id) pocet FROM'
    +'     (SELECT id,substr(dtfound,1,4)||substr(dtfound,5,2)||substr(dtfound,7,2)'
    +'      ||substr("000"||dtfoundtime,-4,2)||substr("000"||dtfoundtime,-2,2) datum_cas'
    +'      FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+') x'
    +'  WHERE (datum_cas>="200212220214" AND datum_cas<"200303210200")'
    +'     OR (datum_cas>="200312220804" AND datum_cas<"200403200749")'
    +'     OR (datum_cas>="200412211342" AND datum_cas<"200503201333")'
    +'     OR (datum_cas>="200512211934" AND datum_cas<"200603201925")'
    +'     OR (datum_cas>="200612220122" AND datum_cas<"200703210107")'
    +'     OR (datum_cas>="200712220708" AND datum_cas<"200803200648")'
    +'     OR (datum_cas>="200812211304" AND datum_cas<"200903201243")'
    +'     OR (datum_cas>="200912211846" AND datum_cas<"201003201832")'
    +'     OR (datum_cas>="201012220038" AND datum_cas<"201103210021")'
    +'     OR (datum_cas>="201112220630" AND datum_cas<"201203200614")'
    +'     OR (datum_cas>="201212211211" AND datum_cas<"201303201202")'
    +'     OR (datum_cas>="201312211811" AND datum_cas<"201403201757")'
    +'     OR (datum_cas>="201412220003" AND datum_cas<"201503202345")'
    +'     OR (datum_cas>="201512220548" AND datum_cas<"201603200530")'
    +'     OR (datum_cas>="201612211144" AND datum_cas<"201703201128")'
    +'     OR (datum_cas>="201712211728" AND datum_cas<"201803201715")'
    +'     OR (datum_cas>="201812212322" AND datum_cas<"201903202258")'
    +'     OR (datum_cas>="201912220519" AND datum_cas<"202003200449")'
    +'     OR (datum_cas>="202012211102" AND datum_cas<"202103212222")';
  CalcMain_SetVarFromSql_Int('Calc_FindsInWinter',sSql,0);

  Log('End of CalcMain_Run()');
end;