//modul poskytuje vypocetni funkce, sam o sobe nic nevytvari

function CalcRegionTagSupport_TagFromMap(sMap:string; bShowError:boolean; var sCategory,sValue,sCategoryNad,sValueNad:string):boolean;
//vraci priznak nalezeni
begin
  Result:=true;
  sCategory:='';
  sValue:='';
  sCategoryNad:='';
  sValueNad:='';
  case sMap of
  'ATkraj': begin sCategory:='AT Land';  end;
  'CZkraj': begin sCategory:='CZ kraj';  end;
  //'DEkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'FRkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  'HUkraj': begin sCategory:='HU megye';  end;
  'CHkraj': begin sCategory:='CH Kanton';  end;
  //'ISkraj': begin sCategory:='IS hluti';  end;
  //'NOkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'NLkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'PLkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'SEkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  'SKkraj': begin sCategory:='SK kraj';  end;
  //---------------
  'ATokres': begin sCategory:='AT Bezirk'; end;
  'CZokres': begin sCategory:='CZ okres'; end;
  //'IEokres': begin sCategory:='IE okres';  end;
  'SKokres': begin sCategory:='SK okres';  end;
  //---------------
  'BRmesto': begin sCategory:='CZ Mestska cast'; sValue:='Brno%'; end;
  //'HAmesto': begin sCategory:='CZ Mestska cast'; sTagVal:='Havov%';  end;
  'PAmesto': begin sCategory:='CZ Mestska cast'; sValue:='Praha%';  end;
  //parametry s nadrazenym uzemnim celkem (pomalejsi, u Prahy zbytecne)
  //v tagu je cestina, proto bez 'n s hackem', Plzen zatim nema mapu
  //'PLmesto': begin sCategory:='CZ Mestsky obvod'; sValue:='Plze%';  end;
  //Pardubice zatim nemaji mapu
  //'PUmesto': begin sCategory:='CZ Mestsky obvod'; sValue:='Pardubice%';  end;
  //'OSmesto': begin sCategory:='CZ Mestsky obvod'; sValue:='';
  //                 sCategoryNad:='CZ okres'; sValueNad:=AnsiToUtf('Ostrava-msto'); end;
  'OSmesto': begin sCategory:='CZ Mestska cast'; sValue:='';
                   sCategoryNad:='CZ okres'; sValueNad:=AnsiToUtf('Ostrava-msto'); end;
  else begin
         Result:=false;
         if(bShowError) then AddError(_('ERR: Couldn''t get TAG category for map:')+' '+sMap)
         else Log(_('ERR: Couldn''t get TAG category for map:')+' '+sMap);
       end;
  end;
  //Log('INFO: TagFromMap: sMap='+sMap+', sCategory='+sCategory+', sValue='+sValue+', sCategoryNa='+sCategoryNad+', sValueNad='+sValueNad);
end;

function CalcRegionTagSupport_TagFromCountry(sCountry:string; bShowError:boolean; var sCategory:string):boolean;
//vraci priznak nalezeni
begin
  Result:=true;
  sCategory:='';
  case sCountry of
  'Austria': begin sCategory:='AT Land';  end;
  'Czechia': begin sCategory:='CZ kraj';  end;
  //'DEkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'France': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  'Hungary': begin sCategory:='HU megye';  end;
  'Ireland': begin sCategory:='IS hluti';  end;
  //'NLkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'PLkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  //'SEkraj': begin sCategory:='';  end;            //nejsou polygony, je dostupne pres MapGenFromState
  'Slovakia': begin sCategory:='SK kraj';  end;
  else begin
         Result:=false;
         Log(_('WARN: Couldn''t get TAG category for country:')+' '+sCountry);
       end;
  end;
  //Log('INFO: TagFromCountry: sCountry='+sCountry+', sCategory='+sCategory);
end;

//hlavni funkce nedela nic
function CalcRegionTagSupport_Run(aPar:TStringList):string;
begin
  Result:='';
end;

procedure CalcRegionTagSupport_Free;
begin
end;