function CustomizedTable_Run(aPar:TStringList):string;
var s,s1,sSql:string;
    i,iFirst,idxCount:integer;
    n,nCols,nRows,nRest:integer;
    bIncludeIgnoring:boolean;
    tab: TSqliteTable;
    aData:TStringList;
begin
  Result:='';
  idxCount:=-1;
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  bIncludeIgnoring:=(UpperCase(aPar.Values['IncludeIgnoringCaches'])='YES');

  //najdeme sloupec s ciselnou hodnotou poctu pro vypocet procent a histogram
  s:=aPar.Values['Columns'];
  i:=0;
  while (s<>'') do begin
    s1:=Fetch(s,'|');
    if(Fetch(s1,'=')='Count') then idxCount:=i;
    Inc(i)
  end;
  n:=idxCount;
  sSql:=TableListMakeSqlFromParams(aPar,bIncludeIgnoring,aPar.Values['IgnoreCacheTypes'],n);
{$ifdef DEBUG_HELPER} LDH('LLLL SQL='+sSql); {$endif}
  if(sSql='') then begin
    //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
    //AddError(_('Bad request for making table - missing important data about columns (i. e. column for sorting caches is not chosen)'));
    Log(_('Bad request for making table - missing important data about columns (i. e. column for sorting caches is not chosen)'));
    exit;
  end;
  //exit;
  tab:=Geoget_DB.GetTable(sSql, false);
  Log('Stop SQL');
  aData:=TStringList.Create();
  //Log('Nacteni dat do pole');
  try
    nCols:=tab.ColCount;
    nRows:=0;
    while (not tab.Eof) do begin
      Inc(nRows);
      for i:=0 to nCols-1 do begin
        s1:='';
        {
        if(i=0) then begin //pokusne otestovani FTF a pripadne zvyrazneni radku
          s1:=tab.FieldAsString(i);
          if(Pos('FTF',s1)>0) then s1:=CONST_HIGHLIGHT
          else s1:='';
        end;
        }
        aData.Add(s1+tab.FieldAsString(i));
        //Log(IntToStr(i)+': '+tab.FieldAsString(i));
      end;
      tab.Next();
    end;
    if(nRows<=0) then begin
      //7.1.2019, aby nebylo preruseno zpracovani a chyby se vypsaly jen na konci
      //AddError(_('WARN: SQL does not return any valid data'));
      Log(_('WARN: SQL does not return any valid data'));
    end;
  finally
    if(tab<>nil) then tab.Free();
  end;
{$ifdef DEBUG_HELPER} LDH('LLLL nRows='+IntToStr(nRows)); {$endif}
  ////////////////////// vytvoreni vystupni tabulky //////////////////////////
  n:=-1;
  s:=aPar.Values['CountRow'];            //zjistime pocet radku do tabulky
  if(s<>'') then n:=StrToInt(s);
  iFirst:=0;
  s:=aPar.Values['FirstRow'];            //zjistime prvni radek tabulky
  if(s<>'') then iFirst:=StrToInt(s);
  //Log('SSSS iFirst='+IntToStr(iFirst)+', n='+IntToStr(n));
  if(aPar.Values['HaveHeader']='No') then aData.Insert(0,'!NoHeader!');
  Result:=Result+OutputTableList(aPar.Values['Columns'],aData,iFirst,n,idxCount,nRest)+CRLF;
  aData.Free();
  //pokud je treba zobrazit nejaky text pod tabulkou, zobrazime ho s nahrazenim
  //nekterych hodnot
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //nahradime specificke hodnoty
    s1:=IntToStr(nRows);
    s:=ReplaceString(s,'%RowCount%',s1);
    //nRest:=nRest-iFirst;
    s1:=IntToStr(nRest);
    s:=ReplaceString(s,'%RowRest%',s1);
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;