//hlavni funkce modulu
function DebugShowGlobalVars_Run(aPar:TStringList):string;
var i,nRest:integer;
    s,s1:string;
    aVar,aData:TStringList;
    ini:TMemIniFile;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  aVar:=TStringList.Create();
  try
    aData:=TStringList.Create();
    try
      //pokud je pozadovano razeni, nastavime priznak
      if(aPar.Values['Sort']='Yes') then aVar.Sorted:=true;
      s1:=aPar.Values['Variables'];
      s:=Fetch(s1,'-');
      Log('s='+s);
      case s of
      'Module': begin //zjistime seznam promennych, ktere generuje modul
                  s:=aPar.Values['ModuleName'];
                  if(s='') then AddError(_('ERR: Module name for generating variable list not set')) 
                  else begin
                    s:=GetModuleDirFromName(s)+s+'.ini';
                    Log('INI soubor: '+s);
                    ini:=TMemIniFile.Create(s);
                    try
                      ini.ReadSectionValues('Variables',aData);
                      for i:=0 to aData.Count-1 do begin
                        s:=aData[i];
                        aVar.Add(Fetch(s,'='));
                      end;
                    finally
                      ini.Free();
                    end;
                    aData.Text:='';
                  end;
                end;
      'VarNameStart': begin //jmeno promenne zacina zadanymi znaky
                  s:=aPar.Values['VarName'];
                  Log('ss='+s);
                  for i:=0 to nGlobalVar-1 do begin
                    if(Pos(s,aGlobVarName[i])>=1) then aVar.Add(aGlobVarName[i]);
                  end;
                end;
      'VarNameRegex': begin //podle regularniho vyrazu
                  s:=aPar.Values['VarName'];
                  Log('sss='+s);
                  for i:=0 to nGlobalVar-1 do begin
                    if(RegexFind('(?i)'+s,aGlobVarName[i])) then aVar.Add(aGlobVarName[i]);
                  end;
                end;
      else begin //bereme vsechny promenne
                  for i:=0 to nGlobalVar-1 do begin
                    aVar.Add(aGlobVarName[i]);
                  end;
           end;
      end;
      Log('AAAA');
      Log('count='+IntToStr(aVar.Count));
      for i:=0 to aVar.Count-1 do begin
        aData.Add(aVar[i]);
        //protoze funkce pro generovani tasbulky predpoklada, ze
        //data jsou z databaze (tedy v UTF), a tato data jsou
        //v ANSI, je treba je prevest
        aData.Add(AnsiToUtf(GlobalVarGet(aVar[i],false)));
      end;
      Log('QQQQ');
      //neni potreba nahrazovat dalsi promenne, rovnou vystup
      Output(Result+OutputTableList(_('Variable')+'=|'+_('Value')+'=',aData,0,aVar.Count,
        -1,nRest)+CRLF+'<p style="text-align:center;">'+_('Number of shown global values:')+' '+IntToStr(aVar.Count)+'</p>');
      Log('QQQQ');
    finally
     aData.Free();
    end;
  finally
    aVar.Free();
  end;
  Result:='';
end;