function FTFSummaryByTypeInCountry_Run(aPar:TStringList):string;
var aTmpPar,aTypes:TStringList;
    tab: TSqliteTable;
    sSort,sSql,sColumns,s:string;
    i:integer;
    nTypes:array[0..100] of integer;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  sSql:=aPar.Values['OrderBy'];
  sSort:=Fetch(sSql,'-');
  aTmpPar:=TStringList.Create();
  try
    aTypes:=TStringList.Create();
    try
      //zjistime seznam typu kesi v databazi, abychom mohli sestavit spravny SQL
      sSql:='SELECT cachetype FROM geocache WHERE dtfound>0 GROUP BY cachetype ORDER BY count(cachetype) desc';
      Geoget_DB.GetTableStrings(sSql,aTypes);
      //vytvorime SQL a zaroven seznam sloupcu tak, aby se jmena typu kesi nahradily ikonami
      sSql:='SELECT country';
      sColumns:='Country flag, text';
      for i:=0 to aTypes.Count-1 do begin
        sSql:=sSql+CRLF+'  ,sum(case when cachetype='''+aTypes[i]+''' then 1 else 0 end) as '''+aTypes[i]+'''';
        sColumns:=sColumns+'|<img src&eq;"%IconCacheTypeSmall'+aTypes[i]+'%" title&eq;"'+aTypes[i]+'" />=Center';
      end;
      sColumns:=sColumns+'|&sum;=Right';
      sSql:=sSql+CRLF+'  ,count(country)'+CRLF
        +'FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv'
        +'    WHERE gc.dtfound>0 AND '+sCachePrefixForSql
        +'    and gt.id=gc.id and gc.dtfound>0'
        +'    and gtc.key=gt.ptrkat'
        +'    and gtc.value="FTF"'
        +'    and gtv.key=gt.ptrvalue and gtv.value like "%FTF%"'
        +'    GROUP BY country ORDER BY ';
      if(sSort<>'Country') then sSql:=sSql+'count(country) desc, ';
      sSql:=sSql+'country';
      aTmpPar.Text:='';
      Log('SQL='+sSql);
      tab:=Geoget_DB.GetTable(sSql, false);
      try
{
        if(tab.eof) then begin
          Log(_('ERR: neni zadny FTF nalez, modul nema zadny vystup.'));
          exit;
        end;
}
        while not tab.eof do begin
          aTmpPar.Add(tab.FieldAsString(0)); //stat
          for i:=1 to aTypes.Count do begin
            s:=tab.FieldAsString(i); //pocty nalezu jednotlivych typu
            if(s='0') then 
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+' (gray)%" />')
            else begin
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+'%" title="'+s+' x" />');
              //pocitame celkove soucty za typ kese
              nTypes[i-1]:=nTypes[i-1]+StrToInt(s);
              nTypes[aTypes.Count]:=nTypes[aTypes.Count]+StrToInt(s);
            end;
          end;
          aTmpPar.Add('<b>'+tab.FieldAsString(i)+'</b>');  //soucet nalezu za stat
          tab.Next();
        end;
      finally
        tab.Free();
      end;
      //pridame celkove pocty typu kesi
      aTmpPar.Add(CONST_NOICON+'<b>&sum;</b>'); //stat
      for i:=0 to aTypes.Count do begin
        aTmpPar.Add('<b>'+IntToStr(nTypes[i])+'</b>');
      end;
      Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i);
    finally
      aTypes.Free();
    end;
  finally
    aTmpPar.Free();
  end;
end;
