//hlavni funkce modulu
function FindsByCreatedDay_Run(aPar:TStringList):string;
var
  sOld,s,sStyle:string;
  tab: TSqliteTable;
  a:array [0..12*31-1] of integer;
  aMonSuma:array[0..31] of integer;
  i,n,dd,mm,nMm,nMax,nMaxMes,nMaxDen:integer;
  bCond:boolean;
  aMonthName:array [0..11] of string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  // pepna zenho vpisu tabulky
  i:=Geoget_DB.GetTableValue('SELECT count(*) Num FROM geocache gc WHERE gc.dtfound>0 AND '+sCachePrefixForSql+SetSqlFilter(aPar));
  bCond:=((iWidth<700) or (i>2500));
  //inicializace poli
  for n:=0 to 12*31-1 do a[n]:=0;
  //nastavime neplatne dny
  a[2*31-2]:=-1; a[2*31-1]:=-1; //unor
  a[4*31-1]:=-1; //duben
  a[6*31-1]:=-1; //cerven
  a[9*31-1]:=-1; //zari
  a[11*31-1]:=-1; //listopad
  for n:=0 to 31 do aMonSuma[n]:=0;
  if bCond then begin
    aMonthName[0]:='Jan';   aMonthName[1]:='Feb';     aMonthName[2]:='Mar';
    aMonthName[3]:='Apr';   aMonthName[4]:='Ma';      aMonthName[5]:='Jun';
    aMonthName[6]:='Jul';   aMonthName[7]:='Aug';     aMonthName[8]:='Sep';
    aMonthName[9]:='Oct';   aMonthName[10]:='Nov';    aMonthName[11]:='Dec';
  end else begin
    aMonthName[0]:='January'; aMonthName[1]:='February';  aMonthName[2]:='March';
    aMonthName[3]:='April';   aMonthName[4]:='May';       aMonthName[5]:='June';
    aMonthName[6]:='July';    aMonthName[7]:='August';    aMonthName[8]:='September';
    aMonthName[9]:='October'; aMonthName[10]:='November'; aMonthName[11]:='December';
  end;
  tab:=Geoget_DB.GetTable(
    'SELECT count(mesic_den) pocet,mesic_den FROM'
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho den v tydnu a prevedeme tak, aby 0 bylo pondeli
    +'  (SELECT substr(dthidden,5,2)||"."||substr(dthidden,7,2) mesic_den'
    +'    FROM geocache gc WHERE dtfound>0'
    +SetSqlFilter(aPar)
    +' ) x'
    +' GROUP BY mesic_den'
    +' ORDER BY mesic_den', false);
  try
    while not tab.eof do
    begin
      n:=tab.FieldAsInteger(0);
      if(n>nMax) then nMax:=n;
      s:=tab.FieldAsString(1);
      mm:=StrToInt(Fetch(s,'.'))-1;
      dd:=StrToInt(s)-1;
      a[mm*31+dd]:=n;
      tab.Next();
    end;
  finally
    tab.free;
  end;
  //vytvorime vystupni tabulku
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  sOld:=GlobalVarGet('StyleTableMatrix',false);
  sOld:=ReplaceString(sOld,'%Width%',IntToStr(iWidth));
  //zmenime velikost fontu, pokud je to potreba
  s:=aPar.Values['FontSize'];
  if(s<>'') then begin
    sOld:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOld,'font-size:'+s+'px',false);
  end;
  Result:=Result+'<table style="'+sOld+'">'+CRLF;
  sOld:=GlobalVarget('MonthMonth',false);
  s:=sOld;
  //if(bCond) then begin //udelame svisly text
  //  s:='';
  //  for dd:=1 to Length(sOld) do begin
  //    s:=s+'&nbsp;'+sOld[dd]+'&nbsp;<br />';
  //  end;
  //end;
  Result:=Result
    +'  <tr style="%StyleTableMatrixTr%">'
    //+'<th style="%StyleTableMatrixTh1%">&nbsp;</th>'
    +'<th colspan=33 style="%StyleTableMatrixTh1%">%DayDay%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'+CRLF
    //zbytecny sloupecek nevypisujeme, zabira misto a je jasne, co je to za hodnoty
    //+'    <th rowspan=14 style="%StyleTableMatrixTh1Down%">'+s+'</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th><th style="%StyleTableMatrixTh2%">01</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">02</th><th style="%StyleTableMatrixTh2%">03</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">04</th><th style="%StyleTableMatrixTh2%">05</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">06</th><th style="%StyleTableMatrixTh2%">07</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">08</th><th style="%StyleTableMatrixTh2%">09</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">10</th><th style="%StyleTableMatrixTh2%">11</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">12</th><th style="%StyleTableMatrixTh2%">13</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">14</th><th style="%StyleTableMatrixTh2%">15</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">16</th><th style="%StyleTableMatrixTh2%">17</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">18</th><th style="%StyleTableMatrixTh2%">19</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">20</th><th style="%StyleTableMatrixTh2%">21</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">22</th><th style="%StyleTableMatrixTh2%">23</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">24</th><th style="%StyleTableMatrixTh2%">25</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">26</th><th style="%StyleTableMatrixTh2%">27</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">28</th><th style="%StyleTableMatrixTh2%">29</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">30</th><th style="%StyleTableMatrixTh2%">31</th>'+CRLF
    +'    <th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF
    +'  </tr>'+CRLF;
  nMaxMes:=0;
  nMaxDen:=0;
  for mm:=0 to 11 do begin
    nMm:=0;
    for dd:=0 to 30 do begin
      if(a[mm*31+dd]>-1) then begin
        nMm:=nMm+a[mm*31+dd];
        aMonSuma[dd]:=aMonSuma[dd]+a[mm*31+dd];
        if(nMaxDen<aMonSuma[dd]) then nMaxDen:=aMonSuma[dd];
      end;
    end;
    aMonSuma[31]:=aMonSuma[31]+nMm;
    if(nMaxMes<nMm) then nMaxMes:=nMm;
  end;
  //ShowMessage('nMaxDen='+IntToStr(nMaxDen)+', nMaxMes='+IntToStr(nMaxMes));
  for mm:=0 to 11 do begin
    nMm:=0;
    Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">%Month'+aMonthName[mm]+'%</th>'+CRLF;
    for dd:=0 to 30 do begin
      if(a[mm*31+dd]>-1) then begin
        nMm:=nMm+a[mm*31+dd];
      end;
      if(a[mm*31+dd]=0) then Result:=Result+'    <td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else if(a[mm*31+dd]=-1) then Result:=Result+'    <td style="%StyleTableMatrixTh2%">&nbsp;</td>'+CRLF
      else begin
        if(a[mm*31+dd]=nMax) and (GlobalVarGet('StyleTableMatrixTdMaxValueText',false)<>'StyleTableMatrixTdMaxValue') then begin
          Result:=Result+'    <td style="%StyleTableMatrixTdMaxValue% background:#'
            +ScaleColor(a[mm*31+dd],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[mm*31+dd])+'</td>'+CRLF;
        end
        else begin Result:=Result+'    <td style="%StyleTableMatrixTd% background:#'
          +ScaleColor(a[mm*31+dd],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
          +'">'+IntToStr(a[mm*31+dd])+'</td>'+CRLF;
        end;
      end;
    end;
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(nMm=nMaxMes) and (GlobalVarGet('ColorTableScaleMaxText',false)<>'ColorTableScaleMaxText') then begin
      sStyle:=ReplaceString(sStyle,'%ColorTableListHeaderText%',GlobalVarGet('ColorTableScaleMaxText',false));
    end;
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(nMm)+'</th>'+CRLF+'  </tr>'+CRLF;
  end;
  //doplnime soucty za jednotlive hodiny
  Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  for dd:=0 to 31 do begin
    //ve stylu nahradime barvu textu za barvu maximalniho textu
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(aMonSuma[dd]=nMaxDen) and (GlobalVarGet('ColorTableScaleMaxText',false)<>'ColorTableScaleMaxText') then begin
      sStyle:=ReplaceString(sStyle,'%ColorTableListHeaderText%',GlobalVarGet('ColorTableScaleMaxText',false));
    end;
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(aMonSuma[dd])+'</th>'+CRLF
  end;
  Result:=Result+'  </tr>'+CRLF;
  Result:=Result+'</table>'+CRLF;
  Output(Result);
  Result:='';
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //zjistime pocet kombinaci
    n:=0;
    for mm:=0 to 11 do begin
      for dd:=0 to 30 do begin
        if(a[mm*31+dd]>0) then Inc(n);
      end;
    end;
    s:=ReplaceString(s,'%FoundCount%',IntToStr(n));
    s:=ReplaceString(s,'%AllCount%',IntToStr(366));
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;