//hlavni funkce modulu
function FindsByHour_Run(aPar:TStringList):string;
var
  s,sOld,sStyle:string;
  tab: TSqliteTable;
  a:array [0..7*24-1] of integer;
  aDaySuma:array[0..24] of integer;
  n,den,hh,nDay,nMax,nMaxDen,nMaxHod:integer;
//  bCond:boolean;
  aDayName:array [0..6] of string;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);

  //inicializace poli
  for n:=0 to 7*24-1 do a[n]:=0;
  for n:=0 to 23 do aDaySuma[n]:=0;
  aDayName[0]:='Monday';     aDayName[1]:='Tuesday';     aDayName[2]:='Wednesday';
  aDayName[3]:='Thursday';   aDayName[4]:='Friday';      aDayName[5]:='Saturday';
  aDayName[6]:='Sunday';
  //z databaze nacteme data - pocty nalezu v kazdou hodinu tydne
  tab:=Geoget_DB.GetTable(
    'SELECT count(datum_hodina) pocet,datum_hodina FROM'
    //datum nalezu prevedeme na string YYYY-MM-DD, vypiseme jeho den v tydnu a prevedeme tak, aby 0 bylo pondeli
    +'  (select ((strftime("%w",substr(dtfound,1,4)||"-"||substr(dtfound,5,2)||"-"||substr(dtfound,7,2))+6)%7)'
    //  -- pridame k nemu hodinu nalezu
    +'    ||" "||substr("000"||dtfoundtime,-4,2)'
    +'    as datum_hodina'
    +'    from geocache gc WHERE gc.dtfound>0 and dtfoundtime>0 AND '+sCachePrefixForSql
    +SetSqlFilter(aPar)
    +') x'
    +' group by datum_hodina'
    +' order by datum_hodina', false);
  try
    while not tab.eof do
    begin
      n:=tab.FieldAsInteger(0);
      if(n>nMax) then nMax:=n;
      s:=tab.FieldAsString(1);
      den:=StrToInt(Fetch(s,' '));
      hh:=StrToInt(s);
      a[den*24+hh]:=n;
      tab.Next();
    end;
  finally
    tab.free;
  end;
  //vytvorime vystupni tabulku
  sOld:=GlobalVarGet('StyleTableMatrix',false)
  sOld:=ReplaceString(sOld,'%Width%',IntToStr(iWidth));
  //zmenime velikost fontu, pokud je to potreba
  s:=aPar.Values['FontSize'];
  if(s<>'') then begin
    sOld:=RegexReplace('font-size[:]\s*\d+(px|%|em|pt)',sOld,'font-size:'+s+'px',false);
  end;
  Result:=Result+'<table style="'+sOld+'">'+CRLF;

//  sOld:=GlobalVarget('DayDay',false); //udelame svisly text
//  s:=sOld;
//  if bCond then begin //udelame svisly text
//    s:='';
//    for hh:=1 to Length(sOld) do begin
//      s:=s+'&nbsp;'+sOld[hh]+'&nbsp;<br />';
//    end;
//  end;
  //protoze sirka muze byt dana i primo v px, musime nahradit styl a v nem sirku,
  //jinak pri globalni nahrade je pouzita sirka cele statistiky
  Result:=Result
    +'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh1%">&nbsp;</th><th colspan=26 style="%StyleTableMatrixTh1%">%MiscHours%</th></tr>'+CRLF
    +'  <tr style="%StyleTableMatrixTr%">'
//    +'    <th rowspan=9 style="%StyleTableMatrixTh1Down%">'+s+'</th>'
    +'    <th style="%StyleTableMatrixTh2%">&nbsp;</th>'
    +'    <th style="%StyleTableMatrixTh2%">00</th><th style="%StyleTableMatrixTh2%">01</th>'
    +'    <th style="%StyleTableMatrixTh2%">02</th><th style="%StyleTableMatrixTh2%">03</th>'
    +'    <th style="%StyleTableMatrixTh2%">04</th><th style="%StyleTableMatrixTh2%">05</th>'
    +'    <th style="%StyleTableMatrixTh2%">06</th><th style="%StyleTableMatrixTh2%">07</th>'
    +'    <th style="%StyleTableMatrixTh2%">08</th><th style="%StyleTableMatrixTh2%">09</th>'
    +'    <th style="%StyleTableMatrixTh2%">10</th><th style="%StyleTableMatrixTh2%">11</th>'
    +'    <th style="%StyleTableMatrixTh2%">12</th><th style="%StyleTableMatrixTh2%">13</th>'
    +'    <th style="%StyleTableMatrixTh2%">14</th><th style="%StyleTableMatrixTh2%">15</th>'
    +'    <th style="%StyleTableMatrixTh2%">16</th><th style="%StyleTableMatrixTh2%">17</th>'
    +'    <th style="%StyleTableMatrixTh2%">18</th><th style="%StyleTableMatrixTh2%">19</th>'
    +'    <th style="%StyleTableMatrixTh2%">20</th><th style="%StyleTableMatrixTh2%">21</th>'
    +'    <th style="%StyleTableMatrixTh2%">22</th><th style="%StyleTableMatrixTh2%">23</th>'
    +'    <th style="%StyleTableMatrixTh2%">&sum;</th>'
    +'  </tr>'+CRLF;
  nMaxDen:=0;
  nMaxHod:=0;
  for den:=0 to 6 do begin
    nDay:=0;
    for hh:=0 to 23 do begin
      nDay:=nDay+a[den*24+hh];
      aDaySuma[hh]:=aDaySuma[hh]+a[den*24+hh];
      if(nMaxHod<aDaySuma[hh]) then nMaxHod:=aDaySuma[hh];
    end;
    aDaySuma[24]:=aDaySuma[24]+nDay;
    if(nMaxDen<nDay) then nMaxDen:=nDay;
  end;
  //ShowMessage('nMaxDen='+IntToStr(nMaxDen)+', nMaxHod='+IntToStr(nMaxHod));
  for den:=0 to 6 do begin
    nDay:=0;
    Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">%Day'+aDayName[den]+'%</th>'+CRLF;
    for hh:=0 to 23 do begin
      nDay:=nDay+a[den*24+hh];
      if(a[den*24+hh]=0) then Result:=Result+'<td style="%StyleTableMatrixTdEmpty%">&nbsp;</td>'+CRLF
      else begin
        if(a[den*24+hh]=nMax) and (GlobalVarGet('StyleTableMatrixTdMaxValueText',true)<>'') then begin
          Result:=Result+'    <td style="%StyleTableMatrixTdMaxValue% background:#'
            +ScaleColor(a[den*24+hh],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[den*24+hh])+'</td>'+CRLF;
        end
        else begin
          Result:=Result+'    <td style="%StyleTableMatrixTd% background:#'
            +ScaleColor(a[den*24+hh],0,nMax,GlobalVarGet('ColorTableScaleMinBkg',false),GlobalVarGet('ColorTableScaleAvgBkg',false),GlobalVarGet('ColorTableScaleMaxBkg',false))
            +'">'+IntToStr(a[den*24+hh])+'</td>'+CRLF;
        end;
      end;
    end;
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(nDay=nMaxDen) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(nDay)+'</th>'+CRLF+'  </tr>'+CRLF;
  end;
  //doplnime soucty za jednotlive hodiny
  Result:=Result+'  <tr style="%StyleTableMatrixTr%"><th style="%StyleTableMatrixTh2%">&sum;</th>'+CRLF;
  for hh:=0 to 24 do begin
    //ve stylu nahradime barvu textu za barvu maximalniho textu
    sStyle:=GlobalVarGet('StyleTableMatrixTh2',false);
    if(aDaySuma[hh]=nMaxHod) and (GlobalVarGet('StyleTableMatrixTh2Max',true)<>'')
      then sStyle:=GlobalVarGet('StyleTableMatrixTh2Max',false);
    Result:=Result+'    <th style="'+sStyle+'">'+IntToStr(aDaySuma[hh])+'</th>'+CRLF
  end;
  Result:=Result+'  </tr>'+CRLF;
  Result:=Result+'</table>'+CRLF;
  Output(Result);
  Result:='';
  s:=aPar.Values['TextBottom'];
  if(s<>'') then begin
    //zjistime pocet kombinaci
    n:=0;
    for den:=0 to 6 do begin
      for hh:=0 to 23 do begin
        if(a[den*24+hh]>0) then Inc(n);
      end;
    end;
    s:=ReplaceString(s,'%FoundCount%',IntToStr(n));
    s:=ReplaceString(s,'%AllCount%',IntToStr(7*24));
    Result:=Result+'%StyleTableBottomTextStartHtml%'+s+'%StyleTableBottomTextEndHtml%'+CRLF;
  end;
end;