function FindsByType_Run(aPar:TStringList):string;
var aTmpPar:TStringList;
    tab: TSqliteTable;
    s,s1,sSql,sType,sColumns,sPieDisp,sTableDisp,sID:string;
    sEData,sELabels:string;
    i:integer;
    bSwitch:boolean;
begin
  Result:='';
  s:=aPar.Values['OutputType'];
  sType:=Fetch(s,'-');
  bSwitch:=(aPar.Values['SwitchType']='Yes');
  sID:='ID'+IntToStr(iItem);
  if(sType='Table') then begin
    sPieDisp:='none'; sTableDisp:=''; 
  end else begin
    sPieDisp:=''; sTableDisp:='none';
  end;
  if bSwitch then
    aPar.Values['Title']:=aPar.Values['Title']+'&nbsp;'
        +'<button id="'+sID+'TableB" style="cursor:pointer; display:'+sTableDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'TableB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Table'').style.display=''none'';'
        +'document.getElementById('''+sID+'PieB'').style.display='''';'
        +'document.getElementById('''+sID+'Pie'').style.display='''';'
        +'" title="'+_('Switch to pie chart')+'">'
        +'<img src="%IconLayoutChartPie%"></button>'
        +'<button id="'+sID+'PieB" style="cursor:pointer; display:'+sPieDisp+'" '
        +'onclick="'
        +'document.getElementById('''+sID+'PieB'').style.display=''none'';'
        +'document.getElementById('''+sID+'Pie'').style.display=''none'';'
        +'document.getElementById('''+sID+'TableB'').style.display='''';'
        +'document.getElementById('''+sID+'Table'').style.display='''';'
        +'" title="'+_('Switch to histogram')+'">'
        +'<img src="%IconLayoutList%"></button>';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  
  aTmpPar:=TStringList.Create();
  try
    //pripravime parametry
    s1:=aPar.Values['SortBy'];
    s:=Fetch(s1,'-');
    if(s='Type') then sColumns:='Type icon|Type=Left;;;Cnt;Asc|Count|Percent|Histogram'
    else sColumns:='Type icon|Type=Left;;;Cnt|Count=;Desc|Percent|Histogram';
    aTmpPar.Text:='Columns='+sColumns+CRLF
                 +'FoundOnly=Yes'+CRLF
                 +'UseFilter='+aPar.Values['UseFilter']+CRLF
                 ;
    //vytvorime SQL
    sSql:=TableListMakeSqlFromParams(aTmpPar,true,'',i);
    aTmpPar.Text:='';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      while not tab.eof do begin
        aTmpPar.Add(tab.FieldAsString(0));
        aTmpPar.Add(tab.FieldAsString(1));
        aTmpPar.Add(tab.FieldAsString(2));
        aTmpPar.Add(tab.FieldAsString(3));
        aTmpPar.Add(tab.FieldAsString(4));
        //----------------data pro ECharts
        sELabels:=sELabels+tab.FieldAsString(1)+CRLF;
        sEData:=sEData+tab.FieldAsString(2)+CRLF;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //z nactenych dat vytvorime vystup
    if bSwitch then begin
      Result:=Result+'<div id="'+sID+'Table" style="display:'+sTableDisp+'">'
        +OutputTableList(sColumns,aTmpPar,0,-1,2,i)+'</div>'+CRLF;
      Result:=Result+'<div id="'+sID+'Pie" style="display:'+sPieDisp+'">'
      Output(Result);
      Result:=EChartsPieChart(sId+'PieGraf',sEData,sELabels,0,SetPieHeightDefault())+'</div>'+CRLF;
      Output(Result);
      Result:='';
    end else begin
      if(sType='Table') then Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i)+CRLF
      else begin
        Output(Result);
        Result:=EChartsPieChart(sId,sEData,sELabels,0,SetPieHeightDefault())+CRLF;
        Output(Result);
        Result:='';
      end;
    end;
  finally
    aTmpPar.Free();
  end;
end;
