function GeoPuzzle_Run(aPar:TStringList):string;
var s:string;
    dt:TDateTime;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  s:=aPar.Values['Puzzles'];
  if(s='') then begin
    Log(_('ERR: GeoPuzzles - no puzzle selected.'));
    exit;
  end;
  //otestujeme existenci pluginu
  if(FileExists(GEOGET_Scriptdir+'\GeoPuzzle\GeoPuzzle.ggp.pas')) then begin
    //pred spustenim pluginu otestujeme, zda pozadovany soubor je zastaraly
    dt:=GetFileTime(GEOGET_Scriptdir+'\GeoPuzzle\GeoPuzzle_'+Fetch(s,'|')+'.html');
    //spustime generovani jen pokud soubor je starsi nez 1 hodinu
    if(Now()-dt>(1./24.)) then GeoCallGGP(GEOGET_Scriptdir+'\GeoPuzzle\GeoPuzzle.ggp.pas');
    //do vystupu zaradime postupne vsechny
    s:=aPar.Values['Puzzles'];
    while (s<>'') do begin
      Result:=Result+FileToString(GEOGET_Scriptdir+'\GeoPuzzle\GeoPuzzle_'+Fetch(s,'|')+'.html')+CRLF;
    end;
  end
  else begin
    ShowHTMLMessage('Error - GeoPuzzle',
    '<a href="https://www.geoget.cz/doku.php/user:skript:geopuzzle#automaticka_instalace" target="_blank">'
    +_('Install missing plugin for GeoPuzzle')+'</a><br /><br />'
    +_('If you click on the URL and then on automatic installation, GeoPuzzles plugin will be installed after closing Stator.')
    );
  end;
end;