function Milestones_Run(aPar:TStringList):string;
var s,sStep,sOd,sDo,sSql,sCols:string;
    i,nCols,nRows:integer;
    tab: TSqliteTable;
    a,aData:TStringList;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  aData:=TStringList.Create();
  aData.Add('1');
  a:=TStringList.Create();
  s:=aPar.Values['Step'];
  while (s<>'') do begin
    sStep:=Fetch(s,'|');
    sOd:=Fetch(sStep,'-');
    sDo:=Fetch(sStep,',');
    //tohle by se asi nemuselo delat pres databazi! (ale je tu snadny vypocet
    //a pripadne jednoducha zmena na vraceni ID pro ladeni a kontrolu)
    sSql:='SELECT rowid FROM '+TEMP_TABLE+' WHERE rowid>='+sOd;
    //sSql:='SELECT id FROM '+TEMP_TABLE+' WHERE rowid>='+sOd;
    //kdyz neni posledni interval, pouzijeme i horni mez
    if(s<>'') then sSql:=sSql++' AND rowid<='+sDo;
    sSql:=sSql+' AND (rowid % '+sStep+')=0';  //a pridame modulo
    //sestavime SQL pro nalezeni milniku podle kroku
    Geoget_DB.GetTableStrings(sSql,a);
    aData.Text:=Trim(aData.Text)+CRLF+a.Text;
  end;
  s:=aPar.Values['Serial'];
  if(s<>'') then begin
    s:=ReplaceString(ReplaceString(s,' ',''),',',CRLF);
    aData.Text:=aData.Text+CRLF+s;
  end;
  //pridame kese podle ID
  s:=aPar.Values['GcId'];
  if(s<>'') then begin
    //prevedeme do formatu pro IN
    s:='"'+ReplaceString(ReplaceString(s,' ',''),',','","')+'"';
    sSql:='SELECT rowid FROM '+TEMP_TABLE+' WHERE id IN ('+s+')';
    Geoget_DB.GetTableStrings(sSql,a);
    aData.Text:=aData.Text+CRLF+Trim(a.Text);
  end;
  //pokud prvni sloupec neni milnik, doplnime ho tam
  sCols:=aPar.Values['Columns'];
  if(not RegexFind('^Milestone\s*[=;,\(\|]',sCols)) then begin
    sCols:='Milestone|'+sCols;
  end;
  //pokud je to uzivatelem pozadovano, pridame i posledni nalez
  Log('AddLastFound='+aPar.Values['AddLastFound']);
  if(aPar.Values['AddLastFound']='Yes') then aData.Add(GlobalVarReplace('%FoundCachesCount%'));

  //vytvorime parametry pro sestaveni SQL
  a.Clear();
  a.Add('FoundOnly=Yes');          //jen nalezene
  a.Add('Columns='+sCols);

  aData.Text:=ReplaceString(aData.Text,CRLF+CRLF,CRLF); //vyhodit prazdne radky
  s:='"'+ReplaceString(Trim(aData.Text),CRLF,'","')+'"'; //format pro LIKE
  //sestavime select pro pozadovane sloupce
  sSql:=TableListMakeSqlFromParams(a,true,'',i);
  //frazi WHERE doplnime o vyber poradi
  sSql:=ReplaceString(sSql,'WHERE','WHERE st.rowid IN ('+s+') AND');
  aData.Clear();
  nRows:=0;
  tab:=Geoget_DB.GetTable(sSql,false);
  try
{$ifdef DEBUG_HELPER}
  LDH('VVVVVV cteni radku tabulky');
{$endif}
    nCols:=tab.ColCount;
    while (not tab.Eof) do begin
      Inc(nRows);
      for i:=0 to nCols-1 do begin
        aData.Add(tab.FieldAsString(i));
  //Log('aData('+IntToStr(i+')='+tab.FieldAsString(i));
      end;
      tab.Next();
    end;
{$ifdef DEBUG_HELPER}
  LDH('VVVVVV nacteno '+IntToStr(nRows)+ ' radku');
{$endif}
  finally
    tab.Free();
  end;
  dtMilestoneLastFound:=0; //vynulovat posledni nalezeny milnik
{$ifdef DEBUG_HELPER}
  LDH('VVVVVV zapis do vystupu 1');
{$endif}
  Result:=Result+OutputTableList(sCols,aData,0,nRows,-1,i)+CRLF;
  if(a<>nil) then a.Free();
  if(aData<>nil) then aData.Free();
{$ifdef DEBUG_HELPER}
  LDH('VVVVVV navrat');
{$endif}
end;