function MyOwnBySize_Run(aPar:TStringList):string;
var aTmpPar:TStringList;
    tab: TSqliteTable;
    s,s1,sSql,sType,sColumns:string;
    sEData,sELabels:string;
    i:integer;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  aTmpPar:=TStringList.Create();
  try
    //pripravime parametry
    s:=aPar.Values['OutputType'];
    sType:=Fetch(s,'-');
    s1:=aPar.Values['SortBy'];
    s:=Fetch(s1,'-');
    if(s='Size') then sColumns:='Size icon|Size as num=Center;Cnt;Asc|Count=Center|Percent|Histogram|SizeNum=Hide'
    else sColumns:='Size icon|Size=Center;Cnt|Count=Center;Desc|Percent|Histogram|SizeNum=Hide';
    sSql:='SELECT cachesize "Size icon", cachesize "Size=Left;;;Cnt;Asc", count(cachesize) "Count=Center",0 "Percent", 0 "Histogram"'
         +', CASE (cachesize) '
         +'WHEN "Not chosen" THEN "0 Not chosen" '
         +'WHEN "Micro" THEN "1 Micro" '
         +'WHEN "Small" THEN "2 Small" '
         +'WHEN "Regular" THEN "3 Regular" '
         +'WHEN "Large" THEN "4 Large" '
         +'WHEN "Virtual" THEN "5 Virtual" '
         +'WHEN "Other" THEN "6 Other" '
         +'ELSE  "7 Unknown" '
         +'END SizeNum'
         +' FROM geocache WHERE id IN ('+GlobalVarGet('OwnedIDsForInPhrase',false)+')'
         +' GROUP BY cachesize';
    if(s='Size') then sSql:=sSql+' ORDER BY SizeNum asc'
    else sSql:=sSql+' ORDER BY count(cachesize) desc, SizeNum asc';
    aTmpPar.Text:='';
    tab:=Geoget_DB.GetTable(sSql, false);
    try
      while not tab.eof do begin
        if(sType='Table') then begin //pridame vsechny polozky
          aTmpPar.Add(tab.FieldAsString(0));
          aTmpPar.Add(tab.FieldAsString(1));
          aTmpPar.Add(tab.FieldAsString(2));
          aTmpPar.Add(tab.FieldAsString(3));
          aTmpPar.Add(tab.FieldAsString(4));
          aTmpPar.Add(tab.FieldAsString(5));
        end
        else begin //pro kolacovy graf pridavame jen pocet a label
          s:=tab.FieldAsString(1);
          //pokud je na zacatku cislo, musime jej odstranit, pocor na viceslovny vyraz 'Not chosen'
          if(s[1]>='0') and (s1<='9') then begin
            s1:=Fetch(s,' ');
            if(s='') then s:=s1;
          end;
          sELabels:=sELabels+s+CRLF;
          sEData:=sEData+tab.FieldAsString(2)+CRLF;
        end;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
    //z nactenych dat vytvorime vystup
    if(sType='Table') then Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,2,i)+CRLF
    else begin
           Output(Result);
           Result:=EChartsPieChart('ID'+IntToStr(iItem),sEData,sELabels,0,SetPieHeightDefault())+CRLF;
           Output(Result);
           Result:='';
         end;
  finally
    aTmpPar.Free();
  end;
end;
