function SummaryByTypeInCountry_Run(aPar:TStringList):string;
var aTmpPar,aTypes:TStringList;
    tab: TSqliteTable;
    sSort,sSql,sColumns,s:string;
    i:integer;
    nTypes:array[0..100] of integer;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  sSql:=aPar.Values['OrderBy'];
  sSort:=Fetch(sSql,'-');
  aTmpPar:=TStringList.Create();
  try
    aTypes:=TStringList.Create();
    try
      //zjistime seznam typu kesi v databazi, abychom mohli sestavit spravny SQL
      sSql:='SELECT cachetype FROM geocache gc WHERE dtfound>0 '
        +'AND '+sCachePrefixForSql+SetSqlFilter(aPar)
        +' GROUP BY cachetype ORDER BY count(cachetype) desc';
      Geoget_DB.GetTableStrings(sSql,aTypes);
{$ifdef DEBUG_HELPER} LDH('LLLL 1');{$endif}
      //vytvorime SQL a zaroven seznam sloupcu tak, aby se jmena typu kesi nahradily ikonami
      sSql:='SELECT country';
      //sColumns:='Country flag|Country';
      sColumns:='Country flag, text';
      for i:=0 to aTypes.Count-1 do begin
        sSql:=sSql+CRLF+'  ,sum(case when cachetype='''+aTypes[i]+''' then 1 else 0 end) as '''+aTypes[i]+'''';
        sColumns:=sColumns+'|<img src&eq;"%IconCacheTypeSmall'+aTypes[i]+'%" title&eq;"'+aTypes[i]+'" />=Center';
      end;
{$ifdef DEBUG_HELPER} LDH('LLLL 2');{$endif}
      sColumns:=sColumns+'|&sum;=Right';
      sSql:=sSql+CRLF+'  ,count(country)'+CRLF
        +'FROM geocache gc WHERE dtfound>0 '
        +'AND '+sCachePrefixForSql+SetSqlFilter(aPar)
        +' GROUP BY country ORDER BY ';
      if(sSort<>'Country') then sSql:=sSql+'count(country) desc, ';
      sSql:=sSql+'country';
      aTmpPar.Text:='';
      Log('SQL='+sSql);
{$ifdef DEBUG_HELPER} LDH('LLLL 3');{$endif}
      tab:=Geoget_DB.GetTable(sSql, false);
      try
        while not tab.eof do begin
          aTmpPar.Add(tab.FieldAsString(0)); //stat
          for i:=1 to aTypes.Count do begin
{$ifdef DEBUG_HELPER} LDH('LLLL 4 i='+InTToStr(i));{$endif}
            s:=tab.FieldAsString(i); //pocty nalezu jednotlivych typu
            if(s='0') then 
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+' (gray)%" />')
            else begin
              aTmpPar.Add('<img src="%IconCacheTypeSmall'+aTypes[i-1]+'%" title="'+s+' x" />');
              //pocitame celkove soucty za typ kese
              nTypes[i-1]:=nTypes[i-1]+StrToInt(s);
              nTypes[aTypes.Count]:=nTypes[aTypes.Count]+StrToInt(s);
            end;
          end;
          aTmpPar.Add('<b>'+tab.FieldAsString(i)+'</b>');  //soucet nalezu za stat
          tab.Next();
        end;
      finally
        tab.Free();
      end;
      //pridame celkove pocty typu kesi
      //aTmpPar.Add(''); //vlajka
      aTmpPar.Add(CONST_NOICON+'<b>&sum;</b>'); //misto statu je suma a priznak, aby se nepravadela do ikony
      for i:=0 to aTypes.Count do begin
        aTmpPar.Add('<b>'+IntToStr(nTypes[i])+'</b>');
      end;
      Result:=Result+OutputTableList(sColumns,aTmpPar,0,-1,-1,i);
    finally
      aTypes.Free();
    end;
  finally
    aTmpPar.Free();
  end;
end;
