// asov ada msnch nlez

function TimelineMonthly_Run(aPar:TStringList):string;
var tab: TSqliteTable;
    iY,iM,iMax,iYearMin,iYearMax,iMonthMin,iMonthMax:integer;
    iHeightGr:integer;
    s,ss,sData,sSql{,sT}:string;
    sEData,sENames:string;
    aData:TStringList;
begin
  // rozmry a parametry grafu
  iHeightGr:=250;                             // vka grafu

  // pprava dat pro graf
  aData:=TStringList.Create();
  sSql:='SELECT dtfound/100 YearMonth, count(*) Count FROM geocache gc WHERE gc.dtfound>0 AND '
  +sCachePrefixForSql+SetSqlFilter(aPar)+' GROUP BY YearMonth';
  tab:=Geoget_DB.GetTable(sSql,false);
  try
    while not tab.eof do begin
      s:=tab.FieldByName['YearMonth'];
      iYearMax:=StrToInt(Copy(s,1,4));
      iMonthMax:=StrToInt(Copy(s,5,2));
      s:=IntToStr(iYearMax)+IntToStr(iMonthMax);
      if iYearMin=0 then iYearMin:=iYearMax;
      if iMonthMin=0 then iMonthMin:=iMonthMax;
      ss:=tab.FieldByName['Count'];
      if StrToInt(ss)>iMax then iMax:=StrToInt(ss);
      aData.Add(s+'='+ss);
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  // generovn datovch ad a popis
  iY:=iYearMin;
  iM:=iMonthMin;
  while true do begin
    s:=aData.Values[IntToStr(iY)+IntToStr(iM)];
    if s='' then s:='0';
    sEData:=sEData+s+CRLF;
    sENames:=sENames+IntToStr(iM)+'/'+IntToStr(iY)+CRLF;
    if(sData='') then sData:=s else sData:=sData+','+s;
    Inc(iM);
    if iM>12 then begin
      iM:=1;
      Inc(iY);
    end;
    if ((iY=iYearMax) and (iM>iMonthMax)) or (iY>iYearMax) then break;
  end;

  // finln akce
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Output(Result);
  //upravime typ grafu
  Result:=EChartsBarChart('ID'+IntToStr(iItem),sEData,sENames,'',
    +_('Finds in month<br/>{b}: {c}'),false,true,iWidth,250);
  s:=aPar.Values['GraphType'];
  if(Fetch(s,'-')='Line') then Result:=ReplaceString(Result,'type:''bar'',','type:''line'',');
  Output(Result);
  Result:='';
  // klid
  if(aData<>nil) then aData.Free();
end;