//hlavni funkce modulu
function WayTo81_Run(aPar:TStringList):string;
var
  // postupne nejak pretridit
  s,sSql,sColumns,sIdElement,sTableBlock,sTableLabel,sPartTableLabel,sShowStyle:string;
  sTableLabelConfig:string;
  sButtonId, sButtonBlock:string; 
  i,nRest,nCols,nRows,idxDt,dtColumnIndex,countOfDtTables,paramCountOfDtTables,actualList:integer;
  aData,dtData,frameParams:TStringList;
  aDtData,dataUsedDt:array of TStringList;
  nRowData:array of integer;
  tab: TSqliteTable;
	bExpanded{,bShowTable},bTemp: Boolean;
begin

    
  s:='SELECT GC.dtfound as `Found date=Right`'+
  + ', GC.id||";"||GC.cachetype||";"||GC.cachestatus||";"||GC.country||";"||GC.name as `Cache info`'
  + ', ((printf("%.1f",GC.difficulty))||"/"||(printf("%.1f",GC.terrain))) as `D/T=Center`'
  + ', GC.difficulty as `Difficulty=Hide`'
  + ', GC.terrain as `Terrain=Hide`'
  + ' FROM ( SELECT rowid,id FROM '+TEMP_TABLE+' ORDER BY rowid ASC) as TEMP,'
  +'   (SELECT * FROM geocache) as GC WHERE TEMP.id=GC.id '+SetSqlFilter(aPar)+'ORDER BY GC.dtfound ASC';
  
  sSql  := ReplaceString(s,'%CRLF%',CRLF);
  tab   := Geoget_DB.GetTable(sSql, false);
  nCols := tab.ColCount;
  nRows := 0;
  
  try
		while (not tab.Eof) do begin
		  Inc(nRows);
	    tab.Next();
	  end;
	finally
		tab.Free();
	end;
	
  sSql  := ReplaceString(s,'%CRLF%',CRLF);
  tab   := Geoget_DB.GetTable(sSql, false);

  Result        :='';
  sButtonBlock  := '';
  
  if(aPar.Values['Title']<>'')      then Result           :=Result+ProcessCommand('CmdTitle',aPar);
  if(aPar.Values['TableLabel']<>'') then sTableLabelConfig:=aPar.Values['TableLabel'];
	
	//pocet DT tabulek pro zobrazeni
  sSql                := aPar.Values['CountOfDtTables'];
  s                   := Fetch(sSql,'-');
  countOfDtTables     := StrToInt(s);
  paramCountOfDtTables:= countOfDtTables;
  
  s                   := aPar.Values['ShowStyle'];
  sShowStyle          := UpperCase(Fetch(s,'-'));
  bExpanded		        := aPar.Values['Expanded'] = 'Yes';
  
  //pokud neni zadan pocet tabulek, tak vem pocet radku (nikdy neni jasne, kde jsou vsechny kombinace)
  if paramCountOfDtTables = 0 then countOfDtTables := Round((nRows/81)) + 1; // (pocet nalezu/81) + 1 je preci MAX pocet tabulek
 
  try
    aData   := TStringList.Create;
    dtData  := TStringList.Create;
    
    //sloupec s DT informaci je na 2, tedy prvni ve vysledku SQL
    dtColumnIndex := 2;
     
    //priprav prostor pro doplnovani DT moznosti  
    for actualList := 0 to countOfDtTables - 1 do begin
      //nejdriv priprav data pro vyslednou tabulku
      Setlength(aDtData, length(aDtData)+1);
      aDtData[actualList] := TStringList.Create;
      
      //pak pouzite DT kombinace v jednotlivych datech tabulky
      Setlength(dataUsedDt, length(dataUsedDt)+1);
      dataUsedDt[actualList] := TStringList.Create;
      
      //nastavit si i pocty radku v data tabulce
      Setlength(nRowData, length(nRowData)+1);
      nRowData[actualList] :=0;
    end; // end FOR
    
    
    //zjistime jmena sloupcu
    
    sColumns  := '#|'; // prvni je poradi, ktere v SQL neni
    for i :=0 to nCols-1 do begin
      sColumns := sColumns+tab.Columns[i]+'|';
    end; 
    
    while (not tab.Eof) do begin
      //najdi, kde jeste kombinace neni
      for actualList :=0 to countOfDtTables - 1 do begin
        
        idxDt := dataUsedDt[actualList].IndexOf(tab.FieldAsString(dtColumnIndex));
        if idxDt < 0  then 
        begin
          Inc(nRowData[actualList]);
          dataUsedDt[actualList].Add(tab.FieldAsString(dtColumnIndex)); // pridej do pozitych/zobrazenych DT kombinaci at se priste preskoci;
          aDtData[actualList].Add(IntToStr(nRowData[actualList])); // pridej na prvni misto poradi, neni to SQL sloupec
          
          for i := 0 to nCols-1 do begin
              aDtData[actualList].Add(tab.FieldAsString(i));   
          end;
          //Ukonci, kombinace pridana
          Break;
        end; // end IF
      end; // end FOR
      tab.Next();
    end; // end WHILE
 
  finally
      if(tab<>nil) then tab.Free();
  end;
  
  //univerzalni bool flag, netreba jich definovat milion preci
  // pokud mam uz jeden nekompletni, tak ostatni vynuluj a ony se nezobrazi
  bTemp := True;
  
  //pokud neni definovany pocet tabulek, tak najdi jen ty komplet + prvni nekompletni
  if paramCountOfDtTables = 0 then
  begin
    for actualList := 0 to length(nRowData) - 1 do begin
      //pokud neni kompletni, tak ...
      if nRowData[actualList] < 81 then 
        begin
          // ... bylo uz pouzita nekompletni tabulka ... pak tahle nema nic, nezobrazi se
          if not bTemp then nRowData[actualList] := 0;
          bTemp := False; // nastav, ze uz dale ne, tim padem bude nulovat vse nasledujici
        end; // end IF BEGIN
    end; // end FOR
  end; // end IF
  
  
  // --------------------------------------
  //          a zaciname generovat   
  // --------------------------------------
  
  sIdElement := GlobalVarGet('IdElement',false);
  SaveWidth('Frame');
  
  //zobraz co uz mas
  Output(Result);
  Result := '';
  
  for actualList := 0 to length(nRowData) - 1 do begin
  
    //zobraz jen ty seznamy, ktere maji vice nez nula polozek
    if nRowData[actualList] > 0 then
    begin
      GlobalVarSet('IdElement',sIdElement+'part'+IntToStr(actualList));
      
      sPartTableLabel := '';
      sTableLabel := '';
      sTableBlock := '';
      
      if sTableLabelConfig <> '' then
      begin
        sTableLabel := ReplaceString(sTableLabelConfig,'%WayTo81TableNum%'        , IntToStr(actualList+1));
        sTableLabel := ReplaceString(sTableLabel      ,'%WayTo81Count%'           , IntToStr(nRowData[actualList]));  
        sTableLabel := ReplaceString(sTableLabel      ,'%WayTo81PercentComplete%' , FlToStr(Round((((nRowData[actualList])*100.00)/81)*10)/10.0)+' %');
      end; // end IF
      
      case sShowStyle of
        'BUTTONS': 
          begin
            //do sButtonBlock nasbirej HTMLko pro tlacitka
            sButtonId := 'b'+GlobalVarGet('IdElement',false);
            sButtonBlock := sButtonBlock + '<button id="' + sButtonId + '" style="cursor:pointer; margin:2px 2px 5px 2px; ';
            if bExpanded then sButtonBlock := sButtonBlock + 'font-weight:bold; " ' else sButtonBlock := sButtonBlock+'font-weight:normal;" ';
            sButtonBlock := sButtonBlock+'onclick="'
                  +'document.getElementById('''+ GlobalVarGet('IdElement',false) + ''').style.display=(getElementById('''+GlobalVarGet('IdElement',false)+''').style.display!=''none''?''none'':'''');'
                  +'document.getElementById('''+ sButtonId + ''').style.fontWeight=(getElementById(''' + GlobalVarGet('IdElement',false) + ''').style.display!=''none''?''bold'':''normal'');'
                  +'return false;">' + sTableLabel + '</button>' + CRLF;
            //end sbirani button HTML

            //do vysledku pridej tabulku vysledku zapakovanou v DIVu     
            Result := Result + '<div id="'+GlobalVarGet('IdElement',false)+'" style=" padding-top: 20px; padding; margin: 8px;';
            if bExpanded then Result := Result + 'display:;' else Result := Result + 'display:none;';
            Result := Result + '">'+CRLF;
            
            //nafejkuj nadpis tabulky
            Result := Result + '<div style="font-size:12px; background-color:#%ColorTableListHeaderBkg%; color:#%ColorTableListHeaderText%; text-align:center; font-weight:bold; padding:4px; margin-bottom:4px; border-top:1px solid #A0A0A0;">' + CRLF;
            Result := Result + sTableLabel + '</div>' + CRLF;
            
            Result := Result + OutputTableList(sColumns,aDtData[actualList],0,-1,1,nRest) + CRLF;
            Result := Result + '</div>'+CRLF;
          end;  // end BEGIN
         
        'FRAMES':
          begin
            frameParams := TStringList.Create();
            frameParams.Values['Title'] := sTableLabel;        
            
            if bExpanded then
              frameParams.Values['Open'] := 'Yes'					//Oteven
            else
              frameParams.Values['Open'] := 'No';			  //Zaven
            
            sTableBlock := sTableBlock + ProcessFrameStart(GlobalVarGet('IdElement',false), frameParams) + CRLF;
            sTableBlock := sTableBlock + OutputTableList(sColumns,aDtData[actualList],0,-1,1,nRest) + CRLF;
            sTableBlock := sTableBlock + ProcessFrameEnd() + CRLF;
            frameParams.Free();
            
            //nutno vyhodit vysledek hned, ID a spol je nutne ted vygenerovat a replacnout, jinak to nefunguje, ale zamerne
            Output(sTableBlock);
         end; // end BEGIN
       end; // end CASE
      
      //zahod data po jedne tabulce
      aDtData[actualList].Free();
      dataUsedDt[actualList].Free();
   
      GlobalVarSet('IdElement',sIdElement); 
    end; // end IF
  end; // end FOR
  
  //pridej uplne na zacatek zobrazeni tlacitek
  if sButtonBlock <> '' then Result := '<div style="text-align:center; ">' + sButtonBlock + '</div>' + Result;
  
  RestoreWidth('Frame');

end;